package com.bettersoft.api.controllers;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.bettersoft.api.utils.LoginUserInfo;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.bettersoft.api.service.interfaces.IDashboardService;
import com.bettersoft.api.utils.JsonResult;

import java.util.Date;

@RestController
@RequestMapping(value = "/dashboard")
public class DashboardController extends BaseController {
    @Resource(name = "dashboardService")
    private IDashboardService dashboardService;

    /**
     * 后台管理系统使用，获取可支配店铺
     * @param request
     * @param response
     * @throws Exception
     */
    @RequestMapping(value = "/initParam", method = RequestMethod.POST)
    public void initParam(HttpServletRequest request,
                          HttpServletResponse response) throws Exception {
        JsonResult jsonResult = new JsonResult();
        try {
            jsonResult.getData().putAll(dashboardService.initParam(getLoginUser(request)));
            jsonResult.setSuccess(true);
        } catch (Exception ex) {
            jsonResult.setSuccess(false);
            jsonResult.setErrMsg("系统错误，请与系统管理员联系！");
            logger.error("dashboard/initParam error.", ex);
        } finally {
            renderResponse(jsonResult, response);
        }
    }

    /**
     * 后台管理系统使用，首页数据
     * @param storeCode
     * @param request
     * @param response
     * @throws Exception
     */
    @RequestMapping(value = "/reportData", method = RequestMethod.POST)
    public void reportData(String storeCode, HttpServletRequest request,
                           HttpServletResponse response, String date) throws Exception {
        JsonResult jsonResult = new JsonResult();
        try {
            jsonResult.getData().putAll(dashboardService.reportData(storeCode,date));
            jsonResult.setSuccess(true);
        } catch (Exception ex) {
            jsonResult.setSuccess(false);
            jsonResult.setErrMsg("系统错误，请与系统管理员联系！");
            logger.error("dashboard/reportData error.", ex);
        } finally {
            renderResponse(jsonResult, response);
        }
    }
}
