package com.bettersoft.api.dao.implement;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.bettersoft.api.model.LoginUserToken;
import com.bettersoft.api.model.SystemUserStoreBean;
import org.springframework.stereotype.Repository;

import com.bettersoft.api.dao.interfaces.IAuthorizationDao;
import com.bettersoft.api.model.MenuTreeBean;

@Repository("authorizationDao")
public class AuthorizationDao extends BaseDao implements IAuthorizationDao {

    public List<MenuTreeBean> searchMenuTrees(Map<String, Object> queryParam)
            throws Exception {
        String fromHql = "from MenuTreeBean";

        return this.generalSearch(fromHql, queryParam, "order by priority");
    }

    public LoginUserToken findLoginToken(String token) throws Exception {
        String fromHql = "from LoginUserToken";
        Map<String, Object> queryParam = new HashMap<String, Object>();
        queryParam.put("token", token);

        List<LoginUserToken> tokens = this.generalSearch(fromHql, queryParam, null);
        return null != tokens && !tokens.isEmpty() ? tokens.get(0) : null;
    }

    public LoginUserToken findLoginTokenByRefresh(String refreshToken) throws Exception {
        String fromHql = "from LoginUserToken";
        Map<String, Object> queryParam = new HashMap<String, Object>();
        queryParam.put("refreshToken", refreshToken);

        List<LoginUserToken> tokens = this.generalSearch(fromHql, queryParam, null);
        return null != tokens && !tokens.isEmpty() ? tokens.get(0) : null;
    }

    public List<SystemUserStoreBean> searchAuthStores(String userCode) throws Exception {
        String fromHql = "from SystemUserStoreBean";
        Map<String, Object> queryParam = new HashMap<String, Object>();
        queryParam.put("userCode", userCode);

        return this.generalSearch(fromHql, queryParam, "order by storeCode");
    }
}
