package com.bettersoft.api.dao.implement;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Repository;

import com.bettersoft.api.dao.interfaces.IOnlineorderdDao;
import com.bettersoft.api.model.OnlineorderdBean;

@Repository("onlineorderdDao")
public class OnlineorderdDao extends BaseDao implements IOnlineorderdDao {
    public List<Map<String, Object>> searchList(Map<String, Object> queryParam) throws Exception {
        String fromHql = "select new map (brandcode as brandcode, orderno as orderno, suborderno as suborderno, line as line,"
                + "linetype as linetype, pname as pname, pmodify as pmodify, qty as qty, price as price,"
                + "discountcode as discountcode, discountamount as discountamount, discountname as discountname, "
                + "amount as amount, amountafterdiscount as amountafterdiscount, suborderstatus as suborderstatus,"
                + "remark as remark, orderfrom as orderfrom, to_char(dtorder,'YYYY-MM-DD HH24:MI:SS') as dtorder, "
                + "dtconfirm as dtconfirm, confirmuser as confirmuser,intitemno as intitemno) from OnlineorderdBean";
        return this.generalSearch(fromHql, queryParam, "order by suborderno,line");
    }

    public Number searchCount(Map<String, Object> queryParam) throws Exception {
        String fromHql = "from OnlineorderdBean";
        return this.generalCount(fromHql, queryParam);
    }

    public OnlineorderdBean findOrderDetail(String orderNo, int line, int suborderno) throws Exception {
        String fromHql = "from OnlineorderdBean";
        Map<String, Object> queryParam = new HashMap<String, Object>();
        queryParam.put("orderno", orderNo);
        queryParam.put("line", line);
        queryParam.put("suborderno", suborderno);
        List<OnlineorderdBean> details = this.generalSearch(fromHql, queryParam, null);
        if (null != details && !details.isEmpty()) {
            return details.get(0);
        }

        return null;
    }

    public Map<String, Object> getTotal(String orderno) throws Exception {
        Map<String, Object> rs = new HashMap<String, Object>();
        String fromHql = "select new map(sum(qty) as totalQry, sum(amount) as totalPrice) from OnlineorderdBean ";
        List<Map<String, Object>> list = this.generalSearch(fromHql + "where orderfrom=0 and orderno='" + orderno + "' group by orderfrom ", null, null);
        if (null != list && list.size() > 0) {
            Map<String, Object> map = list.get(0);
            rs.put("onlineTotalQry", map.get("totalQry"));
            rs.put("onlineTotalPrice", map.get("totalPrice"));
        }
        list = this.generalSearch(fromHql + "where orderfrom=1 and orderno='" + orderno + "' group by orderfrom ", null, null);
        if (null != list && list.size() > 0) {
            Map<String, Object> map = list.get(0);
            rs.put("outlineTotalQry", map.get("totalQry"));
            rs.put("outlineTotalPrice", map.get("totalPrice"));
        }
        return rs;
    }

    public void updateOrderDetailSubOrderStatus(String orderNo, int line, int suborderno, int subStatus) throws Exception {
        String updateHql = "update OnlineorderdBean set suborderstatus = " + subStatus + ",dtconfirm = now(), confirmuser = 'SYSTEM' where orderno = '" + orderNo + "' and suborderno = " + suborderno + " and line = " + line;

        this.executeByHql(updateHql, null);
    }
}
