package com.bettersoft.api.dao.implement;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.bettersoft.api.model.Entity.OnlineorderpList;
import com.bettersoft.api.model.OnlineItemBean;
import com.bettersoft.api.model.OnlinePrepayBean;
import com.bettersoft.api.model.OnlineorderdBean;
import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang.StringUtils;
import org.hibernate.Query;
import org.hibernate.SQLQuery;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.transform.Transformers;
import org.springframework.stereotype.Repository;

import com.bettersoft.api.dao.interfaces.IOnlineorderhDao;
import com.bettersoft.api.model.OnlineorderhBean;
import com.bettersoft.api.utils.Constants;

import javax.annotation.Resource;

@Repository("onlineorderhDao")
public class OnlineorderhDao extends BaseDao implements IOnlineorderhDao {

    public List<OnlineorderhBean> searchList(Map<String, Object> queryParam) throws Exception {
        String fromHql = "from OnlineorderhBean";
        return this.generalSearch(fromHql, queryParam, MapUtils.getString(queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
    }

    public Number searchCount(Map<String, Object> queryParam) throws Exception {
        String fromHql = "from OnlineorderhBean";
        return this.generalCount(fromHql, queryParam);
    }

    public List<OnlineorderdBean> searchOrderDetails(Map<String, Object> queryParam) throws Exception {
        String fromHql = "from OnlineorderdBean";

        return this.generalSearch(fromHql, queryParam, MapUtils.getString(queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
    }

    public boolean isOrderSettle(String storeCode, String tableCode) throws Exception {
        Map<String, Object> queryParam = new HashMap<String, Object>();
        queryParam.put("strstorecode", storeCode);
        queryParam.put("tablecode", tableCode);
        queryParam.put(Constants.QUERY_SPEC_CONDITION + "creatDate", "to_char(creatDate, 'yyyyMMdd')=to_char(now(), 'yyyyMMdd')");
        queryParam.put(Constants.QUERY_LESS + "status", 3);
        queryParam.put(Constants.QUERY_ORDER_BY, "order by creatDate desc");
        List<OnlineorderhBean> unsettles = searchList(queryParam);

        return null == unsettles || unsettles.isEmpty();
    }

    public OnlineorderhBean findLastOnlineOrder(String storeCode, String tableCode) throws Exception {
        String fromHql = "from OnlineorderhBean where strstorecode='" + storeCode + "' and tablecode='" + tableCode + "' and status < 3 and to_char(creatDate, 'yyyyMMdd')=to_char(now(), 'yyyyMMdd')";
        List<OnlineorderhBean> list = this.generalSearch(fromHql, null, "order by creatDate desc");
        if (null != list && list.size() > 0)
            return list.get(0);
        else
            return null;
    }

    public OnlineItemBean findOnlineItem(String storeCode, int itemId) throws Exception {
        String hql = "from OnlineItemBean";
        Map<String, Object> queryParam = new HashMap<String, Object>();
        queryParam.put("strstorecode", storeCode);
        queryParam.put("intitemno", itemId);
        List<OnlineItemBean> list = this.generalSearch(hql, queryParam, null);
        if (null != list && !list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    public int getDaysn(String storeCode) throws Exception {
        String fromHql = "from OnlineorderhBean where to_char(creatDate, 'YYYY-MM-DD')=to_char(now(), 'YYYY-MM-DD')";
        Map<String, Object> queryParam = new HashMap<String, Object>();
        queryParam.put("strstorecode", storeCode);
        Number count = this.generalCount(fromHql, queryParam);
        if (null != count)
            return count.intValue() + 1;
        return 1;
    }

    public int getSubOrderNo(String orderNo) throws Exception {
        String fromHql = "select suborderno from Onlineorderd where orderno ='" + orderNo + "'";
        List<Map<String, Integer>> list = this.generalSearchBySql(fromHql, null, "order by suborderno desc");
        if (null != list && list.size() > 0)
            return list.get(0).get("suborderno") + 1;
        else
            return 1;
    }

    public int getMaxLineNo(String orderNo) throws Exception {
        String fromSql = "select COALESCE(MAX(line), 0) as lineno from onlineorderd where orderno='" + orderNo + "'";
        List<Map<String, Object>> result = this.generalSearchBySql(fromSql, null, null);

        return null != result && !result.isEmpty() ? MapUtils.getIntValue(result.get(0), "lineno", 0) : 0;
    }

    public String getItemType(int itemId) throws Exception {
        String lineType = "I";
        String sql = "select ysnSetMeal from Item where intItemNo=" + itemId + " and ysnSetMeal='T'";
        List<Object> list = this.generalSearchBySql(sql, null, null);
        if (null != list && list.size() > 0)
            lineType = "S";
        return lineType;
    }

    public void saveOnlineOrderDetail(String brandcode, String orderno, int suborderno, int line, String linetype, String pname, String pmodify, int qty, Double price, int orderfrom, String userName, Integer intitemno, String remark) throws Exception {
//        if (linetype.equals("A"))
//            linetype = "I";
        String inSql = "insert into onlineorderd (brandcode,orderno,suborderno,line,linetype,pname,pmodify,qty,price,orderfrom,confirmuser,dtorder,amount,amountafterdiscount,suborderstatus,intitemno, remark)" +
                "values ('" + brandcode + "','" + orderno + "','" + suborderno + "','" + line + "','" + linetype + "','" + pname + "','" + StringUtils.removeEnd(pmodify, " ") + "','" + qty + "','" + price + "','" + orderfrom + "','" + userName + "',now(),"
                + "'" + (qty * price) + "','"+(qty * price)+"',1," + intitemno + ",'" + remark + "')";
        this.updataByOriginSql(inSql);
    }

    public void updateOnlineOrderStatus(String orderNo, int status) throws Exception {
        String updateHql = "update OnlineorderhBean set status = " + status + ", updateDate = now() where orderno = '" + orderNo + "'";

        this.executeByHql(updateHql, null);
    }

    public List<OnlineorderpList> findOnlineorderhListByOpenId(String openId) throws Exception {
        String sql="select onlineorderp.*,onlineorderh.daysn as daysn,store.strstorename as strstorename,onlineorderh.tablecode as tablecode  from onlineorderp,onlineorderh,store,(select now() -interval '1' month  as tim ) as t where store.strstorecode=onlineorderh.strstorecode and onlineorderp.orderno=onlineorderh.orderno and onlineorderp.paydate >tim and onlineorderp.openid='"+openId+"' order by paydate desc";
        SQLQuery query= (SQLQuery) this.getSession().createSQLQuery(sql);
        query.setResultTransformer(Transformers.aliasToBean(OnlineorderpList.class));
        List<OnlineorderpList> list = query.list();
        if(list.size()>0){
            return list;
        }else {
            return null;
        }
    }
    public List<OnlinePrepayBean> findOnlineorderhOrderNoByOpenId(String openId) throws Exception {
        String sql="select pre.* from onlineorderh h,onlineprepay pre where h.orderno=pre.orderno and pre.status=0 and h.openid='"+openId+"'";
        SQLQuery query= (SQLQuery) this.getSession().createSQLQuery(sql);
        query.setResultTransformer(Transformers.aliasToBean(OnlinePrepayBean.class));
        List<OnlinePrepayBean> list = query.list();
        if(list.size()>0){
            return list;
        }else {
            return null;
        }
    }

}
