package com.bettersoft.api.dao.implement;

import java.util.List;
import java.util.Map;

import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Repository;

import com.bettersoft.api.dao.interfaces.IOnlinestoreDao;
import com.bettersoft.api.model.OnlinestoreBean;
import com.bettersoft.api.utils.Constants;

@Repository("onlinestoreDao")
public class OnlinestoreDao extends BaseDao implements IOnlinestoreDao {

    public List<Map<String, Object>> searchList(Map<String, Object> queryParam) throws Exception {
        String fromHql = "select new map(o.strstorecode as strstorecode, s.strStoreName as storeDesc, o.status as status,s.dtmTradeBegin as beginTime,s.dtmTradeEnd as endTime) from OnlinestoreBean o, StoreBean s where o.strstorecode = s.strStoreCode";
        return this.generalSearch(fromHql, queryParam, MapUtils.getString(queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
    }

    public Number searchCount(Map<String, Object> queryParam) throws Exception {
        String fromHql = "select new map(o.strstorecode as strstorecode, s.strStoreName as storeDesc, o.status as status) from OnlinestoreBean o, StoreBean s where o.strstorecode = s.strStoreCode";
        return this.generalCount(fromHql, queryParam);
    }
}
