package com.bettersoft.api.dao.implement;

import java.util.List;
import java.util.Map;

import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Repository;

import com.bettersoft.api.dao.interfaces.IProvincialAreaDao;
import com.bettersoft.api.utils.Constants;

@Repository("provincialAreaDao")
public class ProvincialAreaDao extends BaseDao implements IProvincialAreaDao {

	public List<Map<String, Object>> searchProvincials(
			Map<String, Object> queryParam) throws Exception {
		String fromHql = "select distinct new map(a.areaCode as areaCode, a.areaName as areaName, coalesce(p.areaName,'') as parentArea,"
				+ "case when coalesce(count(c.areaCode),0) > 0 then true else false end as isParent, a.lng as lng, a.lat as lat,"
				+ "a.provincialLevel as provincialLevel, a.createBy as createBy,a.createDateTime as createDateTime,"
				+ "a.createUserName as createUserName,a.lastModifyBy as lastModifyBy,a.lastModifyDateTime as lastModifyDateTime,"
				+ "a.lastModifyUserName as lastModifyUserName) from ProvincialAreaBean a left join a.parentProvincial p left join a.childAreas c "
				+ "group by a.areaCode,a.areaName,p.areaName,a.lng,a.lat,a.provincialLevel,a.createBy,a.createDateTime,a.createUserName,"
				+ "a.lastModifyBy,a.lastModifyDateTime,a.lastModifyUserName";

		return this.generalSearch(fromHql, queryParam, MapUtils.getString(
				queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
	}

	public Number searchProvincialCount(Map<String, Object> queryParam)
			throws Exception {
		String fromHql = "select distinct new map(a.areaCode as areaCode, a.areaName as areaName, coalesce(p.areaName,'') as parentArea,"
				+ "case when coalesce(count(c.areaCode),0) > 0 then true else false end as isParent, a.lng as lng, a.lat as lat,"
				+ "a.provincialLevel as provincialLevel, a.createBy as createBy,a.createDateTime as createDateTime,"
				+ "a.createUserName as createUserName,a.lastModifyBy as lastModifyBy,a.lastModifyDateTime as lastModifyDateTime,"
				+ "a.lastModifyUserName as lastModifyUserName) from ProvincialAreaBean a left join a.parentProvincial p left join a.childAreas c "
				+ "group by a.areaCode,a.areaName,p.areaName,a.lng,a.lat,a.provincialLevel,a.createBy,a.createDateTime,a.createUserName,"
				+ "a.lastModifyBy,a.lastModifyDateTime,a.lastModifyUserName";

		return this.generalCount(fromHql, queryParam, true);
	}

}
