package com.bettersoft.api.dao.implement;

import java.util.List;
import java.util.Map;

import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Repository;

import com.bettersoft.api.dao.interfaces.ISystemDepartmentDao;
import com.bettersoft.api.model.SystemDepartmentBean;
import com.bettersoft.api.utils.Constants;

@Repository("systemDepartmentDao")
public class SystemDepartmentDao extends BaseDao implements
		ISystemDepartmentDao {

	public List<Map<String, Object>> searchDepartments(
			Map<String, Object> queryParam) throws Exception {
		String fromHql = "select distinct new map(d.departmentCode as id,d.departmentCode as departmentCode,d.departmentDesc as departmentDesc,p.departmentCode as parent,p.departmentDesc as parentName,d.departmentLevel as level,case when c.departmentCode is null then true else false end as isLeaf) from SystemDepartmentBean d left join d.parentDepartment p left join d.childDepartments c";

		return this.generalSearch(fromHql, queryParam, MapUtils.getString(
				queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
	}

	public Number searchDepartmentCount(Map<String, Object> queryParam)
			throws Exception {
		String fromHql = "select distinct new map(d.departmentCode as id,d.departmentCode as departmentCode,d.departmentDesc as departmentDesc,p.departmentCode as parent,p.departmentDesc as parentName,d.departmentLevel as level,case when c.departmentCode is null then true else false end as isLeaf) from SystemDepartmentBean d left join d.parentDepartment p left join d.childDepartments c";

		return this.generalCount(fromHql, queryParam, true);
	}

	public List<SystemDepartmentBean> searchDepartmentTree(
			Map<String, Object> queryParam) throws Exception {
		String fromHql = "from SystemDepartmentBean";

		return this.generalSearch(fromHql, queryParam,
				"order by departmentCode");
	}

	public List<SystemDepartmentBean> inqueryDepartments(
			Map<String, Object> queryParam) throws Exception {
		String fromHql = "from SystemDepartmentBean";

		return this.generalSearch(fromHql, queryParam, MapUtils.getString(
				queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
	}

	public Number inqueryDepartmentCount(Map<String, Object> queryParam)
			throws Exception {
		String fromHql = "from SystemDepartmentBean";

		return this.generalCount(fromHql, queryParam);
	}
}