package com.bettersoft.api.dao.implement;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Repository;

import com.bettersoft.api.dao.interfaces.ISystemMenuTreeDao;
import com.bettersoft.api.model.MenuTreeBean;
import com.bettersoft.api.model.SystemMenuPermissionBean;
import com.bettersoft.api.model.SystemPermissionBean;
import com.bettersoft.api.utils.Constants;

@Repository("systemMenuTreeDao")
public class SystemMenuTreeDao extends BaseDao implements ISystemMenuTreeDao {

	public List<MenuTreeBean> searchMenuTrees(Map<String, Object> queryParam)
			throws Exception {
		String fromHql = "from MenuTreeBean";

		return this.generalSearch(fromHql, queryParam, MapUtils.getString(
				queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
	}

	public List<Map<String, Object>> searchMenuTreesGrid(
			Map<String, Object> queryParam) throws Exception {
		String fromHql = "select distinct new map(m.menuCode as id,m.menuCode as menuCode,m.menuName as menuName,m.priority as priority,m.menuUrl as menuUrl,m.enable as enable,p.menuCode as parent,p.menuName as parentName,m.menuIcon as menuIcon,m.menuType as menuType,m.menuLevel as level,case when m.menuType = 'M' then true else false end as isLeaf) from MenuTreeBean m left join m.parentMenu p";

		return this.generalSearch(fromHql, queryParam, MapUtils.getString(
				queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
	}

	public Number searchMenuTreeCount(Map<String, Object> queryParam)
			throws Exception {
		String fromHql = "from MenuTreeBean";

		return this.generalCount(fromHql, queryParam);
	}

	public List<SystemPermissionBean> searchPermissions(
			Map<String, Object> queryParam) throws Exception {
		String fromHql = "from SystemPermissionBean";

		return this.generalSearch(fromHql, queryParam, MapUtils.getString(
				queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
	}

	public SystemMenuPermissionBean searchMenuPermission(String menuCode,
			String permissionCode) throws Exception {
		Map<String, Object> queryParam = new HashMap<String, Object>();
		String fromHql = "from SystemMenuPermissionBean";

		queryParam.put("menu.menuCode", menuCode);
		queryParam.put("permission.permissionCode", permissionCode);

		List<SystemMenuPermissionBean> permissions = this.generalSearch(
				fromHql, queryParam, null);

		return null != permissions && !permissions.isEmpty() ? permissions
				.get(0) : null;
	}
}