package com.bettersoft.api.dao.implement;

import java.util.List;
import java.util.Map;

import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Repository;

import com.bettersoft.api.dao.interfaces.ISystemMessageDao;
import com.bettersoft.api.model.SystemMessageReadBean;
import com.bettersoft.api.utils.Constants;

@Repository("systemMessageDao")
public class SystemMessageDao extends BaseDao implements ISystemMessageDao {

	public List<Map<String, Object>> searchSystemMessages(
			Map<String, Object> queryParam) throws Exception {
		String fromHql = "select new map(m.seqId as seqId, m.msgTitle as msgTitle,m.msgContent as msgContent,"
				+ "case when r.userCode is null then true else false end as read, m.createDateTime as createDateTime) from "
				+ "SystemMessageBean m left join m.messageReads r";

		return this.generalSearch(fromHql, queryParam, MapUtils.getString(
				queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
	}

	public Number searchSystemMessageCount(Map<String, Object> queryParam)
			throws Exception {
		String fromHql = "select new map(m.seqId as seqId, m.msgTitle as msgTitle,m.msgContent as msgContent,"
				+ "case when r.userCode is null then true else false end as read, m.createDateTime as createDateTime) from "
				+ "SystemMessageBean m left join m.messageReads r";
		
		return this.generalCount(fromHql, queryParam);
	}

	public Number searchUnReadMessageCount(Map<String, Object> queryParam)
			throws Exception {
		String fromHql = "from SystemMessageBean m";

		return this.generalCount(fromHql, queryParam);
	}

	public SystemMessageReadBean findMessageRead(Map<String, Object> queryParam)
			throws Exception {
		String fromHql = "from SystemMessageReadBean";

		List<SystemMessageReadBean> msgReads = this.generalSearch(fromHql,
				queryParam, null);
		if (null != msgReads && !msgReads.isEmpty())
			return msgReads.get(0);

		return null;
	}

}
