package com.bettersoft.api.dao.implement;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Repository;

import com.bettersoft.api.dao.interfaces.ISystemRoleDao;
import com.bettersoft.api.model.MenuTreeBean;
import com.bettersoft.api.model.SystemDepartmentBean;
import com.bettersoft.api.model.SystemRoleBean;
import com.bettersoft.api.model.SystemRoleDepartmentBean;
import com.bettersoft.api.model.SystemRoleMenuBean;
import com.bettersoft.api.utils.Constants;

@Repository("systemRoleDao")
public class SystemRoleDao extends BaseDao implements ISystemRoleDao {

	public List<SystemRoleBean> searchRoles(Map<String, Object> queryParam)
			throws Exception {
		String fromHql = "from SystemRoleBean";

		return this.generalSearch(fromHql, queryParam, MapUtils.getString(
				queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
	}

	public Number searchRoleCount(Map<String, Object> queryParam)
			throws Exception {
		String fromHql = "from SystemRoleBean";

		return this.generalCount(fromHql, queryParam);
	}

	public Number searchRoleInUseCount(String roleCode) throws Exception {
		String fromHql = "from SystemUserRoleBean";
		Map<String, Object> queryParam = new HashMap<String, Object>();
		queryParam.put("roleCode", roleCode);

		return this.generalCount(fromHql, queryParam);
	}

	public List<MenuTreeBean> searchMenus(Map<String, Object> queryParam)
			throws Exception {
		String fromHql = "from MenuTreeBean";

		return this.generalSearch(fromHql, queryParam, MapUtils.getString(
				queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
	}

	public List<SystemDepartmentBean> searchDepartments(
			Map<String, Object> queryParam) throws Exception {
		String fromHql = "from SystemDepartmentBean";

		return this.generalSearch(fromHql, queryParam, MapUtils.getString(
				queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
	}

	public SystemRoleMenuBean searchRoleMenu(Map<String, Object> queryParam)
			throws Exception {
		String fromHql = "from SystemRoleMenuBean";

		List<SystemRoleMenuBean> roleMenu = this.generalSearch(fromHql,
				queryParam, null);

		return null != roleMenu && !roleMenu.isEmpty() ? roleMenu.get(0) : null;
	}

	public SystemRoleDepartmentBean searchRoleDept(
			Map<String, Object> queryParam) throws Exception {
		String fromHql = "from SystemRoleDepartmentBean";

		List<SystemRoleDepartmentBean> roleDepts = this.generalSearch(fromHql,
				queryParam, null);

		return null != roleDepts && !roleDepts.isEmpty() ? roleDepts.get(0)
				: null;
	}
}