package com.bettersoft.api.dao.implement;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.bettersoft.api.model.SystemUserStoreBean;
import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Repository;

import com.bettersoft.api.dao.interfaces.ISystemUserDao;
import com.bettersoft.api.model.SystemDepartmentBean;
import com.bettersoft.api.model.SystemUserBean;
import com.bettersoft.api.model.SystemUserRoleBean;
import com.bettersoft.api.utils.Constants;

@Repository("systemUserDao")
public class SystemUserDao extends BaseDao implements ISystemUserDao {

    public List<SystemUserBean> searchUsers(Map<String, Object> queryParam)
            throws Exception {
        String fromHql = "from SystemUserBean";

        return this.generalSearch(fromHql, queryParam, MapUtils.getString(
                queryParam, Constants.QUERY_ORDER_BY, StringUtils.EMPTY));
    }

    public Number searchUserCount(Map<String, Object> queryParam)
            throws Exception {
        String fromHql = "from SystemUserBean";

        return this.generalCount(fromHql, queryParam);
    }

    public List<Map<String, Object>> searchRoles() throws Exception {
        String fromHql = "select new map(roleCode as roleCode,roleName as roleName) from SystemRoleBean";

        return this.generalSearch(fromHql, null, "order by roleCode");
    }

    public List<Map<String, Object>> searchStores() throws Exception {
        String fromHql = "select new map(strStoreCode as storeCode,strStoreName as storeName) from StoreBean";

        return this.generalSearch(fromHql, null, "order by strStoreCode");
    }

    public List<SystemDepartmentBean> searchDepartments() throws Exception {
        Map<String, Object> queryParam = new HashMap<String, Object>();
        queryParam.put(Constants.QUERY_SPEC_CONDITION,
                "parentDepartment is null");

        String fromHql = "from SystemDepartmentBean";

        return this.generalSearch(fromHql, queryParam,
                "order by departmentCode");
    }

    public SystemUserRoleBean findUserRole(Map<String, Object> queryParam)
            throws Exception {
        String fromHql = "from SystemUserRoleBean";

        List<SystemUserRoleBean> userRoles = this.generalSearch(fromHql,
                queryParam, null);

        return null != userRoles && !userRoles.isEmpty() ? userRoles.get(0)
                : null;
    }

    public SystemUserStoreBean findUserStore(Map<String, Object> queryParam) throws Exception {
        String fromHql = "from SystemUserStoreBean";

        List<SystemUserStoreBean> userStores = this.generalSearch(fromHql,
                queryParam, null);

        return null != userStores && !userStores.isEmpty() ? userStores.get(0)
                : null;
    }
}
