package com.bettersoft.api.dao.interfaces;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

public interface IDashboardDao extends IBaseDao {
    public List<Map<String, Object>> searchStores(Map<String, Object> queryParam) throws Exception;

    // 每日线上订单数
    public Map<String,Integer> dailyOnlineOrderQuantity(String storeCode, Date date) throws Exception;

    public Map<String, List<Object>> weeklyOnlineOrders(String storeCode,Date date) throws Exception;

    // 每日未接单数
    public int dailyUnProcessOrderQuantity(String storeCode,Date date) throws Exception;

    // 每日未结账数
    public int dailyNotPaymentOrderQuantity(String storeCode,Date date) throws Exception;

    // 每日线上结账金额
    public Map<String,String> dailyOnlinePaymentAmount(String storeCode,Date date) throws Exception;

    public List<BigDecimal> weeklyOnlinePayments(String storeCode,Date date) throws Exception;

    public List<Map<String, Object>> searchPaymentPersent(String storeCode) throws Exception;


}
