package com.bettersoft.api.encrytion;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.Period;
import java.util.Calendar;
import java.util.Date;

public class DateUtils {

	public final static String DATE_PATTERN = "yyyy-MM-dd";
	public final static String DATE_TIME_PATTERN = "yyyy-MM-dd HH:mm:ss";
	public final static String DATE_TIME = "yyyyMMdd";
	public final static String DATE_TIME_PATTERN3 = "yyyy-MM-dd-HH-mm-ss";

	private volatile static DateUtils singleton;

	private DateUtils() {
	}

	public static DateUtils getSingleton() {
		if (singleton == null) {
			synchronized (DateUtils.class) {
				if (singleton == null) {
					singleton = new DateUtils();
				}
			}
		}
		return singleton;
	}

	public String dayComparePrecise(String fromDate) {
		StringBuilder sb = new StringBuilder();
		try {
			//java.time.format.DateTimeParseException: Text '2008-09-23 00:00:00' could not be parsed, unparsed text found at index 10
			//.substring(0, 10)
			Period period = Period.between(LocalDate.parse(fromDate.substring(0, 10)), LocalDate.now());
			sb.append(period.getYears());
//                .append(",")
//                .append(period.getMonths()).append(",")
//                .append(period.getDays());
		} catch (Exception e) {
			e.printStackTrace();
		}
		return sb.toString();
	}

	public static String format(Date date) {
		return format(date, DATE_PATTERN);
	}
	public static String format3(Date date) {
		return format(date, DATE_TIME_PATTERN3);
	}

	public static String format2() {
		return format(new Date(), DATE_TIME);
	}

	public static String formatDateTime(Date date) {
		return format(date, DATE_TIME_PATTERN);
	}

	public static String format(Date date, String pattern) {
		if (date != null) {
			SimpleDateFormat df = new SimpleDateFormat(pattern);
			return df.format(date);
		}
		return null;
	}

	public static Date getNow() {
		return new Date();
	}

	public static Date getDate(String str) {
		if (str != null) {
			SimpleDateFormat df = new SimpleDateFormat(DATE_PATTERN);
			try {
				return df.parse(str);
			} catch (ParseException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	public static Date getDate(String str,String format) {
		if (str != null) {
			SimpleDateFormat df = new SimpleDateFormat(format);
			try {
				return df.parse(str);
			} catch (ParseException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	public static Long getDay(String date) {
		DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		Long days = null;
		try {
			Date currentTime = dateFormat.parse(dateFormat.format(new Date()));//现在系统当前时间
			Date pastTime = dateFormat.parse(date);//过去时间
			long diff = pastTime.getTime() - currentTime.getTime();
			days = diff / (1000 * 60 * 60 * 24);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		return days;
	}

	public static Long getDifferDay(String beginDate,String endDate) {
		DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		Long days = null;
		try {
			Date begin = dateFormat.parse(beginDate);//开始时间
			Date end = dateFormat.parse(endDate);//结束时间
			long diff = begin.getTime() - end.getTime();
			days = diff / (1000 * 60 * 60 * 24);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		return days;
	}


	/**
	 * 日期加上天数，计算出最新日期
	 */
	public static String addDate(String strDate, long day) {
		long time = 0;
		try {
			SimpleDateFormat dateFormat = new SimpleDateFormat(DATE_PATTERN);
			Date date = dateFormat.parse(strDate); // 指定日期
			time = date.getTime(); // 得到指定日期的毫秒数
			day = day * 24 * 60 * 60 * 1000; // 要加上的天数转换成毫秒数
			time += day; // 相加得到新的毫秒数
		} catch (Exception e) {
			e.printStackTrace();
		}
		return format(new Date(time)); // 将毫秒数转换成日期
	}

	public static Double getRatio(Double start,Double end){
		Double x=start-end;
		return x;
	}
	public static Long getRatio(String start,String end){
		Long x=null;
		DateFormat dft=new SimpleDateFormat("yyyy-MM-dd");
		try {
			Date star=dft.parse(start);
			Date en=dft.parse(end);
			Long num=star.getTime()-en.getTime();

			x= num/24/60/60/1000;
		} catch (ParseException e) {
			e.printStackTrace();
		}

		return x;
	}

	public static String getYear(String date) {
		DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		double days = 0;
		try {
			Date currentTime = dateFormat.parse(dateFormat.format(new Date()));//现在系统当前时间
			Date pastTime = dateFormat.parse(date);//过去时间
			double diff = (double) (currentTime.getTime() - pastTime.getTime());
			days = diff / (1000 * 60 * 60 * 24 );
			days/=365;
		} catch (ParseException e) {
			e.printStackTrace();
		}
		String re = Double.toString(days).split("\\.")[0];
		return re;
	}
	public static Date getCurrentDate() {
		Calendar c = Calendar.getInstance();
		c.set(Calendar.HOUR, 0);
		c.set(Calendar.MINUTE, 0);
		c.set(Calendar.SECOND, 0);
		c.set(Calendar.MILLISECOND, 0);

		return c.getTime();
	}
}
