package com.bettersoft.api.filter;

import java.io.IOException;

import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.bettersoft.api.utils.Constants;
import com.bettersoft.api.utils.JsonResult;
import com.google.gson.Gson;
import org.apache.shiro.web.servlet.OncePerRequestFilter;

public class BettersoftApiCorsFilter extends OncePerRequestFilter {
    protected void doFilterInternal(ServletRequest servletRequest,
                                    ServletResponse servletResponse, FilterChain filterChain)
            throws ServletException, IOException {
        HttpServletResponse response = (HttpServletResponse) servletResponse;
        HttpServletRequest request = (HttpServletRequest) servletRequest;

        response.setHeader("Access-control-Allow-Origin",
                request.getHeader("Origin"));
        response.setHeader("Access-Control-Allow-Methods", "*");
        response.setHeader("Access-Control-Max-Age", "0");
        response.setHeader("Access-Control-Allow-Credentials", "true");
        response.setHeader("Access-Control-Allow-Headers",
                "x-requested-with,Authorization");
        // 防止乱码，用于传输JSON数据
        response.setHeader("Content-Type", "application/json;charset=UTF-8");
        // response.setStatus(HttpStatus.OK.value());

        if (request.getMethod().equalsIgnoreCase("OPTIONS")) {
            response.setStatus(HttpServletResponse.SC_OK);
            response.setContentType("text/json;charset=UTF-8");
            response.setCharacterEncoding(Constants.CHARACTERSET_CODING);
            response.getOutputStream().write(
                    new Gson().toJson(new JsonResult(), JsonResult.class).toString()
                            .getBytes(Constants.CHARACTERSET_CODING));
            return;
        }

        filterChain.doFilter(request, response);
    }
}
