package com.bettersoft.api.filter;

import com.alibaba.fastjson.JSONObject;
import com.bettersoft.api.encrytion.Base64Util;
import com.bettersoft.api.encrytion.DateUtils;
import com.bettersoft.api.utils.BigDecimalAdapter;
import com.bettersoft.api.utils.Constants;
import com.bettersoft.api.utils.HibernateProxyTypeAdapter;
import com.bettersoft.api.utils.JsonResult;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.shiro.web.filter.AccessControlFilter;

import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.math.BigDecimal;
import java.util.Date;

public class BettersoftWxApiFilter extends AccessControlFilter {
    private Log logger = LogFactory.getLog(getClass());

    @Override
    protected boolean isAccessAllowed(ServletRequest servletRequest, ServletResponse servletResponse, Object o) throws Exception {
        HttpServletRequest httpServletRequest = (HttpServletRequest) servletRequest;
        String token = httpServletRequest.getParameter("token");
        String temp = new String(Base64Util.decryBASE64(token));
        JSONObject jsonObject = JSONObject.parseObject(temp);
        String val = jsonObject.getString("day");
        if(!(DateUtils.getDifferDay(val, DateUtils.format(new Date())) > 0)){
            HttpServletResponse httpServletResponse = (HttpServletResponse) servletResponse;
            logger.info(jsonObject);
            JsonResult jsonResult = new JsonResult();
            jsonResult.setSuccess(false);
            jsonResult.setErrMsg("登录过期,请重新登录!");
            Gson gson = new GsonBuilder().serializeNulls()
                    .registerTypeAdapterFactory(HibernateProxyTypeAdapter.FACTORY)
                    // .registerTypeAdapter(Map.class, new MapTypeAdapter())
                    .registerTypeAdapter(BigDecimal.class, new BigDecimalAdapter())
                    .setDateFormat("yyyy-MM-dd HH:mm:ss").create();
            httpServletResponse.getOutputStream().write(
                    gson.toJson(jsonResult, JsonResult.class).toString()
                            .getBytes(Constants.CHARACTERSET_CODING));
            return false;
        }
        return true;
     }

    @Override
    protected boolean onAccessDenied(ServletRequest servletRequest, ServletResponse servletResponse) throws Exception {
        return false;
    }
}
