package com.bettersoft.api.model;

import java.util.*;

import javax.persistence.*;

import org.apache.commons.lang.StringUtils;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "OnlineItem")
public class OnlineItemBean extends BaseBean implements java.io.Serializable {
    private int intitemno;//商品编号
    private String brandcode;//品牌
    private String strstorecode;//门店编号
    private int status;//状态
    private String iconpath;//商品缩略图
    private String imgpath;//商品照片
    private Double num1;//数字备用
    private Double num2;//数字备用2
    private String remark1;//文本备用
    private String remark2;//文本备用2
    private String updateuser;//更新者
    private Date updateDate;//更新日
    private String creatuser;//生成者
    private Date creatDate;//生成日
    private Double price;//价格
    private ItemBean item;
    transient private String pmodify = StringUtils.EMPTY; //附加属性页面展示
    transient private int lineNo;
    transient private int quantity;
    transient private String itemType;

    @Transient
    public String getPmodify() {
        return pmodify;
    }

    public void setPmodify(String pmodify) {
        this.pmodify = pmodify;
    }

    @Transient
    public int getLineNo() {
        return lineNo;
    }

    public void setLineNo(int lineNo) {
        this.lineNo = lineNo;
    }

    @Transient
    public int getQuantity() {
        return quantity;
    }

    public void setQuantity(int quantity) {
        this.quantity = quantity;
    }

    @Transient
    public String getItemType() {
        return itemType;
    }

    public void setItemType(String itemType) {
        this.itemType = itemType;
    }

    @Column(name = "price")
    public Double getPrice() {
        return price;
    }

    public void setPrice(Double price) {
        this.price = price;
    }

    @Id
    @Column(name = "intitemno")
    public int getIntitemno() {
        return intitemno;
    }

    public void setIntitemno(int intitemno) {
        this.intitemno = intitemno;
    }

    @Column(name = "brandcode")
    public String getBrandcode() {
        return brandcode;
    }

    public void setBrandcode(String brandcode) {
        this.brandcode = brandcode;
    }

    @Id
    @Column(name = "strstorecode")
    public String getStrstorecode() {
        return strstorecode;
    }

    public void setStrstorecode(String strstorecode) {
        this.strstorecode = strstorecode;
    }

    @Column(name = "status")
    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    @Column(name = "iconpath")
    public String getIconpath() {
        return iconpath;
    }

    public void setIconpath(String iconpath) {
        this.iconpath = iconpath;
    }

    @Column(name = "imgpath")
    public String getImgpath() {
        return imgpath;
    }

    public void setImgpath(String imgpath) {
        this.imgpath = imgpath;
    }

    @Column(name = "num1")
    public Double getNum1() {
        return num1;
    }

    public void setNum1(Double num1) {
        this.num1 = num1;
    }

    @Column(name = "num2")
    public Double getNum2() {
        return num2;
    }

    public void setNum2(Double num2) {
        this.num2 = num2;
    }

    @Column(name = "remark1")
    public String getRemark1() {
        return remark1;
    }

    public void setRemark1(String remark1) {
        this.remark1 = remark1;
    }

    @Column(name = "remark2")
    public String getRemark2() {
        return remark2;
    }

    public void setRemark2(String remark2) {
        this.remark2 = remark2;
    }

    @Column(name = "updateuser")
    public String getUpdateuser() {
        return updateuser;
    }

    public void setUpdateuser(String updateuser) {
        this.updateuser = updateuser;
    }

    @Column(name = "updateDate")
    public Date getUpdateDate() {
        return updateDate;
    }

    public void setUpdateDate(Date updateDate) {
        this.updateDate = updateDate;
    }

    @Column(name = "creatuser")
    public String getCreatuser() {
        return creatuser;
    }

    public void setCreatuser(String creatuser) {
        this.creatuser = creatuser;
    }

    @Column(name = "creatDate")
    public Date getCreatDate() {
        return creatDate;
    }

    public void setCreatDate(Date creatDate) {
        this.creatDate = creatDate;
    }

    @ManyToOne
    @NotFound(action = NotFoundAction.IGNORE)
    @JoinColumn(name = "intitemno", insertable = false, updatable = false)
    public ItemBean getItem() {
        return item;
    }

    public void setItem(ItemBean item) {
        this.item = item;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OnlineItemBean that = (OnlineItemBean) o;
        return intitemno == that.intitemno &&
                Objects.equals(strstorecode, that.strstorecode) &&
                Objects.equals(pmodify, that.pmodify);
    }

    @Override
    public int hashCode() {
        return Objects.hash(intitemno, strstorecode, pmodify);
    }
}
