package com.bettersoft.api.model;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.metadata.BaseRowModel;
import com.bettersoft.api.encrytion.DateUtils;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.util.ObjectUtils;

import java.math.BigDecimal;
import java.math.RoundingMode;

@EqualsAndHashCode(callSuper = true)
@Data
@NoArgsConstructor
public class OnlineOrderhExport extends BaseRowModel {
    @ExcelProperty(value = "编号", index = 0)
    private String id;

    @ExcelProperty(value = "订单号", index = 1)
    private String orderNo;

    @ExcelProperty(value = "BO系统订单号", index = 2)
    private String posorderno;

    @ExcelProperty(value = "门店编号", index = 3)
    private String strstorecode;

    @ExcelProperty(value = "桌位号", index = 4)
    private String tablecode;

    @ExcelProperty(value = "门店流水号", index = 5)
    private String daysn;

    @ExcelProperty(value = "开单时间", index = 6)
    private String dtorderstart;

    @ExcelProperty(value = "商品数量", index = 7)
    private String qty;

    @ExcelProperty(value = "订单金额", index = 8)
    private String amountyf;

    @ExcelProperty(value = "实付金额", index = 9)
    private String amountsf;

    @ExcelProperty(value = "订单状态", index = 10)
    private String status;

    @ExcelProperty(value = "订单区分", index = 11)
    private String orderDiff;

    @ExcelProperty(value = "下单标识", index = 12)
    private String offlineupdateflg;

    public OnlineOrderhExport(OnlineorderhBean order) {
        this.orderNo = order.getOrderno();
        this.strstorecode = order.getStrstorecode();
        this.tablecode = order.getTablecode();
        this.daysn = String.valueOf(order.getDaysn());
        this.dtorderstart = DateUtils.format(order.getDtorderstart(), DateUtils.DATE_TIME_PATTERN);
        this.qty = String.valueOf(order.getQty());
//        this.amountyf = String.valueOf(order.getAmountyf());

        this.posorderno = order.getPosorderno();
        if(ObjectUtils.isEmpty(order.getAmountyf())){
            this.amountyf = String.valueOf(order.getAmountyf());
        } else {
            this.amountyf = BigDecimal.valueOf(order.getAmountyf()).setScale(2, RoundingMode.HALF_UP).toString();
        }
        if(ObjectUtils.isEmpty(order.getAmountsf())){
            this.amountsf = "";
        } else {
            this.amountsf = BigDecimal.valueOf(order.getAmountsf()).setScale(2, RoundingMode.HALF_UP).toString();
        }

        if (order.getTablecode().equals("qr")) {
            this.orderDiff = "QR点单";
            switch (order.getStatus()) {
                case 0:
                    this.status = "已下单";
                    break;
                case 1:
                    this.status = "已在线付款";
                    break;
                case 3:
                    this.status = "已接单";
                    break;
                case 5:
                    this.status="已退单";
                    break;
                case 9:
                    this.status = "已完成";
                    break;
                default:
                    this.status = "QR外卖->意料之外的状态 " + order.getStatus();
                    break;
            }
        } else {
            this.orderDiff = "门店点单";
            switch (order.getStatus()) {
                case 1:
                    this.status = "已下单";
                    break;
                case 2:
                    this.status = "已接单";
                    break;
                case 3:
                    this.status = "已在线付款";
                    break;
                case 9:
                    this.status = "已完成";
                    break;
                case 4:
                    this.status = "已线下结账";
                    break;
                case 5:
                    this.status = "已退款";
                    break;
                default:
                    this.status = "QR堂食->意料之外的状态 " + order.getStatus();
                    break;
            }
        }
        if (order.getOfflineupdateflg() == 1) {
            this.offlineupdateflg = "线下";
        } else {
            this.offlineupdateflg = "线上";
        }


    }
}
