package com.bettersoft.api.model;

import java.util.Date;
import java.sql.Timestamp;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import com.bettersoft.api.model.BaseBean;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "Price")
public class PriceBean extends BaseBean implements java.io.Serializable
{
	private int intPriceNo;//售价索引
	private String strStoreCode;//门市代码
	private int intItemNo;//商品编号
	private String ysnActive;//是否生效(T/F)
	private Date dtmEffective;//生效日期
	private Date dtmExpiry;//截止日期
	private Double curPrice;//售卖
	private int intCostNo;//当时对照成本索引
	private Double dblGM;//利润
	private Double curGP;//毛利
	private String strRemark;//Remark
	private Date dtmCreate;//Date
	private String strCreator;//Creator
	private Date dtmSetExpiry;//Expiry
	private String strSetExpiryPerson;//Set
	private String strExtSRef1;//他系统参考索引栏位1

	@Id
	@Column(name = "intPriceNo")
	public int getIntPriceNo() 
	{		
		return intPriceNo;
	}
	public void setIntPriceNo(int intPriceNo) 
	{
		this.intPriceNo = intPriceNo;
	}
	@Column(name = "strStoreCode")
	public String getStrStoreCode() 
	{		
		return strStoreCode;
	}
	public void setStrStoreCode(String strStoreCode) 
	{
		this.strStoreCode = strStoreCode;
	}
	@Column(name = "intItemNo")
	public int getIntItemNo() 
	{		
		return intItemNo;
	}
	public void setIntItemNo(int intItemNo) 
	{
		this.intItemNo = intItemNo;
	}
	@Column(name = "ysnActive")
	public String getYsnActive() 
	{		
		return ysnActive;
	}
	public void setYsnActive(String ysnActive) 
	{
		this.ysnActive = ysnActive;
	}
	@Column(name = "dtmEffective")
	public Date getDtmEffective() 
	{		
		return dtmEffective;
	}
	public void setDtmEffective(Date dtmEffective) 
	{
		this.dtmEffective = dtmEffective;
	}
	@Column(name = "dtmExpiry")
	public Date getDtmExpiry() 
	{		
		return dtmExpiry;
	}
	public void setDtmExpiry(Date dtmExpiry) 
	{
		this.dtmExpiry = dtmExpiry;
	}
	@Column(name = "curPrice")
	public Double getCurPrice() 
	{		
		return curPrice;
	}
	public void setCurPrice(Double curPrice) 
	{
		this.curPrice = curPrice;
	}
	@Column(name = "intCostNo")
	public int getIntCostNo() 
	{		
		return intCostNo;
	}
	public void setIntCostNo(int intCostNo) 
	{
		this.intCostNo = intCostNo;
	}
	@Column(name = "dblGM")
	public Double getDblGM() 
	{		
		return dblGM;
	}
	public void setDblGM(Double dblGM) 
	{
		this.dblGM = dblGM;
	}
	@Column(name = "curGP")
	public Double getCurGP() 
	{		
		return curGP;
	}
	public void setCurGP(Double curGP) 
	{
		this.curGP = curGP;
	}
	@Column(name = "strRemark")
	public String getStrRemark() 
	{		
		return strRemark;
	}
	public void setStrRemark(String strRemark) 
	{
		this.strRemark = strRemark;
	}
	@Column(name = "dtmCreate")
	public Date getDtmCreate() 
	{		
		return dtmCreate;
	}
	public void setDtmCreate(Date dtmCreate) 
	{
		this.dtmCreate = dtmCreate;
	}
	@Column(name = "strCreator")
	public String getStrCreator() 
	{		
		return strCreator;
	}
	public void setStrCreator(String strCreator) 
	{
		this.strCreator = strCreator;
	}
	@Column(name = "dtmSetExpiry")
	public Date getDtmSetExpiry() 
	{		
		return dtmSetExpiry;
	}
	public void setDtmSetExpiry(Date dtmSetExpiry) 
	{
		this.dtmSetExpiry = dtmSetExpiry;
	}
	@Column(name = "strSetExpiryPerson")
	public String getStrSetExpiryPerson() 
	{		
		return strSetExpiryPerson;
	}
	public void setStrSetExpiryPerson(String strSetExpiryPerson) 
	{
		this.strSetExpiryPerson = strSetExpiryPerson;
	}
	@Column(name = "strExtSRef1")
	public String getStrExtSRef1() 
	{		
		return strExtSRef1;
	}
	public void setStrExtSRef1(String strExtSRef1) 
	{
		this.strExtSRef1 = strExtSRef1;
	}

}
