package com.bettersoft.api.model;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.Cascade;
import org.hibernate.annotations.CascadeType;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import com.bettersoft.api.annotation.NotClone;
import com.bettersoft.api.annotation.NotCopy;
import com.bettersoft.api.annotation.NotMapped;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "bs_provincial")
public class ProvincialAreaBean extends BaseBean implements Serializable {
	private static final long serialVersionUID = -2990365624636523588L;

	@NotCopy
	private String areaCode;
	private String areaName;
	private String lng;
	private String lat;
	private int provincialLevel;

	@NotClone
	transient private ProvincialAreaBean parentProvincial;
	@NotMapped
	private List<ProvincialAreaBean> childAreas = new ArrayList<ProvincialAreaBean>();

	@com.bettersoft.api.annotation.Cascade(mappedBy = "parentProvincial", property = "areaCode")
	private String parentAreaCode;
	@com.bettersoft.api.annotation.Cascade(mappedBy = "parentProvincial", property = "areaName")
	private String parentAreaName;

	@Id
	@Column(name = "bs_areacode")
	public String getAreaCode() {
		return areaCode;
	}

	public void setAreaCode(String areaCode) {
		this.areaCode = areaCode;
	}

	@Column(name = "bs_areaname")
	public String getAreaName() {
		return areaName;
	}

	public void setAreaName(String areaName) {
		this.areaName = areaName;
	}

	@Column(name = "bs_lng")
	public String getLng() {
		return lng;
	}

	public void setLng(String lng) {
		this.lng = lng;
	}

	@Column(name = "bs_lat")
	public String getLat() {
		return lat;
	}

	public void setLat(String lat) {
		this.lat = lat;
	}

	@Column(name = "bs_provlevel")
	public int getProvincialLevel() {
		return provincialLevel;
	}

	public void setProvincialLevel(int provincialLevel) {
		this.provincialLevel = provincialLevel;
	}

	@Column(name = "bs_createby")
	public String getCreateBy() {
		return createBy;
	}

	public void setCreateBy(String createBy) {
		this.createBy = createBy;
	}

	@Column(name = "bs_createdatetime")
	public Timestamp getCreateDateTime() {
		return createDateTime;
	}

	public void setCreateDateTime(Timestamp createDateTime) {
		this.createDateTime = createDateTime;
	}

	@Column(name = "bs_createusername")
	public String getCreateUserName() {
		return createUserName;
	}

	public void setCreateUserName(String createUserName) {
		this.createUserName = createUserName;
	}

	@Column(name = "bs_lastmodiby")
	public String getLastModifyBy() {
		return lastModifyBy;
	}

	public void setLastModifyBy(String lastModifyBy) {
		this.lastModifyBy = lastModifyBy;
	}

	@Column(name = "bs_lastmodidatetime")
	public Timestamp getLastModifyDateTime() {
		return lastModifyDateTime;
	}

	public void setLastModifyDateTime(Timestamp lastModifyDateTime) {
		this.lastModifyDateTime = lastModifyDateTime;
	}

	@Column(name = "bs_lastmodiusername")
	public String getLastModifyUserName() {
		return lastModifyUserName;
	}

	public void setLastModifyUserName(String lastModifyUserName) {
		this.lastModifyUserName = lastModifyUserName;
	}

	@ManyToOne
	@JoinColumn(name = "bs_parentarea")
	public ProvincialAreaBean getParentProvincial() {
		return parentProvincial;
	}

	public void setParentProvincial(ProvincialAreaBean parentProvincial) {
		this.parentProvincial = parentProvincial;
	}

	@OneToMany(mappedBy = "parentProvincial", orphanRemoval = true, fetch = FetchType.EAGER)
	@Cascade(value = { CascadeType.ALL })
	public List<ProvincialAreaBean> getChildAreas() {
		return childAreas;
	}

	public void setChildAreas(List<ProvincialAreaBean> childAreas) {
		this.childAreas = childAreas;
	}

	@Transient
	public String getParentAreaCode() {
		return parentAreaCode;
	}

	public void setParentAreaCode(String parentAreaCode) {
		this.parentAreaCode = parentAreaCode;
	}

	@Transient
	public String getParentAreaName() {
		return parentAreaName;
	}

	public void setParentAreaName(String parentAreaName) {
		this.parentAreaName = parentAreaName;
	}
}
