package com.bettersoft.api.model;

import java.io.Serializable;
import java.sql.Timestamp;

import javax.persistence.*;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "bs_smssender_log")
public class SmsSenderLogBean extends BaseBean implements Serializable {
	private static final long serialVersionUID = 7875908712747843060L;

	private int seqId;
	private String senderPhone;
	private String senderMsg;
	private String senderType;
	private boolean sender;
	private Timestamp senderTime;
	private String refrenceId;

	@Id
	@SequenceGenerator(name = "SEQ_SMSLOG_ID", allocationSize = 1, initialValue = 1, sequenceName = "SEQ_SMSLOG_ID")
	@GeneratedValue(generator = "SEQ_SMSLOG_ID", strategy = GenerationType.SEQUENCE)
	@Column(name = "bs_seq_id")
	public int getSeqId() {
		return seqId;
	}

	public void setSeqId(int seqId) {
		this.seqId = seqId;
	}

	@Column(name = "bs_sender_phone")
	public String getSenderPhone() {
		return senderPhone;
	}

	public void setSenderPhone(String senderPhone) {
		this.senderPhone = senderPhone;
	}

	@Column(name = "bs_sender_msg")
	public String getSenderMsg() {
		return senderMsg;
	}

	public void setSenderMsg(String senderMsg) {
		this.senderMsg = senderMsg;
	}

	@Column(name = "bs_sender_type")
	public String getSenderType() {
		return senderType;
	}

	public void setSenderType(String senderType) {
		this.senderType = senderType;
	}

	@Column(name = "bs_issender")
	public boolean isSender() {
		return sender;
	}

	public void setSender(boolean sender) {
		this.sender = sender;
	}

	@Column(name = "bs_sender_time")
	public Timestamp getSenderTime() {
		return senderTime;
	}

	public void setSenderTime(Timestamp senderTime) {
		this.senderTime = senderTime;
	}

	@Column(name = "bs_refdocno")
	public String getRefrenceId() {
		return refrenceId;
	}

	public void setRefrenceId(String refrenceId) {
		this.refrenceId = refrenceId;
	}
}
