package com.bettersoft.api.model;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.CascadeType;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;

import com.bettersoft.api.annotation.Cascade;
import com.bettersoft.api.annotation.NotCopy;
import com.bettersoft.api.annotation.NotMapped;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "bs_sysdepartment")
public class SystemDepartmentBean extends BaseBean implements Serializable {
	private static final long serialVersionUID = -699020799128706868L;

	@NotCopy
	private String departmentCode;
	private String departmentDesc;
	private boolean enable;
	@NotCopy
	private int departmentLevel;
	private String remark;

	@NotMapped
	transient private SystemDepartmentBean parentDepartment;
	@NotMapped
	private List<SystemDepartmentBean> childDepartments = new ArrayList<SystemDepartmentBean>();

	private String parentCode;
	private String parentDesc;

	@Id
	@Column(name = "bs_depcode")
	public String getDepartmentCode() {
		return departmentCode;
	}

	public void setDepartmentCode(String departmentCode) {
		this.departmentCode = departmentCode;
	}

	@Column(name = "bs_depdesc")
	public String getDepartmentDesc() {
		return departmentDesc;
	}

	public void setDepartmentDesc(String departmentDesc) {
		this.departmentDesc = departmentDesc;
	}

	@Column(name = "bs_isenable")
	public boolean isEnable() {
		return enable;
	}

	public void setEnable(boolean enable) {
		this.enable = enable;
	}

	@Column(name = "bs_level")
	public int getDepartmentLevel() {
		return departmentLevel;
	}

	public void setDepartmentLevel(int departmentLevel) {
		this.departmentLevel = departmentLevel;
	}

	@Column(name = "bs_remark")
	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	@Column(name = "bs_createby")
	public String getCreateBy() {
		return createBy;
	}

	public void setCreateBy(String createBy) {
		this.createBy = createBy;
	}

	@Column(name = "bs_createdatetime")
	public Timestamp getCreateDateTime() {
		return createDateTime;
	}

	public void setCreateDateTime(Timestamp createDateTime) {
		this.createDateTime = createDateTime;
	}

	@Column(name = "bs_createusername")
	public String getCreateUserName() {
		return createUserName;
	}

	public void setCreateUserName(String createUserName) {
		this.createUserName = createUserName;
	}

	@Column(name = "bs_lastmodiby")
	public String getLastModifyBy() {
		return lastModifyBy;
	}

	public void setLastModifyBy(String lastModifyBy) {
		this.lastModifyBy = lastModifyBy;
	}

	@Column(name = "bs_lastmodidatetime")
	public Timestamp getLastModifyDateTime() {
		return lastModifyDateTime;
	}

	public void setLastModifyDateTime(Timestamp lastModifyDateTime) {
		this.lastModifyDateTime = lastModifyDateTime;
	}

	@Column(name = "bs_lastmodiusername")
	public String getLastModifyUserName() {
		return lastModifyUserName;
	}

	public void setLastModifyUserName(String lastModifyUserName) {
		this.lastModifyUserName = lastModifyUserName;
	}

	@ManyToOne
	@NotFound(action = NotFoundAction.IGNORE)
	@JoinColumn(name = "bs_parentcode")
	public SystemDepartmentBean getParentDepartment() {
		return parentDepartment;
	}

	public void setParentDepartment(SystemDepartmentBean parentDepartment) {
		this.parentDepartment = parentDepartment;
	}

	@OneToMany(mappedBy = "parentDepartment", orphanRemoval = true)
	@org.hibernate.annotations.Cascade(value = { CascadeType.ALL })
	public List<SystemDepartmentBean> getChildDepartments() {
		return childDepartments;
	}

	public void setChildDepartments(List<SystemDepartmentBean> childDepartments) {
		this.childDepartments = childDepartments;
	}

	@Transient
	@Cascade(mappedBy = "parentDepartment", property = "departmentCode")
	public String getParentCode() {
		return parentCode;
	}

	public void setParentCode(String parentCode) {
		this.parentCode = parentCode;
	}

	@Transient
	@Cascade(mappedBy = "parentDepartment", property = "departmentDesc")
	public String getParentDesc() {
		return parentDesc;
	}

	public void setParentDesc(String parentDesc) {
		this.parentDesc = parentDesc;
	}
}
