package com.bettersoft.api.model;

import java.io.Serializable;
import java.sql.Timestamp;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import com.bettersoft.api.annotation.Cascade;
import com.bettersoft.api.utils.StringDigestUtil;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "bs_syslog")
public class SystemLogOperatorBean extends BaseBean implements Serializable {
	private static final long serialVersionUID = 5493677758875278725L;

	private String logId;
	private String loginUserCode;
	private String loginUserName;
	private String operatorType;
	private String operatorObject;

	transient private SystemLogOperatorDetailBean operatorDetail;

	@Cascade(mappedBy = "operatorDetail", property = "sourceValue")
	private String sourceValue;
	@Cascade(mappedBy = "operatorDetail", property = "targetValue")
	private String targetValue;
	private String menuName;

	public SystemLogOperatorBean() {
		super();
		this.logId = StringDigestUtil.generalUUID();
	}

	@Id
	@Column(name = "bs_log_id")
	public String getLogId() {
		return logId;
	}

	public void setLogId(String logId) {
		this.logId = logId;
	}

	@Column(name = "bs_loginusercode")
	public String getLoginUserCode() {
		return loginUserCode;
	}

	public void setLoginUserCode(String loginUserCode) {
		this.loginUserCode = loginUserCode;
	}

	@Column(name = "bs_loginusername")
	public String getLoginUserName() {
		return loginUserName;
	}

	public void setLoginUserName(String loginUserName) {
		this.loginUserName = loginUserName;
	}

	@Column(name = "bs_opertype")
	public String getOperatorType() {
		return operatorType;
	}

	public void setOperatorType(String operatorType) {
		this.operatorType = operatorType;
	}

	@Column(name = "bs_operobj")
	public String getOperatorObject() {
		return operatorObject;
	}

	public void setOperatorObject(String operatorObject) {
		this.operatorObject = operatorObject;
	}

	@Column(name = "bs_createdatetime")
	public Timestamp getCreateDateTime() {
		return createDateTime;
	}

	public void setCreateDateTime(Timestamp createDateTime) {
		this.createDateTime = createDateTime;
	}

	@OneToOne(mappedBy = "logOper", optional = false, cascade = CascadeType.ALL)
	public SystemLogOperatorDetailBean getOperatorDetail() {
		return operatorDetail;
	}

	public void setOperatorDetail(SystemLogOperatorDetailBean operatorDetail) {
		this.operatorDetail = operatorDetail;
	}

	@Transient
	public String getMenuName() {
		return menuName;
	}

	public void setMenuName(String menuName) {
		this.menuName = menuName;
	}

	@Transient
	public String getSourceValue() {
		return sourceValue;
	}

	public void setSourceValue(String sourceValue) {
		this.sourceValue = sourceValue;
	}

	@Transient
	public String getTargetValue() {
		return targetValue;
	}

	public void setTargetValue(String targetValue) {
		this.targetValue = targetValue;
	}
}
