package com.bettersoft.api.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "bs_syslogdetail")
public class SystemLogOperatorDetailBean extends BaseBean implements
		Serializable {
	private static final long serialVersionUID = 5898239724074316384L;

	private String logId;
	private String sourceValue;
	private String targetValue;

	transient private SystemLogOperatorBean logOper;

	@Id
	@Column(name = "bs_log_id")
	public String getLogId() {
		return logId;
	}

	public void setLogId(String logId) {
		this.logId = logId;
	}

	@Column(name = "bs_srcvalue")
	public String getSourceValue() {
		return sourceValue;
	}

	public void setSourceValue(String sourceValue) {
		this.sourceValue = sourceValue;
	}

	@Column(name = "bs_tarvalue")
	public String getTargetValue() {
		return targetValue;
	}

	public void setTargetValue(String targetValue) {
		this.targetValue = targetValue;
	}

	@ManyToOne
	@JoinColumn(name = "bs_log_id", insertable = false, updatable = false)
	public SystemLogOperatorBean getLogOper() {
		return logOper;
	}

	public void setLogOper(SystemLogOperatorBean logOper) {
		this.logOper = logOper;
	}
}
