package com.bettersoft.api.model;

import java.io.Serializable;
import java.sql.Timestamp;

import javax.persistence.*;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "bs_menupermission")
public class SystemMenuPermissionBean extends BaseBean implements Serializable {
    private static final long serialVersionUID = 1187646685502115027L;

    private int seqId;

    private String menuCode;
    private String permissionCode;

    transient private MenuTreeBean menu;
    transient private SystemPermissionBean permission;

    private String permissionDesc;

    @Id
    @SequenceGenerator(name = "SEQ_MENUPERMISSION_ID", allocationSize = 1, initialValue = 1, sequenceName = "SEQ_MENUPERMISSION_ID")
    @GeneratedValue(generator = "SEQ_MENUPERMISSION_ID", strategy = GenerationType.SEQUENCE)
    @Column(name = "bs_seq_id")
    public int getSeqId() {
        return seqId;
    }

    public void setSeqId(int seqId) {
        this.seqId = seqId;
    }

    @Column(name = "bs_menucode")
    public String getMenuCode() {
        return menuCode;
    }

    public void setMenuCode(String menuCode) {
        this.menuCode = menuCode;
    }

    @Column(name = "bs_permcode")
    public String getPermissionCode() {
        return permissionCode;
    }

    public void setPermissionCode(String permissionCode) {
        this.permissionCode = permissionCode;
    }

    @Column(name = "bs_createdatetime")
    public Timestamp getCreateDateTime() {
        return createDateTime;
    }

    public void setCreateDateTime(Timestamp createDateTime) {
        this.createDateTime = createDateTime;
    }

    @ManyToOne
    @JoinColumn(name = "bs_menucode", insertable = false, updatable = false)
    public MenuTreeBean getMenu() {
        return menu;
    }

    public void setMenu(MenuTreeBean menu) {
        this.menu = menu;
    }

    @ManyToOne
    @JoinColumn(name = "bs_permcode", insertable = false, updatable = false)
    public SystemPermissionBean getPermission() {
        return permission;
    }

    public void setPermission(SystemPermissionBean permission) {
        this.permission = permission;
    }

    @Transient
    public String getPermissionDesc() {
        return permissionDesc;
    }

    public void setPermissionDesc(String permissionDesc) {
        this.permissionDesc = permissionDesc;
    }
}
