package com.bettersoft.api.model;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.hibernate.annotations.Cascade;
import org.hibernate.annotations.CascadeType;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "bs_sysmessage")
public class SystemMessageBean extends BaseBean implements Serializable {
	private static final long serialVersionUID = -5382777530911572961L;

	private int seqId;
	private String msgTitle;
	private String msgContent;

	private List<SystemMessageReadBean> messageReads = new ArrayList<SystemMessageReadBean>();

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "bs_seq_id")
	public int getSeqId() {
		return seqId;
	}

	public void setSeqId(int seqId) {
		this.seqId = seqId;
	}

	@Column(name = "bs_msgtitle")
	public String getMsgTitle() {
		return msgTitle;
	}

	public void setMsgTitle(String msgTitle) {
		this.msgTitle = msgTitle;
	}

	@Column(name = "bs_msgcontent")
	public String getMsgContent() {
		return msgContent;
	}

	public void setMsgContent(String msgContent) {
		this.msgContent = msgContent;
	}

	@Column(name = "bs_createdatetime")
	public Timestamp getCreateDateTime() {
		return createDateTime;
	}

	public void setCreateDateTime(Timestamp createDateTime) {
		this.createDateTime = createDateTime;
	}

	@OneToMany(mappedBy = "message", orphanRemoval = true)
	@Cascade(value = { CascadeType.ALL })
	public List<SystemMessageReadBean> getMessageReads() {
		return messageReads;
	}

	public void setMessageReads(List<SystemMessageReadBean> messageReads) {
		this.messageReads = messageReads;
	}
}
