package com.bettersoft.api.model;

import java.io.Serializable;
import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "bs_sysmsgread")
public class SystemMessageReadBean extends BaseBean implements Serializable {
	private static final long serialVersionUID = -6864390287187630268L;

	private int seqId;
	private int messageId;
	private String userCode;

	private SystemMessageBean message;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "bs_seq_id")
	public int getSeqId() {
		return seqId;
	}

	public void setSeqId(int seqId) {
		this.seqId = seqId;
	}

	@Column(name = "bs_msg_id")
	public int getMessageId() {
		return messageId;
	}

	public void setMessageId(int messageId) {
		this.messageId = messageId;
	}

	@Column(name = "bs_usercode")
	public String getUserCode() {
		return userCode;
	}

	public void setUserCode(String userCode) {
		this.userCode = userCode;
	}
	
	@Column(name = "bs_createdatetime")
	public Timestamp getCreateDateTime() {
		return createDateTime;
	}

	public void setCreateDateTime(Timestamp createDateTime) {
		this.createDateTime = createDateTime;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "bs_msg_id", insertable = false, updatable = false)
	public SystemMessageBean getMessage() {
		return message;
	}

	public void setMessage(SystemMessageBean message) {
		this.message = message;
	}
}
