package com.bettersoft.api.model;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.Cascade;
import org.hibernate.annotations.CascadeType;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;

import com.bettersoft.api.annotation.NotCopy;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "bs_sysrole")
public class SystemRoleBean extends BaseBean implements Serializable {
	private static final long serialVersionUID = -900910363979765455L;

	@NotCopy
	private String roleCode;
	private String roleName;
	private String remark;

	@NotCopy
	transient private SystemDepartmentBean department;
	@NotCopy
	private List<SystemRoleMenuBean> authMenus = new ArrayList<SystemRoleMenuBean>();
	@NotCopy
	private List<SystemRoleDepartmentBean> authDatas = new ArrayList<SystemRoleDepartmentBean>();

	private String departmentCode;
	private String departmentDesc;

	@Id
	@Column(name = "bs_rolecode")
	public String getRoleCode() {
		return roleCode;
	}

	public void setRoleCode(String roleCode) {
		this.roleCode = roleCode;
	}

	@Column(name = "bs_rolename")
	public String getRoleName() {
		return roleName;
	}

	public void setRoleName(String roleName) {
		this.roleName = roleName;
	}

	@Column(name = "bs_remark")
	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	@Column(name = "bs_createby")
	public String getCreateBy() {
		return createBy;
	}

	public void setCreateBy(String createBy) {
		this.createBy = createBy;
	}

	@Column(name = "bs_createdatetime")
	public Timestamp getCreateDateTime() {
		return createDateTime;
	}

	public void setCreateDateTime(Timestamp createDateTime) {
		this.createDateTime = createDateTime;
	}

	@Column(name = "bs_createusername")
	public String getCreateUserName() {
		return createUserName;
	}

	public void setCreateUserName(String createUserName) {
		this.createUserName = createUserName;
	}

	@Column(name = "bs_lastmodiby")
	public String getLastModifyBy() {
		return lastModifyBy;
	}

	public void setLastModifyBy(String lastModifyBy) {
		this.lastModifyBy = lastModifyBy;
	}

	@Column(name = "bs_lastmodidatetime")
	public Timestamp getLastModifyDateTime() {
		return lastModifyDateTime;
	}

	public void setLastModifyDateTime(Timestamp lastModifyDateTime) {
		this.lastModifyDateTime = lastModifyDateTime;
	}

	@Column(name = "bs_lastmodiusername")
	public String getLastModifyUserName() {
		return lastModifyUserName;
	}

	public void setLastModifyUserName(String lastModifyUserName) {
		this.lastModifyUserName = lastModifyUserName;
	}

	@ManyToOne
	@NotFound(action = NotFoundAction.IGNORE)
	@JoinColumn(name = "bs_depcode")
	public SystemDepartmentBean getDepartment() {
		return department;
	}

	public void setDepartment(SystemDepartmentBean department) {
		this.department = department;
	}

	@OneToMany(mappedBy = "systemRole", orphanRemoval = true)
	@Cascade(value = { CascadeType.ALL })
	public List<SystemRoleMenuBean> getAuthMenus() {
		return authMenus;
	}

	public void setAuthMenus(List<SystemRoleMenuBean> authMenus) {
		this.authMenus = authMenus;
	}

	@OneToMany(mappedBy = "systemRole", orphanRemoval = true)
	@Cascade(value = { CascadeType.ALL })
	public List<SystemRoleDepartmentBean> getAuthDatas() {
		return authDatas;
	}

	public void setAuthDatas(List<SystemRoleDepartmentBean> authDatas) {
		this.authDatas = authDatas;
	}

	@Transient
	public String getDepartmentCode() {
		return departmentCode;
	}

	public void setDepartmentCode(String departmentCode) {
		this.departmentCode = departmentCode;
	}

	@Transient
	public String getDepartmentDesc() {
		return departmentDesc;
	}

	public void setDepartmentDesc(String departmentDesc) {
		this.departmentDesc = departmentDesc;
	}
}
