package com.bettersoft.api.model;

import java.io.Serializable;
import java.sql.Timestamp;

import javax.persistence.*;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "bs_role_dep")
public class SystemRoleDepartmentBean extends BaseBean implements Serializable {
    private static final long serialVersionUID = -8683220322268863772L;

    private int seqId;

    private String roleCode;
    private String departmentCode;

    transient private SystemRoleBean systemRole;
    transient private SystemDepartmentBean department;

    @Id
    @SequenceGenerator(name = "SEQ_ROLEDEP_ID", sequenceName = "SEQ_ROLEDEP_ID", allocationSize = 1, initialValue = 1)
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_ROLEDEP_ID")
    @Column(name = "bs_seq_id")
    public int getSeqId() {
        return seqId;
    }

    public void setSeqId(int seqId) {
        this.seqId = seqId;
    }

    @Column(name = "bs_rolecode")
    public String getRoleCode() {
        return roleCode;
    }

    public void setRoleCode(String roleCode) {
        this.roleCode = roleCode;
    }

    @Column(name = "bs_depcode")
    public String getDepartmentCode() {
        return departmentCode;
    }

    public void setDepartmentCode(String departmentCode) {
        this.departmentCode = departmentCode;
    }

    @Column(name = "bs_createdatetime")
    public Timestamp getCreateDateTime() {
        return createDateTime;
    }

    public void setCreateDateTime(Timestamp createDateTime) {
        this.createDateTime = createDateTime;
    }

    @ManyToOne
    @NotFound(action = NotFoundAction.IGNORE)
    @JoinColumn(name = "bs_rolecode", insertable = false, updatable = false)
    public SystemRoleBean getSystemRole() {
        return systemRole;
    }

    public void setSystemRole(SystemRoleBean systemRole) {
        this.systemRole = systemRole;
    }

    @ManyToOne
    @NotFound(action = NotFoundAction.IGNORE)
    @JoinColumn(name = "bs_depcode", insertable = false, updatable = false)
    public SystemDepartmentBean getDepartment() {
        return department;
    }

    public void setDepartment(SystemDepartmentBean department) {
        this.department = department;
    }

}
