package com.bettersoft.api.model;

import java.io.Serializable;
import java.sql.Timestamp;

import javax.persistence.*;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;

import com.bettersoft.api.annotation.Ignore;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "bs_role_menu")
public class SystemRoleMenuBean extends BaseBean implements Serializable {
	private static final long serialVersionUID = -435252006844331020L;

	@Ignore
	private int seqId;
	private String roleCode;
	private String menuCode;
	private String permissionCode;
	private String authCode;

	transient private SystemRoleBean systemRole;
	transient private MenuTreeBean menuTree;
	transient private SystemPermissionBean permission;

	@Id
	@SequenceGenerator(name = "SEQ_ROLEMENU_ID", sequenceName = "SEQ_ROLEMENU_ID", allocationSize = 1, initialValue = 1)
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_ROLEMENU_ID")
	@Column(name = "bs_seq_id")
	public int getSeqId() {
		return seqId;
	}

	public void setSeqId(int seqId) {
		this.seqId = seqId;
	}

	@Column(name = "bs_rolecode")
	public String getRoleCode() {
		return roleCode;
	}

	public void setRoleCode(String roleCode) {
		this.roleCode = roleCode;
	}

	@Column(name = "bs_menucode")
	public String getMenuCode() {
		return menuCode;
	}

	public void setMenuCode(String menuCode) {
		this.menuCode = menuCode;
	}

	@Column(name = "bs_permcode")
	public String getPermissionCode() {
		return permissionCode;
	}

	public void setPermissionCode(String permissionCode) {
		this.permissionCode = permissionCode;
	}

	@Column(name = "bs_authcode")
	public String getAuthCode() {
		return authCode;
	}

	public void setAuthCode(String authCode) {
		this.authCode = authCode;
	}

	@Column(name = "bs_createdatetime")
	public Timestamp getCreateDateTime() {
		return createDateTime;
	}

	public void setCreateDateTime(Timestamp createDateTime) {
		this.createDateTime = createDateTime;
	}

	@ManyToOne
	@NotFound(action = NotFoundAction.IGNORE)
	@JoinColumn(name = "bs_rolecode", insertable = false, updatable = false)
	public SystemRoleBean getSystemRole() {
		return systemRole;
	}

	public void setSystemRole(SystemRoleBean systemRole) {
		this.systemRole = systemRole;
	}

	@ManyToOne
	@NotFound(action = NotFoundAction.IGNORE)
	@JoinColumn(name = "bs_menucode", insertable = false, updatable = false)
	public MenuTreeBean getMenuTree() {
		return menuTree;
	}

	public void setMenuTree(MenuTreeBean menuTree) {
		this.menuTree = menuTree;
	}

	@ManyToOne
	@NotFound(action = NotFoundAction.IGNORE)
	@JoinColumn(name = "bs_permcode", insertable = false, updatable = false)
	public SystemPermissionBean getPermission() {
		return permission;
	}

	public void setPermission(SystemPermissionBean permission) {
		this.permission = permission;
	}
}
