package com.bettersoft.api.model;

import java.io.Serializable;
import java.sql.Timestamp;

import javax.persistence.*;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "bs_user_role")
public class SystemUserRoleBean extends BaseBean implements Serializable {
	private static final long serialVersionUID = -8683278414098523732L;

	private int seqId;

	private String userCode;
	private String roleCode;

	private SystemUserBean systemUser;
	private SystemRoleBean systemRole;

	@Id
	@SequenceGenerator(name = "SEQ_URSERROLE_ID", allocationSize = 1, initialValue = 1, sequenceName = "SEQ_URSERROLE_ID")
	@GeneratedValue(generator = "SEQ_URSERROLE_ID", strategy = GenerationType.SEQUENCE)
	@Column(name = "bs_seq_id")
	public int getSeqId() {
		return seqId;
	}

	public void setSeqId(int seqId) {
		this.seqId = seqId;
	}

	@Column(name = "bs_createdatetime")
	public Timestamp getCreateDateTime() {
		return createDateTime;
	}

	public void setCreateDateTime(Timestamp createDateTime) {
		this.createDateTime = createDateTime;
	}

	@Column(name = "bs_usercode")
	public String getUserCode() {
		return userCode;
	}

	public void setUserCode(String userCode) {
		this.userCode = userCode;
	}

	@Column(name = "bs_rolecode")
	public String getRoleCode() {
		return roleCode;
	}

	public void setRoleCode(String roleCode) {
		this.roleCode = roleCode;
	}

	@ManyToOne
	@NotFound(action = NotFoundAction.IGNORE)
	@JoinColumn(name = "bs_usercode", insertable = false, updatable = false)
	public SystemUserBean getSystemUser() {
		return systemUser;
	}

	public void setSystemUser(SystemUserBean systemUser) {
		this.systemUser = systemUser;
	}

	@ManyToOne
	@NotFound(action = NotFoundAction.IGNORE)
	@JoinColumn(name = "bs_rolecode", insertable = false, updatable = false)
	public SystemRoleBean getSystemRole() {
		return systemRole;
	}

	public void setSystemRole(SystemRoleBean systemRole) {
		this.systemRole = systemRole;
	}
}
