package com.bettersoft.api.model;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;

import javax.persistence.*;
import java.io.Serializable;
import java.sql.Timestamp;

@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "bs_userstore")
public class SystemUserStoreBean extends BaseBean implements Serializable {
    private int seqId;
    private String userCode;
    private String storeCode;

    transient private SystemUserBean systemUser;
    transient private StoreBean store;

    @Id
    @SequenceGenerator(name = "SEQ_USERSTORE_ID", sequenceName = "SEQ_USERSTORE_ID", allocationSize = 1, initialValue = 1)
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_USERSTORE_ID")
    @Column(name = "bs_seq_id")
    public int getSeqId() {
        return seqId;
    }

    public void setSeqId(int seqId) {
        this.seqId = seqId;
    }

    @Column(name="bs_usercode")
    public String getUserCode() {
        return userCode;
    }

    public void setUserCode(String userCode) {
        this.userCode = userCode;
    }

    @Column(name="bs_strstorecode")
    public String getStoreCode() {
        return storeCode;
    }

    public void setStoreCode(String storeCode) {
        this.storeCode = storeCode;
    }

    @Column(name="bs_createdatetime")
    public Timestamp getCreateDateTime() { return this.createDateTime; }

    public void setCreateDateTime(Timestamp createDateTime) { this.createDateTime = createDateTime; }

    @ManyToOne
    @NotFound(action = NotFoundAction.IGNORE)
    @JoinColumn(name = "bs_usercode", insertable = false, updatable = false)
    public SystemUserBean getSystemUser() { return systemUser; }

    public void setSystemUser(SystemUserBean systemUser) { this.systemUser = systemUser; }

    @ManyToOne
    @NotFound(action = NotFoundAction.IGNORE)
    @JoinColumn(name = "bs_strstorecode", insertable = false, updatable = false)
    public StoreBean getStore() { return store; }

    public void setStore(StoreBean store) { this.store = store; }
}
