package com.bettersoft.api.realm;

import org.apache.shiro.authc.UsernamePasswordToken;

public class BettersoftUsernamePasswordToken extends UsernamePasswordToken {
	private static final long serialVersionUID = 4114139942941215522L;

	private String loginType;
	private String sessionId;
	private String loginPlatform;

	public BettersoftUsernamePasswordToken() {
		super();
	}

	public BettersoftUsernamePasswordToken(final String username,
			final String password) {
		super(username, password != null ? password.toCharArray() : null,
				false, null);
	}

	public BettersoftUsernamePasswordToken(final String username,
			final char[] password, final String host) {
		super(username, password, false, host);
	}

	public BettersoftUsernamePasswordToken(final String username,
			final String password, final String host) {
		super(username, password != null ? password.toCharArray() : null,
				false, host);
	}

	public BettersoftUsernamePasswordToken(final String username,
			final char[] password, final boolean rememberMe) {
		super(username, password, rememberMe, null);
	}

	public BettersoftUsernamePasswordToken(final String username,
			final String password, final boolean rememberMe) {
		super(username, password != null ? password.toCharArray() : null,
				rememberMe, null);
	}

	public BettersoftUsernamePasswordToken(final String username,
			final char[] password, final boolean rememberMe, final String host) {
		super(username, password, rememberMe, host);
	}

	public String getLoginType() {
		return loginType;
	}

	public void setLoginType(String loginType) {
		this.loginType = loginType;
	}

	public String getSessionId() {
		return sessionId;
	}

	public void setSessionId(String sessionId) {
		this.sessionId = sessionId;
	}

	public String getLoginPlatform() {
		return loginPlatform;
	}

	public void setLoginPlatform(String loginPlatform) {
		this.loginPlatform = loginPlatform;
	}
}
