package com.bettersoft.api.service.implement;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Service;

import com.bettersoft.api.dao.interfaces.IBaseDao;
import com.bettersoft.api.model.SystemConfigurationBean;
import com.bettersoft.api.service.interfaces.IAppCommonInterfaceService;
import com.bettersoft.api.utils.Constants;

@Service("appCommonInterfaceService")
public class AppCommonInterfaceService extends BaseService implements
		IAppCommonInterfaceService {
	@Resource(name = "baseDao")
	private IBaseDao baseDao;

	public Map<String, Object> findAdvertInfo() throws Exception {
		Map<String, Object> resultMap = new HashMap<String, Object>();
		SystemConfigurationBean carouselConf = baseDao
				.findConfigurationByCode(Constants.CONF_CAROUSEL_URL);

		if (null != carouselConf
				&& !StringUtils.isEmpty(carouselConf.getConfigValue())) {

			String[] carousels = StringUtils.split(
					carouselConf.getConfigValue(), ";");
			List<Map<String, Object>> carouselMaps = new ArrayList<Map<String, Object>>();
			
			for (String carousel : carousels) {
				Map<String, Object> carouselMap = new HashMap<String, Object>();
				String[] carouselUrls = StringUtils.split(carousel, "|");

				carouselMap.put("carouselImg", carouselUrls[0]);
				carouselMap.put("carouselUrl", StringUtils.EMPTY);
				if (1 < carouselUrls.length)
					carouselMap.put("carouselUrl", carouselUrls[1]);
				
				carouselMaps.add(carouselMap);
			}
			
			resultMap.put("carousels", carouselMaps);
		}

		SystemConfigurationBean bannerConf = baseDao
				.findConfigurationByCode(Constants.CONF_BANNER_URL);
		if (null != bannerConf
				&& !StringUtils.isEmpty(bannerConf.getConfigValue())) {
			String[] banners = StringUtils.split(bannerConf.getConfigValue(),
					";");
			List<Map<String, Object>> bannerMaps = new ArrayList<Map<String, Object>>();
			for (String banner : banners) {
				String[] bannerUrls = StringUtils.split(banner, "|");
				Map<String, Object> bannerMap = new HashMap<String, Object>();

				bannerMap.put("bannerImg", bannerUrls[0]);
				bannerMap.put("bannerUrl", StringUtils.EMPTY);
				if (1 < bannerUrls.length)
					bannerMap.put("bannerUrl", bannerUrls[1]);
				
				bannerMaps.add(bannerMap);
			}

			resultMap.put("banners", bannerMaps);
		}
		
		return resultMap;
	}

	@Override
	public boolean checkEntityOccupied(Serializable id) throws Exception {
		// TODO Auto-generated method stub
		return false;
	}

}
