package com.bettersoft.api.service.implement;

import java.io.Serializable;
import java.text.MessageFormat;
import java.util.List;
import java.util.Map;

import com.bettersoft.api.config.WxConfig;
import com.bettersoft.api.dao.interfaces.IOnlineorderhDao;
import com.bettersoft.api.model.OnlinePrepayBean;
import com.bettersoft.api.model.OnlineorderhBean;
import com.bettersoft.api.service.interfaces.IOnlineorderhService;
import com.bettersoft.api.utils.Constants;
import com.bettersoft.api.utils.RedisCacheUtil;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.alibaba.fastjson.JSONObject;
import com.bettersoft.api.service.interfaces.ICallJiakeApiService;
import com.bettersoft.api.service.interfaces.IOnlinePrepayService;
import com.bettersoft.api.service.interfaces.IOnlineorderpService;
import com.bettersoft.api.utils.HttpUtils;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

@Repository
public class CallJiakeApiService extends BaseService implements ICallJiakeApiService {
	@Autowired
	 private  IOnlineorderpService onlineorderpService;
	@Autowired
	 private  IOnlinePrepayService onlinePrepayService;
	@Resource(name = "redisCacheUtil")
	private RedisCacheUtil redisCacheUtil;
	@Autowired
	private IOnlineorderhService onlineorderhService;

	@Override
	public JSONObject callJiakeApi_wxUser_Service(Map<String, Object> queryParam)
			throws Exception {
		JSONObject target = new JSONObject();
		JSONObject param = new JSONObject();
		JSONObject result =null;

		param.put("code", queryParam.get("code"));
		target.put("para", param.toString());
		target.put("method", "wx_user");
//		target.put("sub_mch_id",queryParam.get("sub_mch_id"));
		target.put("sub_mch_id","1602264060");result= HttpUtils.callHttpsJiakeApiPost(target);
		
		return result;
	}

	@Override
	public boolean checkEntityOccupied(Serializable id) throws Exception {
		return false;
	}

	@Override
	@Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
	public JSONObject callJiakeApi_wxQuery_Service(
			Map<String, Object> queryParam) throws Exception {
		JSONObject target = new JSONObject();
		JSONObject param = new JSONObject();
		JSONObject result =null;

		//out_trade_no不为null时，定时任务调用
		//out_trade_no为null时，小程序调用，此时使用transaction_id
		if(queryParam.get("out_trade_no")!=null && !"".equals(queryParam.get("out_trade_no"))){
			logger.info("定时任务调用");
			param.put("out_trade_no", queryParam.get("out_trade_no"));
		}else{
//			param.put("transaction_id", queryParam.get("trade_no"));
			logger.info("小程序调用");
			List<OnlinePrepayBean> onlinePrepayBeans=onlinePrepayService.findLastOutTradeNo(queryParam.get("order_no").toString());
			logger.info(onlinePrepayBeans);
			if(onlinePrepayBeans.size()>0 && onlinePrepayBeans.get(0).getOut_trade_no()!=null){
				param.put("out_trade_no",onlinePrepayBeans.get(0).getOut_trade_no());
				queryParam.put("out_trade_no",onlinePrepayBeans.get(0).getOut_trade_no());
			}
		}
		
		target.put("para", param.toString());
		target.put("method", "wx_query");
		target.put("sub_mch_id",queryParam.get("sub_mch_id"));
		result= HttpUtils.callHttpsJiakeApiPost(target);
		
		if(result!=null && "0".equals(result.get("jk_code")) && "SUCCESS".equals(result.get("return_code")) && "SUCCESS".equals(result.get("trade_state"))){
			//如果查询  确认支付成功
			updateOnlineOrderData(queryParam, result,1);
			onlinePrepayService.sendPurchaseResult(queryParam.get("out_trade_no").toString().substring(0,19));
		}
		return result;
	}

	@Override
	public JSONObject callJiakeApi_wxCFO_Service(Map<String, Object> queryParam)
			throws Exception {
		JSONObject target = new JSONObject();
		JSONObject param = new JSONObject();
		JSONObject result =null;
		double mul = 100.0;
		//商户侧订单号(orderno对应多个out，取最新)
		param.put("out_trade_no", queryParam.get("out_trade_no"));
		//订单描述，例如：（**店消费）
		param.put("body", queryParam.get("body"));
		//人民币支付金额，以分为单位。无小数。
		param.put("total_amount", (int)(Double.parseDouble(queryParam.get("total_amount").toString())*mul));
    	//参照3.1获取，如非按3.1方式获取，则需要传商户同主体公众号的appid作为subappid
		param.put("openid", queryParam.get("openid"));
		//获取openid对应的商户公众号appid
		param.put("subappid", WxConfig.appId);
		//人民币折扣金额，以分为单位。无小数。 注：=dish_list中商品单价*数量的合计- total_amount（支付金额）
		param.put("discount_amount", (int)(Double.parseDouble(queryParam.get("discount_amount").toString())*mul));
		//点餐入口，公众号：点餐页面完整URL 小程序：点餐页面path路径
		param.put("order_entry", "/pages/main/main");
		//微信用户登录接口返回的登录票据 公众号，填写页面授权access_token，详细参考； 小程序，填写session_key，详细参考。
		param.put("login_token",queryParam.get("login_token"));
		
		//门店编号
		param.put("out_shop_no", queryParam.get("out_shop_no"));
//		param.put("out_shop_no", "12002");

		param.put("dish_list", queryParam.get("dish_list"));
		
		target.put("para", param.toString());
		target.put("method", "wx_creat_foodorder");
		target.put("sub_mch_id",queryParam.get("sub_mch_id"));
//		target.put("sub_mch_id","1602264060");

//		logger.info(param.toString());

		result= HttpUtils.callHttpsJiakeApiPost(target);
			
		return result;
	}
	@Override
	public JSONObject callJiakeApi_aliUser_Service(Map<String, Object> queryParam)
			throws Exception {
		JSONObject target = new JSONObject();
		JSONObject param = new JSONObject();
		JSONObject result =null;

		param.put("auth_code", queryParam.get("auth_code"));
		
		
		target.put("para", param.toString());
		target.put("method", "ali_user");
		target.put("sub_mch_id",queryParam.get("sub_mch_id"));
		
		result= HttpUtils.callHttpsJiakeApiPost(target);
		
		return result;
	}

	@Override
	public JSONObject callJiakeApi_aliQuery_Service(
			Map<String, Object> queryParam) throws Exception {
		JSONObject target = new JSONObject();
		JSONObject param = new JSONObject();
		JSONObject result =null;
		
		if(queryParam.get("out_trade_no")!=null && !"".equals("out_trade_no")){
			param.put("out_trade_no", queryParam.get("out_trade_no"));
		}else{
			param.put("transaction_id", queryParam.get("transaction_id"));
		}
		target.put("para", param.toString());
		target.put("method", "ali_query");
		target.put("sub_mch_id",queryParam.get("sub_mch_id"));

		result= HttpUtils.callHttpsJiakeApiPost(target);
		
		if(result!=null && "0".equals(result.get("jk_code")) && "TRADE_SUCCESS".equals(result.get("trade_status"))){ 
			//如果查询  确认支付成功
			updateOnlineOrderData(queryParam, result,2);
		}
		return result;
	}

	@Override
	public JSONObject callJiakeApi_aliCFO_Service(Map<String, Object> queryParam)
			throws Exception {
		JSONObject target = new JSONObject();
		JSONObject param = new JSONObject();
		JSONObject result =null;
		//商户侧订单号
		param.put("out_trade_no", queryParam.get("out_trade_no"));
		//订单描述，例如：（**店消费）
		param.put("subject", queryParam.get("subject"));	
		//人民币支付金额，以分为单位。无小数。
		param.put("total_amount", queryParam.get("total_amount"));
		//参照4.1获取
		param.put("buyer_id", queryParam.get("buyer_id"));
		//订单授权码(与订单一一对应） 利用订单同步前获取的formId作为订单授权码。
		param.put("order_auth_code", queryParam.get("order_auth_code"));
		//人民币折扣金额，以分为单位。无小数。 注：=dish_list中商品单价*数量的合计- total_amount（支付金额）
		param.put("discount_amount", queryParam.get("discount_amount"));
		//商品信息列表,例: \"item_order_list\":[{" + " \"item_code\":\"5010101\"," + "\"item_name\":\"奶茶\"," + "\"unit_price\":13.18," + "\"quantity\":20" + " }],"
		param.put("item_order_list", queryParam.get("item_order_list"));
	
		
		target.put("para", param.toString());
		target.put("method", "ali_creat_foodorder");
		target.put("sub_mch_id",queryParam.get("sub_mch_id"));
		
		result= HttpUtils.callHttpsJiakeApiPost(target);
			
		return result;
	}

	@Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
	public void updateOnlineOrderData(Map<String, Object> queryParam,JSONObject result,int paymentcode){
        String out_trade_no=null;
	    if(queryParam.get("out_trade_no")!=null){
		    out_trade_no=queryParam.get("out_trade_no").toString();
        }
        String orderNo=null;
        if(queryParam.get("order_no")!=null){
            orderNo=queryParam.get("order_no").toString();
        }
		String remark="";
		if(paymentcode == 1){
			//weix
			if(result.get("transaction_id")!=null){
				remark=out_trade_no + ","+result.get("transaction_id")+"";
			} else {
				remark=out_trade_no + "";
			}
		}else{
			//支付宝
			remark=out_trade_no + ","+result.get("trade_no")+"";
		}
		int line =1;
		//line=Integer.valueOf(queryParam.get("line").toString());
		try {
			logger.info("===================="+orderNo+"=============================");
			logger.info("===================="+out_trade_no+"=========================");
			logger.info("===================="+remark+"=============================");
			onlinePrepayService.updateOnlinePrepay(out_trade_no, "9");
			onlineorderpService.updateOnlineorderpRemark(orderNo,line,remark);
			onlineorderhService.removeShoppingCart(orderNo);

		} catch (Exception e) {
			logger.error("更新updateOnlinePrepay  updateOnlineorderpRemark" ,  e);
		}
	}
    // onlineorderpService.updateOnlineorderpRemark(orderNo,1,remark);
}
