package com.bettersoft.api.service.implement;

import com.alibaba.fastjson.JSONObject;
import com.bettersoft.api.config.WxConfig;
import com.bettersoft.api.dao.interfaces.IOnlinePrepayDao;
import com.bettersoft.api.dao.interfaces.IOnlineorderhDao;
import com.bettersoft.api.dao.interfaces.IOnlineorderpDao;
import com.bettersoft.api.dao.interfaces.IOnlineuserDao;
import com.bettersoft.api.encrytion.Base64Util;
import com.bettersoft.api.encrytion.DateUtils;
import com.bettersoft.api.model.*;
import com.bettersoft.api.service.interfaces.IOnlineorderhService;
import com.bettersoft.api.service.interfaces.IWxService;
import com.bettersoft.api.utils.HttpUtils;
import com.bettersoft.api.utils.RedisCacheUtil;
import com.wechat.pay.contrib.apache.httpclient.WechatPayHttpClientBuilder;
import com.wechat.pay.contrib.apache.httpclient.auth.AutoUpdateCertificatesVerifier;
import com.wechat.pay.contrib.apache.httpclient.auth.PrivateKeySigner;
import com.wechat.pay.contrib.apache.httpclient.auth.WechatPay2Credentials;
import com.wechat.pay.contrib.apache.httpclient.auth.WechatPay2Validator;
import com.wechat.pay.contrib.apache.httpclient.util.PemUtil;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.util.EntityUtils;
import org.postgresql.util.Base64;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ResourceUtils;
import org.springframework.web.client.RestTemplate;

import javax.annotation.Resource;
import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.*;
import java.nio.charset.StandardCharsets;
import java.security.PrivateKey;
import java.security.Signature;
import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.List;

@Service
public class MyWxService extends BaseService implements IWxService {

    @Resource(name = "redisCacheUtil")
    private RedisCacheUtil redisCacheUtil;

    @Resource(name = "onlineorderhDao")
    private IOnlineorderhDao onlineorderhDao;

    @Resource(name = "onlineorderpDao")
    private IOnlineorderpDao onlineorderpDao;

    @Resource(name = "onlineuserDao")
    private IOnlineuserDao onlineuserDao;

    @Autowired
    private IOnlinePrepayDao onlinePrepayDao;

    @Autowired
    private IOnlineorderhService onlineorderhService;
    @Autowired
    private CallJiakeApiService callJiakeApiService;

    @Override
    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public Object dealLoginAuth(String code) {
       RestTemplate restTemplate = new RestTemplate();
        //调微信官方接口获得sesssion_key openid存到 session对象里
        try {
            //code换取sessionKey
            HttpHeaders headers = new HttpHeaders();
            JSONObject param = new JSONObject();
            param.put("appid", WxConfig.appId);
            param.put("secret", WxConfig.secret);
            param.put("js_code",code);
            param.put("grant_type","authorization_code");
            HttpEntity<JSONObject> request = new HttpEntity<JSONObject>(param, headers);
            String bodyAsString = restTemplate.getForObject(WxConfig.JSCODE_TO_SESSION_URL, String.class,param);
            JSONObject bodyAsJson = JSONObject.parseObject(bodyAsString);
//            session.setSessionKey(bodyAsJson.getString("session_key"));
            JSONObject result = new JSONObject();
            result.put("openid",bodyAsJson.getString("openid"));
            result.put("unionid",bodyAsJson.getString("unionid"));
//            JSONObject result = new JSONObject();
//            result.put("openid","aaa");
//            result.put("unionid","testunionid");
            result.put("sessionKey",bodyAsJson.getString("session_key"));
            OnlineUserBean onlineUserBean = onlineuserDao.findEntity(OnlineUserBean.class,result.getString("openid"));
            if(onlineUserBean==null){
                onlineUserBean = new OnlineUserBean();
                onlineUserBean.setOpenid(result.getString("openid"));
                onlineUserBean.setUnionid(result.getString("unionid"));
//                onlineUserBean.setBrandcode("A01");
                onlineUserBean.setCreatDate(new Date());
                onlineUserBean.setUpdateDate(new Date());
                onlineuserDao.saveOrUpdate(onlineUserBean);
            } else {
                onlineUserBean.setUnionid(result.getString("unionid"));
                onlineUserBean.setOpenid(result.getString("openid"));
                onlineUserBean.setUpdateDate(new Date());
                onlineuserDao.saveOrUpdate(onlineUserBean);
            }
            result.put("phone","");
            result.put("day", DateUtils.addDate(DateUtils.format(new Date()),7));
            return Base64Util.encryptBASE64(result.toString().getBytes(StandardCharsets.UTF_8));
        } catch (Exception e) {
            this.logger.error("获得sessionKey失败", e);
        }
        return null;
    }

    @Override
    public boolean checkEntityOccupied(Serializable id) throws Exception {
        return false;
    }


    @Override
    public Object wxPay(String openId, String storeCode, String tableCode) {
        try {
            //1. 获取订单编号
            OnlineorderhBean order = onlineorderhDao.findLastOnlineOrder(storeCode, tableCode);
            String orderNo = order.getOrderno();
            //2. 调用微信统一下单接口
            Map<String, Object> result = new HashMap<String, Object>();
            JSONObject paramMap = new JSONObject();
            paramMap.put("appid",WxConfig.appId);
            paramMap.put("mchid",WxConfig.mch_id);
            paramMap.put("description","茑屋线下点菜");
            paramMap.put("out_trade_no",orderNo);
            //回调地址分两种，站立式点单和桌位点单
            paramMap.put("notify_url",WxConfig.notify_url+"/online/buyCart/paymentOrder");  //TODO    回调通知地址
            JSONObject amount = new JSONObject();
            amount.put("total",(long)(order.getAmountyf()*100));
            amount.put("currency","CNY");   //货币类型
            paramMap.put("amount",amount);
            JSONObject payer = new JSONObject();
            payer.put("openid",openId);
            paramMap.put("payer",payer);

            //获取商户私钥，需要证书，放在resource目录下
            PrivateKey merchantPrivateKey = PemUtil.loadPrivateKey(new FileInputStream(ResourceUtils.getFile("classpath:apiclient_key.pem")));
            AutoUpdateCertificatesVerifier verifier = new AutoUpdateCertificatesVerifier(
                    new WechatPay2Credentials(WxConfig.mch_id,new PrivateKeySigner(WxConfig.mch_serial_number,merchantPrivateKey)),
                    WxConfig.apiV3key.getBytes(StandardCharsets.UTF_8));
            WechatPayHttpClientBuilder builder = WechatPayHttpClientBuilder.create()
                    .withMerchant(WxConfig.mch_id,WxConfig.mch_serial_number,merchantPrivateKey)
                    .withValidator(new WechatPay2Validator(verifier));
            HttpClient httpClient = builder.build();

            HttpPost httpPost = new HttpPost("https://api.mch.weixin.qq.com/v3/pay/transactions/jsapi");
            httpPost.addHeader("Accept", "application/json");
            httpPost.addHeader("Content-type","application/json; charset=utf-8");
            httpPost.setEntity(new StringEntity(paramMap.toJSONString(),"UTF-8"));

            HttpResponse response = httpClient.execute(httpPost);
            String bodyAsString = EntityUtils.toString(response.getEntity());

            JSONObject bodyAsJSON = JSONObject.parseObject(bodyAsString);
            final String prepay_id = bodyAsJSON.getString("prepay_id");
            if(bodyAsJSON.containsKey("code")){
                throw new Exception();
            }
            final String timeStamp = String.valueOf(System.currentTimeMillis());
            final String nonceStr = this.getRandomStringByLength(32);
            result.put("appid",WxConfig.appId);
            result.put("timeStamp",timeStamp);
            result.put("nonceStr",nonceStr);
            result.put("prepay_id",prepay_id);
            result.put("signType","RSA");
            String paySign = this.generatePaySign(WxConfig.appId,timeStamp,nonceStr,prepay_id,merchantPrivateKey);
            if(paySign==null){
                throw new Exception();
            }
            result.put("paySign",paySign);
            return result;
        } catch (Exception e) {
            return null;
        }
    }

    @Override
    public Object wxSubscribeMessage(String orderNo) {
        RestTemplate restTemplate = new RestTemplate();
        try {
            Map<String, Object> queryParam = new HashMap<String, Object>();
            queryParam.put("orderno",orderNo);
            OnlineorderhBean order = onlineorderhDao.findEntity(OnlineorderhBean.class,orderNo);
            StoreBean store = onlineorderhDao.findEntity(StoreBean.class,order.getStrstorecode());
            JSONObject paramMap = new JSONObject();
            paramMap.put("touser",order.getOpenId());
            paramMap.put("template_id",WxConfig.template_id);
            JSONObject data = new JSONObject();
            JSONObject temp1 = new JSONObject();
            temp1.put("value","Q"+String.format("%04d", order.getDaysn()));
            data.put("character_string19",temp1);
            JSONObject temp2 = new JSONObject();
            if(store.getStrStoreName().length()>=18){
                temp2.put("value",store.getStrStoreName().substring(0,16)+"...");
            } else {
                temp2.put("value",store.getStrStoreName());
            }
            data.put("thing23",temp2);
            JSONObject temp3 = new JSONObject();
            if(store.getStrAddr().length()>=18){
                temp3.put("value",store.getStrAddr().substring(0,16)+"...");
            } else {
                temp3.put("value",store.getStrAddr());
            }
            data.put("thing24",temp3);
            JSONObject temp4 = new JSONObject();
            temp4.put("value","您的餐品已制作完成，请凭取餐码到店取餐。");
            data.put("thing7",temp4);
            paramMap.put("data",data);
            //ADD BY GM 2022.9.15 STR
            paramMap.put("page","pages/orderList/orderList");
            paramMap.put("miniprogram_state","formal");
            //ADD BY GM 2022.9.15 END
            HttpHeaders headers = new HttpHeaders();
            HttpEntity<JSONObject> request = new HttpEntity<JSONObject>(paramMap, headers);
            Map<String, Object> param = new HashMap<>();
            param.put("access_token",redisCacheUtil.getCache("access_token"));
            String bodyAsString = restTemplate.postForObject(WxConfig.WX_SUBSCRIBE_MESSAGE,request,String.class,param);
            JSONObject bodyAsJson = JSONObject.parseObject(bodyAsString);
            if(!bodyAsJson.getString("errcode").equals("0")){
                if(bodyAsJson.getString("errcode").equals("42001")){
                    HttpHeaders headerToken = new HttpHeaders();
                    JSONObject paramToken = new JSONObject();
                    paramToken.put("grant_type","client_credential");
                    paramToken.put("appid",WxConfig.appId);
                    paramToken.put("secret", WxConfig.secret);
                    HttpEntity<JSONObject> requestToken = new HttpEntity<JSONObject>(paramToken, headerToken);
                    GetAccess getAccess = restTemplate.getForObject(WxConfig.GET_ACCESS_TOKEN_URL, GetAccess.class,paramToken);
                    redisCacheUtil.setCache("access_token",getAccess.getAccess_token());
                    param.put("access_token",redisCacheUtil.getCache("access_token"));
                    bodyAsString = restTemplate.postForObject(WxConfig.WX_SUBSCRIBE_MESSAGE,request,String.class,param);
                    bodyAsJson = JSONObject.parseObject(bodyAsString);
                    if(bodyAsJson.getString("errcode").equals("0")){
                        return "发送成功!";
                    } else {
                        logger.info(bodyAsJson.getString("errmsg")+bodyAsJson.getString(" errcode"));
                        return bodyAsJson.getString("errmsg")+bodyAsJson.getString(" errcode");
                    }
                } else {
                    logger.info(bodyAsJson.getString("errmsg")+bodyAsJson.getString(" errcode"));
                    return bodyAsJson.getString("errmsg")+bodyAsJson.getString(" errcode");
                }
            }
            return "发送成功!";
        } catch (Exception e) {
            logger.error(e.getMessage(),e);
            return "未知异常!";
        }
    }

    public String generatePaySign(String appid, String timeStamp, String nonceStr, String prepay_id, PrivateKey merchantPrivateKey) {
        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append(appid+"\n");
        stringBuffer.append(timeStamp+"\n");
        stringBuffer.append(nonceStr+"\n");
        stringBuffer.append("prepay_id="+prepay_id+"\n");
        try {
            Signature signature = Signature.getInstance("SHA256withRSA");
            signature.initSign(merchantPrivateKey);
            signature.update(stringBuffer.toString().getBytes(StandardCharsets.UTF_8));
            byte[] signBytes = signature.sign();
            return Base64.encodeBytes(signBytes);
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }

    }

//    public String generateToken() {
//        //通过当前时间毫秒值和随机函数 获取一个随机数
//        String token = System.currentTimeMillis() + new Random().nextInt() + "";
//

    @Override
    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public Object wxGetPhone(String code,String token) {
        RestTemplate restTemplate = new RestTemplate();
        try {
            JSONObject paramMap = new JSONObject();
            paramMap.put("code",code);
            HttpHeaders headers = new HttpHeaders();
            HttpEntity<JSONObject> request = new HttpEntity<JSONObject>(paramMap, headers);
            Map<String, Object> param = new HashMap<>();
            param.put("access_token",redisCacheUtil.getCache("access_token"));
            String bodyAsString = restTemplate.postForObject(WxConfig.WX_GET_PHONE,request,String.class,param);
            JSONObject bodyAsJson = JSONObject.parseObject(bodyAsString);
            logger.info(bodyAsJson);
            if(bodyAsJson==null||bodyAsJson.getString("errcode")==null||!bodyAsJson.getString("errcode").equals("0")){
                logger.info(bodyAsJson);
                logger.info("重新获取access_token后继续获取手机号!");
                HttpHeaders headerToken = new HttpHeaders();
                JSONObject paramToken = new JSONObject();
                paramToken.put("grant_type","client_credential");
                paramToken.put("appid",WxConfig.appId);
                paramToken.put("secret", WxConfig.secret);
                HttpEntity<JSONObject> requestToken = new HttpEntity<JSONObject>(paramToken, headerToken);
                GetAccess getAccess = restTemplate.getForObject(WxConfig.GET_ACCESS_TOKEN_URL, GetAccess.class,paramToken);
                redisCacheUtil.setCache("access_token",getAccess.getAccess_token());
                param.put("access_token",redisCacheUtil.getCache("access_token"));
                bodyAsString = restTemplate.postForObject(WxConfig.WX_GET_PHONE,request,String.class,param);
                bodyAsJson = JSONObject.parseObject(bodyAsString);
                if(bodyAsJson==null||bodyAsJson.getString("errcode")==null||!bodyAsJson.getString("errcode").equals("0")) {
                    logger.info(bodyAsJson);
                    throw new Exception();
                }
            }
            String str = new String(Base64Util.decryBASE64(token));
            JSONObject strAsJson = JSONObject.parseObject(str);
            strAsJson.put("phone",bodyAsJson.getJSONObject("phone_info").get("phoneNumber"));
            OnlineUserBean onlineUserBean = new OnlineUserBean();
            onlineUserBean = onlineuserDao.findEntity(onlineUserBean.getClass(),strAsJson.getString("openid"));
            onlineUserBean.setMembermobile(strAsJson.getString("phone"));
            onlineuserDao.saveOrUpdate(onlineUserBean);
            return Base64Util.encryptBASE64(strAsJson.toString().getBytes(StandardCharsets.UTF_8));
        } catch (Exception e) {
//            e.printStackTrace();
            logger.error(e.getMessage(),e);
            return null;
        }
    }

//    @Override
//    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
//    public List<JSONObject> getStore(String openId,String city) throws Exception{
//        try {
//            List<JSONObject> jsonObjects = new ArrayList<>();
//            List<Map<String,Object>> latestOrder = new ArrayList<>();
//            if(openId!=null){
//                latestOrder = onlineorderhDao.generalSearchBySql("select onlineorderh.* from onlineorderh where openid = '"+ openId+ "'",null," order by dtorderstart desc limit 1");
//            } else {
//                latestOrder = null;
//            }
//            if(latestOrder!=null&&latestOrder.size()!=0){
//                List<Map<String,Object>> latestStore = onlineorderhDao.generalSearchBySql("select store.* from store where strstorecode = '" + latestOrder.get(0).get("strstorecode")+ "'",null,null);
//                if(StringUtils.isBlank(city) || latestStore.get(0).get("strcontactname").equals(city)){
//                    JSONObject temp = new JSONObject();
//                    temp.put("storeCode",latestStore.get(0).get("strstorecode"));
//                    temp.put("storeName",latestStore.get(0).get("strstorename"));
//                    temp.put("storeAddress",latestStore.get(0).get("straddr"));
//                    temp.put("strcontactname",latestStore.get(0).get("strcontactname"));
//                    temp.put("begin",latestStore.get(0).get("dtmtradebegin").toString().substring(11));
//                    temp.put("end",latestStore.get(0).get("dtmtradeend").toString().substring(11));
//                    temp.put("flag","1");
//                    jsonObjects.add(temp);
//                }
//            }
//            List<Map<String,Object>> stores;
//            if(StringUtils.isNotBlank(city)){
//                if(latestOrder!=null&&latestOrder.size()!=0){
//                    stores = onlineorderhDao.generalSearchBySql(
//                            "select store.* from store where strcontactname = '" +city + "' and strstorecode != '" + latestOrder.get(0).get("strstorecode")+"'",null,null);
//                } else {
//                    stores = onlineorderhDao.generalSearchBySql(
//                            "select store.* from store where strcontactname = '" +city + "'",null,null);
//                }
//            } else {
//                if(latestOrder!=null&&latestOrder.size()!=0) {
//                    stores = onlineorderhDao.generalSearchBySql(
//                            "select store.* from store where strstorecode != '" + latestOrder.get(0).get("strstorecode") + "'", null, null);
//                } else {
//                    stores = onlineorderhDao.generalSearchBySql(
//                            "select store.* from store", null, null);
//                }
//            }
//            for(Map<String,Object> store:stores){
//                JSONObject temp = new JSONObject();
//                temp.put("storeCode",store.get("strstorecode"));
//                temp.put("storeName",store.get("strstorename"));
//                temp.put("storeAddress",store.get("straddr"));
//                temp.put("strcontactname",store.get("strcontactname"));
//                temp.put("begin",store.get("dtmtradebegin").toString().substring(11));
//                temp.put("end",store.get("dtmtradeend").toString().substring(11));
//                temp.put("flag","0");
//                jsonObjects.add(temp);
//            }
//            return jsonObjects;
//        } catch (Exception e) {
//            e.printStackTrace();
//            throw e;
//        }
//    }

    @Override
    public List<JSONObject> getStore(String openId, String city) throws Exception {
        List<JSONObject> jsonObjects = new ArrayList<>();
        List<Map<String,Object>> latestOrder = new ArrayList<>();
        latestOrder = onlineorderhDao.generalSearchBySql("select store.* from store where strcontactname = '" +city + "'",null,null);

        for(Map<String,Object> store:latestOrder){
                JSONObject temp = new JSONObject();
                temp.put("storeCode",store.get("strstorecode"));
                temp.put("storeName",store.get("strstorename"));
                temp.put("storeAddress",store.get("straddr"));
                temp.put("strcontactname",store.get("strcontactname"));
                SimpleDateFormat simpleDateFormatdedate = new SimpleDateFormat ("HH:mm");
                Calendar calendar = Calendar.getInstance();
                if(store.get("dtmtradebegin")!=null){
                    temp.put("begin", simpleDateFormatdedate.format(store.get("dtmtradebegin")));
                } else {
                    temp.put("begin","--:--");
                }
                if(store.get("dtmtradeend")!=null){
                    logger.info(store.get("dtmtradeend"));
                    calendar.setTime((Date) store.get("dtmtradeend"));
                    logger.info(calendar.getTime());
                    calendar.add(Calendar.MINUTE,-10);
                    logger.info(calendar.getTime());
                    temp.put("end", simpleDateFormatdedate.format(calendar.getTime()));
                } else {
                    temp.put("end","--:--");
                }
                if(store.get("strcontactname")=="北京" ||store.get("strcontactname").equals("北京")){
                    temp.put("flag","1");
                }else{
                    temp.put("flag","0");
                }
                jsonObjects.add(temp);
            }
        return jsonObjects;
    }

    @Override
    public List<String> getStoreCity() {
        List<String> citys = new ArrayList<>();
        List<Map<String,Object>> stores = onlineorderhDao.generalSearchBySql(
                "select t.strcontactname FROM (select distinct(strcontactname) from store where strcontactname!=' ') as t ",null,"order by case t.strcontactname when '北京' then 1 else 2 end");
        for(Map<String,Object> store:stores){
            if(!citys.contains(store)){
                citys.add(store.get("strcontactname").toString());
            }
        }
        return citys;
    }

    @Override
    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public JSONObject wxCallJiakePay(String storeCode,String tableCode,String openId,String loginToken) {
        Map<String,Object> queryMap = new HashMap<>();
        try {
            OnlineorderhBean order = onlineorderhDao.findLastOnlineOrder(storeCode,tableCode);
            if(order!=null){
                List<OnlineorderdBean> orderDetails = onlineorderhService.searchOrderDetails(order.getOrderno());
                //构建入参
                //商户侧订单号
                queryMap.put("out_trade_no", order.getOrderno());
                //订单描述，例如：（**店消费）
                queryMap.put("body", "店号"+storeCode+"消费");
                //人民币支付金额，以分为单位。无小数。
                queryMap.put("total_amount", order.getAmountyf()*100);
                //参照3.1获取，如非按3.1方式获取，则需要传商户同主体公众号的appid作为subappid
                queryMap.put("openid", openId);
                //获取openid对应的商户公众号appid
                queryMap.put("subappid", WxConfig.appId);
                //人民币折扣金额，以分为单位。无小数。 注：=dish_list中商品单价*数量的合计- total_amount（支付金额）
                queryMap.put("discount_amount", order.getDiscountamount()*100);
                //点餐入口，公众号：点餐页面完整URL 小程序：点餐页面path路径
                queryMap.put("order_entry", "");
                //微信用户登录接口返回的登录票据 公众号，填写页面授权access_token，详细参考； 小程序，填写session_key，详细参考。
                queryMap.put("login_token", loginToken);
                //门店编号
                queryMap.put("out_shop_no", storeCode);
                //所点商品明细，不知道具体什么格式
                queryMap.put("dish_list", "");
                queryMap.put("sub_mch_id",WxConfig.mch_id);
                //在jiake系统创建支付订单
                logger.info("======================创建参数完成，开始创建订单=============================");
                JSONObject result = callJiakeApiService.callJiakeApi_wxCFO_Service(queryMap);
                //通过result判断是否插入成功，暂时写成下面这样，不知道result返回信息
                if(result==null || !"0".equals(result.get("jk_code"))){
                    logger.info("=======================创建订单失败=============================");
                    return result;
                } else {
                    logger.info("=======================创建订单成功=============================");
                    OnlinePrepayBean prePay = new OnlinePrepayBean();
                    OnlineorderpBean orderPay = new OnlineorderpBean();
                    orderPay.setOrderno(order.getOrderno());
                    orderPay.setLine(1);
                    orderPay.setAmount(order.getAmountyf());
                    orderPay.setOpenid(openId);
                    orderPay.setPaymentcode(1);
                    //支付名称，三方支付订单号暂定
                    orderPay.setPaymentname("");
                    orderPay.setIf_orderno("");
                    onlineorderpDao.saveOrUpdate(orderPay);
                    prePay.setStatus(0);
                    prePay.setAmount(order.getAmountyf().toString());
                    prePay.setPaymentcode(1);
                    prePay.setOrderno(order.getOrderno());
                    //三方支付订单号暂定
                    prePay.setOut_trade_no("");
                    onlinePrepayDao.saveOrUpdate(prePay);
                    logger.info("======================创建本地订单完成，开始支付=====================");
                    //开始支付
                    queryMap.clear();
                    //创建支付参数，code未知
                    logger.info("========================创建支付参数，开始支付============================");
                    queryMap.put("code","");
                    JSONObject resultPay = callJiakeApiService.callJiakeApi_wxUser_Service(queryMap);
                    if(resultPay==null || !"0".equals(resultPay.get("jk_code"))){
                        logger.info("===============================支付失败====================");
                    }
                    return resultPay;
                }
            } else {
                String re = "不存在订单";
                JSONObject jsonObject = new JSONObject();
                jsonObject.put("jk_msg",re);
                return jsonObject;
            }
        } catch (Exception e) {
            e.printStackTrace();
            String re = "支付失败,请重试!";
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("jk_msg",re);
            return jsonObject;
        }
    }

    //        //由于上述获取的随机数长度不定  所以要采用数据摘要类获取固定长度的随机数  MessageDigest
//        try {
//            MessageDigest md = MessageDigest.getInstance("md5");
//            byte[] md5 = md.digest(token.getBytes());
//
//            //又由于md5数组如果转换为字符串基本上会是乱码  所以要用Base64Encoder 来进行转换  成字符串
//            Base64.Encoder encoder = Base64.getEncoder();
//            return Arrays.toString(encoder.encode(md5));
//
//
//        } catch (NoSuchAlgorithmException e) {
//            throw new RuntimeException();
//        }
//    }

//    @Override
//    public String wxGetOrderUnlimited(String code) {
//        RestTemplate restTemplate = new RestTemplate();
//        try {
//            HttpHeaders headers = new HttpHeaders();
//            JSONObject param = new JSONObject();
//            param.put("scene", "code="+code);
//            param.put("env_version","trial");
//            param.put("page","pages/index/index");
//            param.put("check_path",false);
//            HttpEntity<JSONObject> request = new HttpEntity<JSONObject>(param, headers);
//            Map<String, Object> accessToken = new HashMap<>();
//            accessToken.put("access_token",redisCacheUtil.getCache("access_token"));
//            byte[] imageAsString = restTemplate.postForObject(WxConfig.WX_GET_ORDER,request, byte[].class,accessToken);
////            logger.info(restTemplate.postForObject(WxConfig.WX_GET_ORDER,request, String.class,accessToken));
////            for(int i = 0; i < b.length; ++i) {
////                if (b[i] < 0) {
////                    b[i] += 256;
////                }
////            }
//            ByteArrayInputStream bais = new ByteArrayInputStream(imageAsString);
//            BufferedImage bi1 = ImageIO.read(bais);
//            File w2 = new File("D://tangshi.jpg");// 可以是jpg,png,gif格式ImageIO.read
//            ImageIO.write(bi1, "jpg", w2);// 不管输出什么格式图片，此处不需改动
//            return new String(imageAsString);
//        } catch (Exception e) {
//            this.logger.error("获取图片失败!", e);
//        }
//        return null;
//    }

    @Override
    public List<String> wxGetOrderUnlimited(String storeCode, String beginCode, String endCode, String flag) {
        try {
            List<String> path=new ArrayList<>();
            if(flag!=null && flag.equals("1")){
                String code=String.format("%08d",Integer.parseInt(storeCode));
                code=code+"99";
                String urlPathName= MessageFormat.format(WxConfig.codeImgUrl, storeCode, code)+".jpg";
                path.add(urlPathName);
            }
            else {
                for (int i = Integer.parseInt(beginCode); i <=Integer.parseInt(endCode) ; i++) {
                    String code=String.format("%08d",Integer.parseInt(storeCode));
                    code=code+String.format("%02d",i);
                    String urlPathName=MessageFormat.format(WxConfig.codeImgUrl, storeCode, code)+".jpg";
                    path.add(urlPathName);
                }
            }
            return path;
        } catch (Exception e) {
            this.logger.error("获取图片失败!", e);
            return null;
        }
    }

    @Override
    public void wxSetOrderUnlimited(String storeCode, String beginCode, String endCode, String flag) {
        RestTemplate restTemplate = new RestTemplate();
        try {
            String path="D:\\apache-tomcat-9.0.87\\webapps\\uatqrordercodeimg\\"+storeCode+"\\";
            File folder = new File(path);
            if (!folder.exists() && !folder.isDirectory()) {
                folder.mkdirs();
            }
            HttpHeaders headers = new HttpHeaders();
            if(flag!=null && flag.equals("1")){
                String code=String.format("%08d",Integer.parseInt(storeCode));
                code=code+"99";
                JSONObject param = new JSONObject();
                param.put("scene", "code="+code);
//                param.put("env_version","develop");
//                param.put("env_version","trial");
                param.put("env_version","release");
                param.put("page","pages/index/index");
                param.put("width","1280");
                param.put("check_path",false);
                HttpEntity<JSONObject> request = new HttpEntity<JSONObject>(param, headers);
                Map<String, Object> accessToken = new HashMap<>();
                accessToken.put("access_token",redisCacheUtil.getCache("access_token"));
                byte[] imageAsString = restTemplate.postForObject(WxConfig.WX_GET_ORDER,request, byte[].class,accessToken);
                logger.info(imageAsString);
                ByteArrayInputStream bais = new ByteArrayInputStream(imageAsString);
                BufferedImage bi1 = ImageIO.read(bais);
//                FileSystemView systemView = FileSystemView.getFileSystemView();
//                File homeDirectory = systemView.getHomeDirectory();
//                //桌面路径
//                String path = homeDirectory.getPath()+"\\";
                String pathname=path+code+".jpg";
                File w2 = new File(pathname);// 可以是jpg,png,gif格式ImageIO.read
                ImageIO.write(bi1, "jpg", w2);// 不管输出什么格式图片，此处不需改动
            }
            else {
                for (int i = Integer.parseInt(beginCode); i <=Integer.parseInt(endCode) ; i++) {
                    String code=String.format("%08d",Integer.parseInt(storeCode));
                    code=code+String.format("%02d",i);
                    JSONObject param = new JSONObject();
                    param.put("scene", "code="+code);
//                    param.put("env_version","develop");
//                    param.put("env_version","trial");
                    param.put("env_version","release");
                    param.put("page","pages/index/index");
                    param.put("width","1280");
                    param.put("check_path",false);
                    HttpEntity<JSONObject> request = new HttpEntity<JSONObject>(param, headers);
                    Map<String, Object> accessToken = new HashMap<>();
                    accessToken.put("access_token",redisCacheUtil.getCache("access_token"));
                    byte[] imageAsString = restTemplate.postForObject(WxConfig.WX_GET_ORDER,request, byte[].class,accessToken);
                    logger.info(imageAsString);
                    ByteArrayInputStream bais = new ByteArrayInputStream(imageAsString);
                    BufferedImage bi1 = ImageIO.read(bais);
//                    FileSystemView systemView = FileSystemView.getFileSystemView();
//                    File homeDirectory = systemView.getHomeDirectory();
//                    //桌面路径
//                    String path = homeDirectory.getPath()+"\\";
                    String pathname=path+code+".jpg";
                    File w2 = new File(pathname );// 可以是jpg,png,gif格式ImageIO.read
                    ImageIO.write(bi1, "jpg", w2);// 不管输出什么格式图片，此处不需改动
                }

            }
        } catch (Exception e) {
            this.logger.error("生成图片失败!", e);
        }
    }
    public String getRandomStringByLength(int length){
        String base = "abcdefghijklmnopqrstuvwxyz0123456789";
        Random random = new Random();
        StringBuffer sb = new StringBuffer();
        for(int i = 0;i<length;i++){
            int number = random.nextInt(base.length());
            sb.append(base.charAt(number));
        }
        return sb.toString();
    }

    @Override
    public String getUrl() {
        RestTemplate restTemplate = new RestTemplate();
        try {
            JSONObject paramMap = new JSONObject();
            paramMap.put("env_version","trial");
            paramMap.put("query","0002100177");
            paramMap.put("expire_type","0");
            paramMap.put("expire_time","30");
            HttpHeaders headers = new HttpHeaders();
            HttpEntity<JSONObject> request = new HttpEntity<JSONObject>(paramMap, headers);
            Map<String, Object> param = new HashMap<>();
            param.put("access_token",redisCacheUtil.getCache("access_token"));
            String bodyAsString = restTemplate.postForObject(WxConfig.WX_GET_URL,request,String.class,param);
            JSONObject bodyAsJson = JSONObject.parseObject(bodyAsString);
            if(!bodyAsJson.getString("errcode").equals("0")){
                if(bodyAsJson.getString("errcode").equals("40001")){
                    HttpHeaders headerToken = new HttpHeaders();
                    JSONObject paramToken = new JSONObject();
                    paramToken.put("grant_type","client_credential");
                    paramToken.put("appid",WxConfig.appId);
                    paramToken.put("secret", WxConfig.secret);
                    HttpEntity<JSONObject> requestToken = new HttpEntity<JSONObject>(paramToken, headerToken);
                    GetAccess getAccess = restTemplate.getForObject(WxConfig.GET_ACCESS_TOKEN_URL, GetAccess.class,paramToken);
                    redisCacheUtil.setCache("access_token",getAccess.getAccess_token());
                    param.put("access_token",redisCacheUtil.getCache("access_token"));
                    bodyAsString = restTemplate.postForObject(WxConfig.WX_GET_URL,request,String.class,param);
                    bodyAsJson = JSONObject.parseObject(bodyAsString);
                    if(!bodyAsJson.getString("errcode").equals("0")){
                        logger.info(bodyAsString);
                        return bodyAsString;
                    }
                } else {
                    logger.info(bodyAsString);
                    return bodyAsString;
                }
            } else {
                return bodyAsJson.getString("url_link");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public boolean checkStoreStatus(String storeId) throws Exception {
        Number latestOrder = onlineorderhDao.generalCountByFullSql("select count(*) from store where strstorecode = '"+storeId+"' AND to_char(now(),'HH24:MI:SS') >= to_char(store.dtmtradebegin,'HH24:MI:SS') and to_char(now(),'HH24:MI:SS') <to_char(store.dtmtradeend,'HH24:MI:SS')");

        if(latestOrder!=null&&latestOrder.intValue()!=0){
            logger.info("检查店铺信息,当前时间:"+DateUtils.format(new Date(),DateUtils.DATE_TIME_PATTERN));
            return true;
//            Map<String,Object> store = latestOrder.get(0);
//            if(store.get("dtmtradebegin")!=null&&store.get("dtmtradeend")!=null){
//                SimpleDateFormat simpleDateFormatdate = new SimpleDateFormat ("HH:mm");
//                Date begin = simpleDateFormatdate.parse(DateUtils.format((Date) store.get("dtmtradebegin"),DateUtils.DATE_TIME_PATTERN));
//                Date end = simpleDateFormatdate.parse(DateUtils.format((Date) store.get("dtmtradeend"),DateUtils.DATE_TIME_PATTERN));
//                Date now = simpleDateFormatdate.parse(DateUtils.format(new Date(),DateUtils.DATE_TIME_PATTERN));
//                if(now.before(end)&&now.after(begin)){
//                    logger.info("检查店铺信息,当前时间:"+now+",开始时间:"+begin+",结束时间:"+ end);
//                    return true;
//                } else {
//                    logger.info("检查店铺信息,当前时间:"+now+",在开始时间:"+begin+"之前或者结束时间:"+ end +"之后!");
//                    return false;
//                }
//            } else {
//                logger.error("检查店铺信息,店铺缺少开始时间"+store.get("dtmtradebegin" +"或者结束时间"+store.get("dtmtradeend")));
//                return false;
//            }
        } else {
            logger.error("检查店铺信息,不存在该店铺或者该店铺不在营业时间内!");
            return false;
        }
    }
}
