package com.bettersoft.api.service.implement;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.*;

import javax.annotation.Resource;

import com.bettersoft.api.config.WxConfig;
import com.bettersoft.api.dao.interfaces.*;
import com.bettersoft.api.encrytion.DateUtils;
import com.bettersoft.api.encrytion.MD5Util;
import com.bettersoft.api.model.*;
import com.bettersoft.api.utils.HttpUtils;
import com.bettersoft.api.utils.RedisCacheUtil;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.alibaba.fastjson.JSONObject;
import com.bettersoft.api.service.interfaces.ICallJiakeApiService;
import com.bettersoft.api.service.interfaces.IOnlinePrepayService;
import com.bettersoft.api.task.OnlineOrderTask;
import com.bettersoft.api.utils.ConfigParamHelper;
import com.bettersoft.api.utils.Constants.CommonConsts;
import org.springframework.web.client.RestClientException;
import org.springframework.web.client.RestTemplate;

@Repository
public class OnlinePrepayService extends BaseService implements IOnlinePrepayService {
    @Resource(name = "onlinePrepayDao")
    private IOnlinePrepayDao onlinePrepayDao;
    @Autowired
    private IOnlineorderpDao onlineorderpDao;
    @Autowired
    private ICallJiakeApiService callJiakeApiService;
    @Resource
    private ConfigParamHelper configParam;
    @Resource
    private RestTemplate restTemplate;
    @Resource
    private IOnlineuserDao onlineuserDao;
    @Resource
    private IOnlineorderhDao onlineorderhDao;
    @Resource
    private IOnlinestoreDao onlinestoreDao;
    @Resource(name = "redisCacheUtil")
    private RedisCacheUtil redisCacheUtil;

    @Override
    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void saveOnlinePrepay(JSONObject jsonObject, Map<String, Object> map, int flag) {

        try {
            String amount = "";
            String paymentCode = "";
            String brandcode = configParam.getBrandCode();
            String orderno = "";
            if (map.get("orderno") != null) {
                orderno = map.get("orderno").toString();
            }
            String out_trade_no = map.get("out_trade_no").toString();
            String strstorecode = map.get("out_shop_no").toString();

            if (flag == 1) {
                paymentCode = configParam.getWxPaymentCode();
                Float floatAmount = Float.valueOf(map.get("total_amount").toString());
                amount = floatAmount.toString();
            } else {
                paymentCode = configParam.getAliPaymentCode();
                amount = map.get("total_amount").toString();
            }

            //String paydate=jsonObject.get("paytimestamp")+"";
            SimpleDateFormat formatter = new SimpleDateFormat(CommonConsts.STANDARD_DATETIME_FORMAT);
            String paydate = formatter.format(new Date());
            onlinePrepayDao.saveOnlinePrepay(brandcode, orderno, out_trade_no, paymentCode, amount, paydate, "0", strstorecode);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            logger.error("saveOnlinePrepay error  参数为：" + map, e);
        }
    }


    public List<Map<String, Object>> searchList(Map<String, Object> map) throws Exception {
        // TODO Auto-generated method stub
        return onlinePrepayDao.searchList(map);
    }

    public List<OnlinePrepayBean> searchListbean(Map<String, Object> map) throws Exception {
        // TODO Auto-generated method stub
        return onlinePrepayDao.searchListBean(map);
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void updateOnlinePrepay(String out_trade_no,
                                   String status) throws Exception {
        // TODO Auto-generated method stub
        OnlinePrepayBean order = onlinePrepayDao.findEntity(OnlinePrepayBean.class, out_trade_no);
        order.setStatus(9);
        if (null == order)
            throw new ClassNotFoundException(out_trade_no);

//		onlinePrepayDao.updateOnlinePrepay(out_trade_no, "9");
        onlinePrepayDao.saveOrUpdate(order);
        saveOnlinePay(out_trade_no);
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void saveOnlinePay(String orderNo) throws Exception {
        // TODO Auto-generated method stub
        OnlinePrepayBean order = onlinePrepayDao.findEntity(OnlinePrepayBean.class, orderNo);
        OnlineorderhBean onlineorderhBean = onlineorderpDao.findEntity(OnlineorderhBean.class, order.getOrderno());
        if (9 != order.getStatus())
            throw new ClassNotFoundException(orderNo);
        String insertSql = "insert into onlineorderp (amount, brandcode, creatDate, creatuser, if_orderno, line, openid, paymentcode, paymentname, orderno)" +
                "values(" + Double.parseDouble(order.getAmount()) + ",'" + onlineorderhBean.getBrandcode() + "','" + new Date() + "','SYSTEM','" +
                order.getOrderno() + "',1,'" + onlineorderhBean.getOpenId() + "',1,'微信','" + onlineorderhBean.getOrderno() + "') on conflict(orderno,line) DO NOTHING;";
        onlineorderpDao.updataByOriginSql(insertSql);
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void searchListUpdate() throws Exception {
        OnlineOrderTask.flag = true;
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("status", 0);
        List<OnlinePrepayBean> list = onlinePrepayDao.queryListBean(map);
        if (list == null) {
            return;
        }
//		Set<String> tempMap = new HashSet<>();
        OnlinePrepayBean onlinePrepayBean = null;
        for (int i = 0; i < list.size(); i++) {
            onlinePrepayBean = list.get(i);
//			if(tempMap.contains(onlinePrepayBean.getOrderno())){
//				continue;
//			}
//			tempMap.add(onlinePrepayBean.getOrderno());
            map.put("out_trade_no", onlinePrepayBean.getOut_trade_no());
            map.put("order_no", onlinePrepayBean.getOrderno());
            OnlinestoreBean store = onlinestoreDao.findEntity(OnlinestoreBean.class, onlinePrepayBean.getStrstorecode());
            map.put("sub_mch_id", store.getRemark1());
            if (configParam.getAliPaymentCode().equals(onlinePrepayBean.getPaymentcode().toString())) {
                callJiakeApiService.callJiakeApi_aliQuery_Service(map);
            } else {
                callJiakeApiService.callJiakeApi_wxQuery_Service(map);
            }
        }
    }


    public boolean checkEntityOccupied(Serializable id) throws Exception {
        // TODO Auto-generated method stub
        return false;
    }


    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void deletePrepay() throws Exception {
        // TODO Auto-generated method stub
        onlinePrepayDao.deletePrepay();
    }


    @Override
    public String searchOutTradeNo(String orderno) {
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("orderno", orderno);
        try {
            List<OnlinePrepayBean> list = onlinePrepayDao.searchListBean(map);
            String outTradeNo;
            if (list == null || list.size() == 0) {
                outTradeNo = orderno + String.format("%04d", 1);
            } else {
                outTradeNo = orderno + String.format("%04d", list.size() + 1);
            }
            return outTradeNo;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public List<OnlinePrepayBean> findLastOutTradeNo(String orderno) {
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("orderno", orderno);
        List<OnlinePrepayBean> list = onlinePrepayDao.generalSearch("from OnlinePrepayBean", map, "ORDER BY out_trade_no DESC");
        logger.info(list);
        return list;
    }


    @Override
    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void sendPurchaseResult(String orderNo) {
        try {
            OnlineorderhBean order = onlineorderhDao.findEntity(OnlineorderhBean.class, orderNo);
            OnlineUserBean user = onlineuserDao.findEntity(OnlineUserBean.class, order.getOpenId());
            HttpHeaders headers = new HttpHeaders();
            JSONObject param = new JSONObject();
            StringBuilder serialNumber = new StringBuilder();
            serialNumber.append(DateUtils.format(order.getDtorderstart(), DateUtils.DATE_TIME));
            String daysn = String.format("%04d", order.getDaysn());
            serialNumber.append(daysn);
            if (user != null && user.getMemberflg() != null && user.getMemberflg() == 1) {
                param.put("cardCode", user.getMemberCard());
            } else {
                param.put("cardCode", "");
            }
            param.put("shopCode", order.getStrstorecode());
//		param.put("shopCode","12001");
            param.put("posNo", order.getStrstorecode() + "Q");
            logger.info("回调积分时,用户: " + order.getOpenId() + ",数据库序列号为: " + order.getCrm_serialnumber() + ",缓存序列号为: " + redisCacheUtil.getCache(order.getStrstorecode() + order.getOpenId()));
//			param.put("serialNumber", redisCacheUtil.getCache(order.getOpenId()));
            if (StringUtils.isEmpty(order.getCrm_serialnumber()) && StringUtils.isEmpty(redisCacheUtil.getCache(order.getStrstorecode() + order.getOpenId()))) {
                logger.info("订单" + order.getOrderno() + "核销时无序列号,重新生成一个!");
//                Long cache = Long.parseLong(redisCacheUtil.getCache(order.getStrstorecode()).toString());
//                redisCacheUtil.setCache(order.getStrstorecode(), cache + 1);
//                redisCacheUtil.setCache(order.getStrstorecode() + order.getOpenId(), cache,28800);
                Long cache = getSerialNumber(order.getStrstorecode(),order.getOpenId());
                order.setCrm_serialnumber(cache.toString());
                onlineorderhDao.update(order);
//                Long temp = cache + 1;
//                logger.info("店铺号:" + order.getStrstorecode() + ",当前流水号:" + temp);
            } else if (StringUtils.isEmpty(order.getCrm_serialnumber()) && !StringUtils.isEmpty(redisCacheUtil.getCache(order.getStrstorecode() + order.getOpenId()))) {
                order.setCrm_serialnumber(redisCacheUtil.getCache(order.getStrstorecode() + order.getOpenId()));
                onlineorderhDao.update(order);
            }
//			param.put("serialNumber", order.getCrm_serialnumber());
            param.put("serialNumber", redisCacheUtil.getCache(order.getStrstorecode() + order.getOpenId()));
//		param.put("serialNumber", "2102240001");
            redisCacheUtil.removeCacheByKey(order.getStrstorecode() + order.getOpenId());
            logger.info("获取序列号后,用户: " + order.getOpenId() + ",缓存序列号为:" + redisCacheUtil.getCache(order.getStrstorecode() + order.getOpenId()));
            param.put("accessToken", MD5Util.encode("sendPurchaseResultToYRccc" + param.getString("cardCode")));
//			param.put("totalAmount",order.getAmountyf());
            param.put("totalAmount", order.getAmountsf());
            param.put("appID", WxConfig.appId);
            param.put("openID", user.getOpenid());
            logger.info("回调积分参数:" + param);
            HttpEntity<JSONObject> request = new HttpEntity<JSONObject>(param, headers);
//			JSONObject bodyAsJson = restTemplate.postForObject(WxConfig.RE_TOYR,request,JSONObject.class,param);
            String bodyAsString = HttpUtils.doPost(WxConfig.RE_TOYR, JSONObject.toJSONString(param));
            JSONObject bodyAsJson = JSONObject.parseObject(bodyAsString);
            logger.info("回调积分返回值:" + bodyAsJson);
        } catch (Exception e) {
            e.printStackTrace();
            logger.info(e);
        }
    }

    @Override
    public void createSerialNum() {
        try {
            List<Map<String, Object>> latestOrder = new ArrayList<>();
            latestOrder = onlineorderhDao.generalSearchBySql("select onlinestore.* from onlinestore ", null, null);

            for (Map<String, Object> store : latestOrder) {
                String cache = (DateUtils.format(new Date(), DateUtils.DATE_TIME) + "0001").substring(2);
                logger.info("============" + cache + " " + store.get("strstorecode").toString());
                redisCacheUtil.setCache(store.get("strstorecode").toString(), cache);
            }
        } catch (Exception e) {
            logger.error(e.getMessage(),e);
        }
    }
}
