package com.bettersoft.api.service.implement;

import com.bettersoft.api.dao.implement.OnlineuserDao;
import com.bettersoft.api.dao.interfaces.IOnlineorderdDao;
import com.bettersoft.api.dao.interfaces.IOnlineorderhDao;
import com.bettersoft.api.dao.interfaces.IOnlineorderpDao;
import com.bettersoft.api.model.*;
import com.bettersoft.api.service.interfaces.IOnlineorderPosApiService;
import com.bettersoft.api.service.interfaces.IWxService;
import com.bettersoft.api.utils.*;
import com.bettersoft.api.validmodel.OnlineItemPackageValidate;
import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.io.Serializable;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;

@Repository
public class OnlineorderPosApiService extends BaseService implements IOnlineorderPosApiService {
    @Resource(name = "onlineorderhDao")
    private IOnlineorderhDao onlineorderhDao;
    @Resource(name = "onlineorderdDao")
    private IOnlineorderdDao onlineorderdDao;
    @Resource(name = "onlineorderpDao")
    private IOnlineorderpDao onlineorderpDao;
    @Resource
    private OnlineuserDao onlineuserDao;
    @Resource(name = "redisCacheUtil")
    private RedisCacheUtil redisCacheUtil;
    @Autowired
    private IWxService wxService;

    public List<String> getUnsettleOrders(Map<String, Object> queryParam) throws Exception {
        List<String> orderNos = new ArrayList<String>();

        //参数转换

        List<OnlineorderhBean> orders = onlineorderhDao.searchList(queryParam);
        if (null != orders && !orders.isEmpty()) {
            for (OnlineorderhBean order : orders) {
                if(order.getTablecode()!=null && (!order.getTablecode().equals("qr")||queryParam.get("status").equals(1))){
                    orderNos.add(order.getOrderno());
                }
            }
        }

        return orderNos;
    }

    public Map<String, Object> getOrderDeatil(String storeCode, String orderNo) throws Exception {
        Map<String, Object> resultMap = new HashMap<String, Object>();
        Map<String, Object> queryParam = new HashMap<String, Object>();
        queryParam.put("strstorecode", storeCode);
        queryParam.put("orderno", orderNo);
        List<OnlineorderhBean> orders = onlineorderhDao.searchList(queryParam);
        if (null != orders && !orders.isEmpty()) {
            OnlineorderhBean order = orders.get(0);

            List<Map<String, Object>> orderdetaildone = new ArrayList<Map<String, Object>>();
            List<Map<String, Object>> orderdetail = new ArrayList<Map<String, Object>>();
            List<Map<String, Object>> orderpayment = new ArrayList<Map<String, Object>>();

            resultMap.put("orderno", order.getOrderno());
            resultMap.put("storeCode", storeCode);
            if(order.getTablecode()!=null && order.getTablecode().equals("qr")){
                resultMap.put("tablecode","");
            }else {
                resultMap.put("tablecode", order.getTablecode());
            }
            OnlineUserBean userBean=null;
            if(order.getOpenId()!=null){
                userBean=onlineuserDao.findEntity(OnlineUserBean.class,order.getOpenId());
                if(userBean!=null&&userBean.getMemberCard()!=null){
                    resultMap.put("membercard",userBean.getMemberCard());
                }else {
                    resultMap.put("membercard","");
                }
            }else{
                resultMap.put("membercard","");
            }
            resultMap.put("dtorderstart", order.getDtorderstart());
            resultMap.put("dtorderupdate", order.getDtorderupdate());
            resultMap.put("qty", order.getQty());
            if(order.getDiscountamount()==null){
                resultMap.put("discountamount", 0);
            } else {
                resultMap.put("discountamount", -order.getDiscountamount());
            }
            resultMap.put("amountyf", order.getAmountyf());
            resultMap.put("amountsf", order.getAmountsf());
            resultMap.put("offlineupdateflg", order.getOfflineupdateflg());
            resultMap.put("status", order.getStatus());
            resultMap.put("customername", order.getCustomername());
            resultMap.put("customeraddress", order.getCustomeraddress());
            resultMap.put("customermobile", order.getCustomermobile());
            resultMap.put("remark", order.getRemark());
            resultMap.put("hopetime", order.getHopetime());
            resultMap.put("daysn", order.getDaysn());
            if(!StringUtils.isEmpty(order.getCrm_serialnumber())){
                resultMap.put("crm_serialNumber", order.getCrm_serialnumber());
            }
            //TODO
            queryParam.remove("strstorecode");
            queryParam.put("orderno", orderNo);
            queryParam.put("suborderstatus", 2);
            List<Map<String, Object>> orderDetails = onlineorderdDao.searchList(queryParam);
            if (null != orderDetails && !orderDetails.isEmpty()) {
                for (Map<String, Object> orderDetail : orderDetails) {
                    if(orderDetail!=null&&orderDetail.get("discountamount")==null){
                        orderDetail.put("discountamount",0);
                    } else if(orderDetail!=null){
                        orderDetail.put("discountamount",-Double.parseDouble(orderDetail.get("discountamount").toString()));
                    }
                    if(orderDetail!=null&&orderDetail.get("discountcode")==null){
                        orderDetail.put("discountcode",0);
                    }
                    if(orderDetail!=null&&orderDetail.get("discountname")==null){
                        orderDetail.put("discountname","");
                    }
                    orderdetaildone.add(orderDetail);
                }
            }

            queryParam.put("suborderstatus", 1);
            orderDetails = onlineorderdDao.searchList(queryParam);
            if (null != orderDetails && !orderDetails.isEmpty()) {
                for (Map<String, Object> orderDetail : orderDetails) {
                    if(orderDetail!=null&&orderDetail.get("discountamount")==null){
                        orderDetail.put("discountamount",0);
                    } else if(orderDetail!=null){
                        orderDetail.put("discountamount",-Double.parseDouble(orderDetail.get("discountamount").toString()));
                    }
                    if(orderDetail!=null&&orderDetail.get("discountcode")==null){
                        orderDetail.put("discountcode",0);
                    }
                    if(orderDetail!=null&&orderDetail.get("discountname")==null){
                        orderDetail.put("discountname","");
                    }
                    orderdetail.add(orderDetail);
                }
            }
            queryParam.remove("suborderstatus");
            List<OnlineorderpBean> orderPayments = onlineorderpDao.searchList(queryParam);
            if (null != orderPayments && !orderPayments.isEmpty()) {
                for (OnlineorderpBean payment : orderPayments) {
                    orderpayment.add(EntityUtil.convertEntityToMap(payment));
                }
            }

            resultMap.put("orderdetaildone", orderdetaildone);
            resultMap.put("orderdetail", orderdetail);
            resultMap.put("orderpayment", orderpayment);

            return resultMap;
        }

        throw new ClassNotFoundException(orderNo);
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public Boolean confirmOrder(Map<String, Object> orderParam) throws Exception {
        String storeCode = MapUtils.getString(orderParam, "storeCode", StringUtils.EMPTY);
        String orderNo = MapUtils.getString(orderParam, "orderNo", StringUtils.EMPTY);
        String processFlag = MapUtils.getString(orderParam, "processFlag", StringUtils.EMPTY);
        List<String> suborderNos = (List<String>) MapUtils.getObject(orderParam, "suborderNos", null);
        String posorderNo = MapUtils.getString(orderParam, "posorderNo", StringUtils.EMPTY);
        logger.info(posorderNo);
//
        Map<String, Object> queryParam = new HashMap<String, Object>();
        queryParam.put("orderno", orderNo);
        if (processFlag.equals("D")) {
            queryParam.put("suborderstatus", 1);
            queryParam.put(Constants.QUERY_SPEC_CONDITION + "suborder", "suborderno in ('" + StringUtils.join(suborderNos.toArray(), "','") + "')");
            List<Map<String, Object>> details = onlineorderdDao.searchList(queryParam);
            if (null != details && !details.isEmpty()) {
                for (Map<String, Object> detail : details) {
                    int line = MapUtils.getIntValue(detail, "line", 0);
                    int suborderno = MapUtils.getIntValue(detail, "suborderno", 0);
                    onlineorderdDao.updateOrderDetailSubOrderStatus(orderNo, line, suborderno, 2);
                }
                OnlineorderhBean order = onlineorderhDao.findEntity(OnlineorderhBean.class,orderNo);
                if (order!=null) {
                    if(order.getTablecode()!=null &&order.getTablecode().equals("qr")){
                        order.setPosorderno(posorderNo);
                        order.setStatus(3);
                        onlineorderhDao.update(order);
                    }
                }
            } else {
                queryParam.clear();
                queryParam.put("strstorecode", storeCode);
                queryParam.put("orderno", orderNo);
                List<OnlineorderhBean> orders = onlineorderhDao.searchList(queryParam);
                if (null != orders && !orders.isEmpty()) {
                    OnlineorderhBean order = orders.get(0);
                    order.setPosorderno(posorderNo);
                    if(order.getTablecode()!=null && order.getTablecode().equals("qr")){
                        order.setStatus(3);
                    }else {
                        order.setStatus(2);
                    }

                    onlineorderhDao.update(order);
                } else {
                    throw new ClassNotFoundException(orderNo);
                }
            }
            return true;
        } else if (processFlag.equals("P")) {
            List<OnlineorderhBean> orders = onlineorderhDao.searchList(queryParam);
            if (null != orders && !orders.isEmpty()) {
                OnlineorderhBean order = orders.get(0);
                if(order.getTablecode()!=null &&!order.getTablecode().equals("qr")){
                    order.setPosorderno(posorderNo);
                    //wyj fix bug 20200308
                    //order.setStatus(2);
                    order.setStatus(9);
                    onlineorderhDao.update(order);
                    return  true;
                }else {
                    return false;
                }

            } else {
                throw new ClassNotFoundException(orderNo);
            }
        }
        return true;
    }

    @Override
    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void sellOrder(Map<String, Object> orderParam) throws Exception {
        String storeCode = MapUtils.getString(orderParam, "storeCode", StringUtils.EMPTY);
        String orderNo = MapUtils.getString(orderParam, "orderNo", StringUtils.EMPTY);
//        String processFlag = MapUtils.getString(orderParam, "processFlag", StringUtils.EMPTY);
//        List<String> suborderNos = (List<String>) MapUtils.getObject(orderParam, "suborderNos", null);
        String posorderNo = MapUtils.getString(orderParam, "posorderNo", StringUtils.EMPTY);
        Map<String, Object> queryParam = new HashMap<String, Object>();
        queryParam.put("orderno", orderNo);
        queryParam.put("strstorecode", storeCode);
        List<OnlineorderhBean> orders = onlineorderhDao.searchList(queryParam);
        if (null != orders && !orders.isEmpty()) {
            OnlineorderhBean order = orders.get(0);
            if(order.getTablecode()!=null && order.getTablecode().equals("qr") ){
                order.setPosorderno(posorderNo);
                order.setStatus(9);
                order.setFoodoutflg(1);
                if(wxService.wxSubscribeMessage(orderNo).equals("发送成功!")){
                    order.setMsgpushresult(1);
                    logger.info("发送成功!");
                }
                onlineorderhDao.update(order);
            }
        } else {
            throw new ClassNotFoundException(orderNo);
        }
    }
//    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
//    public void confirmOrder(Map<String, Object> orderParam) throws Exception {
//        String storeCode = MapUtils.getString(orderParam, "storeCode", StringUtils.EMPTY);
//        String orderNo = MapUtils.getString(orderParam, "orderNo", StringUtils.EMPTY);
//        String processFlag = MapUtils.getString(orderParam, "processFlag", StringUtils.EMPTY);
//        List<String> suborderNos = (List<String>) MapUtils.getObject(orderParam, "suborderNos", null);
//        String posorderNo = MapUtils.getString(orderParam, "posorderno", StringUtils.EMPTY);
//
//        Map<String, Object> queryParam = new HashMap<String, Object>();
//        queryParam.put("orderno", orderNo);
//        if (processFlag.equals("D")) {
//            queryParam.put("suborderstatus", 1);
//            queryParam.put(Constants.QUERY_SPEC_CONDITION + "suborder", "suborderno in ('" + StringUtils.join(suborderNos.toArray(), "','") + "')");
//            List<Map<String, Object>> details = onlineorderdDao.searchList(queryParam);
//            if (null != details && !details.isEmpty()) {
//                for (Map<String, Object> detail : details) {
//                    int line = MapUtils.getIntValue(detail, "line", 0);
//                    int suborderno = MapUtils.getIntValue(detail, "suborderno", 0);
//                    onlineorderdDao.updateOrderDetailSubOrderStatus(orderNo, line, suborderno, 2);
//                }
//            } else {
//                queryParam.clear();
//                queryParam.put("strstorecode", storeCode);
//                queryParam.put("orderno", orderNo);
//                List<OnlineorderhBean> orders = onlineorderhDao.searchList(queryParam);
//                if (null != orders && !orders.isEmpty()) {
//                    OnlineorderhBean order = orders.get(0);
//                    order.setPosorderno(posorderNo);
//                    order.setStatus(2);
//                    onlineorderhDao.update(order);
//                } else {
//                    throw new ClassNotFoundException(orderNo);
//                }
//            }
//        } else if (processFlag.equals("P")) {
//            List<OnlineorderhBean> orders = onlineorderhDao.searchList(queryParam);
//            if (null != orders && !orders.isEmpty()) {
//                OnlineorderhBean order = orders.get(0);
//                order.setPosorderno(posorderNo);
//                //wyj fix bug 20200308
//                //order.setStatus(2);
//                order.setStatus(9);
//
//                onlineorderhDao.update(order);
//            } else {
//                throw new ClassNotFoundException(orderNo);
//            }
//        }
//    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void offlineOrderSync(Map<String, Object> orderParam, LoginUserInfo loginUser) throws Exception {
        String storeCode = MapUtils.getString(orderParam, "storeCode", StringUtils.EMPTY);
        String posorderNo = MapUtils.getString(orderParam, "posorderNo", StringUtils.EMPTY);
        String tableCode = MapUtils.getString(orderParam, "tableCode", StringUtils.EMPTY);
        List<Map<String, Object>> details = (List<Map<String, Object>>) MapUtils.getObject(orderParam, "itemDetails", null);
        String orderno = "A01" + DateUtils.dateToString(new Date(), "yyyyMMddHHmmss") + storeCode;
        OnlineorderhBean order = null;
        int suborderNo = 1;
        int totalQuantity = 0;
        BigDecimal totalAmount = new BigDecimal(0);
        List<OnlineItemPackageValidate> buyItems = new ArrayList<OnlineItemPackageValidate>();
        //wyj bugfix 20200308
        //if (null != details && details.isEmpty()) {

        if (null != details && !details.isEmpty()) {
            for (Map<String, Object> detail : details) {
                //int lineNo = Integer.parseInt(MapUtils.getString(detail, "line", "0"));
                //int intitemno = Integer.parseInt(MapUtils.getString(detail, "intitemno", "0"));
                int quantity = Integer.parseInt(MapUtils.getString(detail, "qty", "0"));
                //fig bug w 20200320
                BigDecimal price = BigDecimal.valueOf(0.0);
                if (!StringUtils.isEmpty(MapUtils.getString(detail, "price", "0.0"))) {
                    price = BigDecimal.valueOf(Double.parseDouble(MapUtils.getString(detail, "price", "0.0")));
                }

                //String modify = MapUtils.getString(detail, "pmodify", StringUtils.EMPTY);
                totalQuantity += quantity;
                /*
                if (price.intValue() == 0) {
                    OnlineItemBean item = onlineorderhDao.findEntity(OnlineItemBean.class, intitemno);
                    if (null != item) {
                        totalAmount = totalAmount.add(new BigDecimal(item.getPrice() * quantity));
                    }
                } else {
                    totalAmount = totalAmount.add(price.multiply(new BigDecimal(quantity)));
                }
                */
                totalAmount = totalAmount.add(price.multiply(new BigDecimal(quantity)));
                /*
                OnlineItemPackageValidate buyItem = new OnlineItemPackageValidate();
                buyItem.setQuantity(quantity);
                buyItem.setLineNo(lineNo);
                buyItem.setPmodify(modify);

                buyItems.add(buyItem);
                
                saveOnlineorderdBean(item.getBrandcode(), order.getOrderno(), suborderNo, bi.getLineNo(), onlineorderhDao.getItemType(item.getIntitemno()), item.getItem().getStrItemNameShort(), bi.getPmodify(),
                        bi.getQuantity(), item.getPrice(), 1, "SYSTEM");
                */
            }
        }
        int lineNo = 1;
        boolean isSettle = onlineorderhDao.isOrderSettle(storeCode, tableCode);
        if (isSettle) {
            order = new OnlineorderhBean();
            Integer daysn = onlineorderhDao.getDaysn(storeCode);
            order.setOrderno(orderno + daysn);
            order.setBrandcode("A01");
            order.setStrstorecode(storeCode);
            order.setTablecode(tableCode);
            order.setDaysn(null);
            order.setDtorderstart(new Date());
            order.setQty(totalQuantity);
            order.setAmountyf(totalAmount.doubleValue());
            order.setOfflineupdateflg(1);
            order.setStatus(2);
            order.setUpdateuser(loginUser.getUserCode());
            order.setUpdateDate(new Date());
            order.setCreatuser(loginUser.getUserCode());
            order.setCreatDate(new Date());
            order.setPosorderno(posorderNo);
        } else {
            order = onlineorderhDao.findLastOnlineOrder(storeCode, tableCode);
            order.setDtorderupdate(new Date());
            order.setUpdateDate(new Date());
            suborderNo = onlineorderhDao.getSubOrderNo(order.getOrderno());//子表的下单序号
            lineNo = onlineorderhDao.getMaxLineNo(order.getOrderno()) + 1;
            order.setQty(order.getQty() + totalQuantity);
            order.setAmountyf(order.getAmountyf() + totalAmount.doubleValue());
            order.setPosorderno(posorderNo);
            order.setUpdateuser(loginUser.getUserCode());
        }
        
        /*
        for (OnlineItemPackageValidate bi : buyItems) {
            OnlineItemBean item = onlineorderhDao.findOnlineItem(storeCode, bi.getItemId());
            if (null == item) {
                throw new ClassNotFoundException("");
            }
            saveOnlineorderdBean(item.getBrandcode(), order.getOrderno(), suborderNo, bi.getLineNo(), onlineorderhDao.getItemType(item.getIntitemno()), item.getItem().getStrItemNameShort(), bi.getPmodify(),
                    bi.getQuantity(), item.getPrice(), 1, "SYSTEM");
        }
        */

        if (null != details && !details.isEmpty()) {
            for (Map<String, Object> detail : details) {
                //int lineNo = Integer.parseInt(MapUtils.getString(detail, "line", "0"));

                int intitemno = Integer.parseInt(MapUtils.getString(detail, "intitemno", "0"));
                int quantity = Integer.parseInt(MapUtils.getString(detail, "qty", "0"));
                //fig bug w 20200320
                double price = 0.0;
                if (!StringUtils.isEmpty(MapUtils.getString(detail, "price", "0.0"))) {
                    price = Double.parseDouble(MapUtils.getString(detail, "price", "0.0"));
                }

                String modify = MapUtils.getString(detail, "pmodify", StringUtils.EMPTY);

                String itemtype = MapUtils.getString(detail, "linetype", StringUtils.EMPTY);

                String pname = MapUtils.getString(detail, "pname", StringUtils.EMPTY);

                totalQuantity += quantity;


                saveOnlineorderdBean("A01", order.getOrderno(), suborderNo, lineNo, itemtype, pname, modify,
                        quantity, price, 1, "SYSTEM", intitemno);
                lineNo++;
            }
        }

        onlineorderhDao.save(generalLogOperator(Constants.INSERT_OPER_TYPE, loginUser, order));
        onlineorderhDao.saveOrUpdate(order);
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void onlineOrderSettlement(Map<String, Object> paymentParam, LoginUserInfo loginUser) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddhhmmss");
        String storeCode = MapUtils.getString(paymentParam, "storeCode", StringUtils.EMPTY);
        String tableCode = MapUtils.getString(paymentParam, "tableCode", StringUtils.EMPTY);
        List<Map<String, Object>> payments = (List<Map<String, Object>>) MapUtils.getObject(paymentParam, "payments", null);
        OnlineorderhBean order = onlineorderhDao.findLastOnlineOrder(storeCode, tableCode);
        order.setStatus(4);
        order.setUpdateDate(new Date());
        for (Map<String, Object> payment : payments) {
            double amount = MapUtils.getNumber(payment, "amount", 0.0f).doubleValue();
            int line = MapUtils.getNumber(payment, "line", 0l).intValue();
            int paymentCode = Integer.parseInt(MapUtils.getString(payment, "paymentcode", "0"));
            String paymentName = MapUtils.getString(payment, "paymentname", StringUtils.EMPTY);
            String ifOrderNo = MapUtils.getString(payment, "if_orderno", StringUtils.EMPTY);
            String openid = MapUtils.getString(payment, "openid", StringUtils.EMPTY);
            String remark = MapUtils.getString(payment, "remark", StringUtils.EMPTY);
            // String payDate = MapUtils.getString(payment, "payDate", StringUtils.EMPTY);

            onlineorderpDao.saveOnlineOrderPayment("A01", order.getOrderno(), line, paymentCode, paymentName, amount, ifOrderNo, openid, remark, sdf.format(new Date()), loginUser.getUserCode());
        }

        onlineorderhDao.update(order);
        onlineorderhDao.save(generalLogOperator(Constants.UPDATE_OPER_TYPE, loginUser, order));
    }
    public void saveOnlineorderdBean(String brandcode, String orderno, int suborderno, int line, String linetype,
                                     String pname, String pmodify, int qty, Double price, int orderfrom, String userName, int intitemno) {
        String inSql = "insert into onlineorderd (brandcode,orderno,suborderno,line,linetype,pname,pmodify,qty,price,orderfrom,confirmuser,dtorder,amount,amountafterdiscount,suborderstatus,dtconfirm,intitemno)" +
                "values ('" + brandcode + "','" + orderno + "','" + suborderno + "','" + line + "','" + linetype + "','" + pname + "','" + pmodify + "','" + qty + "','" + price + "','" + orderfrom + "','" + userName + "',now(),"
                + "'" + (qty * price) + "',0,2,now()," + intitemno + ")";
        onlineorderhDao.updataByOriginSql(inSql);
    }

    public boolean checkEntityOccupied(Serializable id) throws Exception {
        return false;
    }
}
