package com.bettersoft.api.service.implement;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.bettersoft.api.dao.interfaces.IOnlineorderdDao;
import com.bettersoft.api.model.OnlineorderdBean;
import com.bettersoft.api.service.interfaces.IOnlineorderdService;
import com.bettersoft.api.utils.Constants;
import com.bettersoft.api.utils.EntityUtil;
import com.bettersoft.api.utils.LangUtils;
import com.bettersoft.api.utils.LoginUserInfo;
import com.bettersoft.api.validmodel.OnlineorderdValidate;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

@Repository
@SuppressWarnings({ "unchecked", "rawtypes" })
public class OnlineorderdService extends BaseService implements IOnlineorderdService
{
	@Resource(name = "onlineorderdDao")
	private IOnlineorderdDao onlineorderdDao;

	protected Gson gson = new GsonBuilder().setDateFormat("yyyy-MM-dd HH:mm:ss").serializeNulls().create();

	public Map<String, Object> searchByPage(Map<String, Object> queryParam) throws Exception
	{
		List<Map<String,Object>> list = onlineorderdDao.searchList(queryParam);
		Map<String, Object> rs = onlineorderdDao.getTotal(LangUtils.optString(queryParam.get("orderno")));
		Number count = onlineorderdDao.searchCount(queryParam);
		rs.put("list", list);
		rs.put("totalCount", count);
		return rs;
	}

	public OnlineorderdBean findOnlineorderd(String str) throws Exception
	{
		OnlineorderdBean onlineorderdBean = onlineorderdDao.findEntity(OnlineorderdBean.class, str);
		return onlineorderdBean;
	}
	
	public OnlineorderdBean findOnlineorderd(Long l) throws Exception
	{
		OnlineorderdBean onlineorderdBean = onlineorderdDao.findEntity(OnlineorderdBean.class, l);
		return onlineorderdBean;
	}

	@Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
	public void saveOnlineorderd(OnlineorderdValidate onlineorderdValidate, LoginUserInfo loginUser) throws Exception
	{
		OnlineorderdBean onlineorderdBean = new OnlineorderdBean();
		EntityUtil.copyEntityProperty(onlineorderdValidate, onlineorderdBean);
		/*onlineorderdBean.setUpdateuser(loginUser.getUserCode());
		onlineorderdBean.setUpdateDate(new Date());
		onlineorderdBean.setCreatuser(loginUser.getUserName());
		onlineorderdBean.setCreatDate(new Date());*/
		onlineorderdDao.save(generalLogOperator(Constants.INSERT_OPER_TYPE, loginUser, onlineorderdBean));
		onlineorderdDao.save(onlineorderdBean);
	}
	
	@Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
	public void updateOnlineorderd(OnlineorderdValidate onlineorderdValidate, LoginUserInfo loginUser) throws Exception
	{
		/*
		String priKey = onlineorderdValidate.getPriKey();
		OnlineorderdBean edit = onlineorderdDao.findEntity(OnlineorderdBean.class, priKey);
		
		EntityUtil.compareCopyEntity(onlineorderdValidate, edit);
		if (null == edit)
			throw new ClassNotFoundException();

		onlineorderdBean.setUpdateuser(loginUser.getUserCode());
		onlineorderdBean.setUpdateDate(new Date());
		onlineorderdDao.save(generalLogOperator(Constants.UPDATE_OPER_TYPE, loginUser, edit));
		onlineorderdDao.update(edit);
		*/
	}

	@Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
	public void deleteOnlineorderd(String str, LoginUserInfo loginUser) throws Exception
	{
		OnlineorderdBean del = onlineorderdDao.findEntity(OnlineorderdBean.class, str);
		if (null == del)
			throw new ClassNotFoundException();
		onlineorderdDao.save(generalLogOperator(Constants.DELETE_OPER_TYPE, loginUser, del));
		onlineorderdDao.delete(del);
	}
	
	@Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
	public void deleteOnlineorderd(Long l, LoginUserInfo loginUser) throws Exception
	{
		OnlineorderdBean del = onlineorderdDao.findEntity(OnlineorderdBean.class, l);
		if (null == del)
			throw new ClassNotFoundException();
		onlineorderdDao.save(generalLogOperator(Constants.DELETE_OPER_TYPE, loginUser, del));
		onlineorderdDao.delete(del);
	}

	public boolean checkEntityOccupied(Serializable id) throws Exception
	{
		OnlineorderdBean existsDept = onlineorderdDao.findEntity(OnlineorderdBean.class, id);

		return null != existsDept;
	}
}
