package com.bettersoft.api.service.implement;

import java.io.IOException;
import java.io.OutputStream;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.nio.charset.StandardCharsets;
import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.metadata.Sheet;
import com.alibaba.excel.support.ExcelTypeEnum;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.bettersoft.api.config.WxConfig;
import com.bettersoft.api.dao.implement.OnlineuserDao;
import com.bettersoft.api.dao.interfaces.IOnlinePrepayDao;
import com.bettersoft.api.dao.interfaces.IOnlineorderpDao;
import com.bettersoft.api.dao.interfaces.IOnlinestoreDao;
import com.bettersoft.api.encrytion.Base64Util;
import com.bettersoft.api.encrytion.MD5Util;
import com.bettersoft.api.exceptions.ValidateFailedException;
import com.bettersoft.api.model.*;
import com.bettersoft.api.model.Entity.OnlineorderhList;
import com.bettersoft.api.model.Entity.OnlineorderpList;
import com.bettersoft.api.utils.*;
import com.bettersoft.api.validmodel.ShoppingCartValidate;

import org.apache.commons.lang.StringUtils;
import org.hibernate.SQLQuery;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.bettersoft.api.dao.interfaces.IOnlineorderhDao;
import com.bettersoft.api.service.interfaces.IOnlineorderhService;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.springframework.util.CollectionUtils;
import org.springframework.util.ObjectUtils;

@Repository
@SuppressWarnings({"unchecked", "rawtypes"})
public class OnlineorderhService extends BaseService implements IOnlineorderhService {
    @Resource(name = "onlineorderhDao")
    private IOnlineorderhDao onlineorderhDao;
    @Resource(name = "onlineorderpDao")
    private IOnlineorderpDao onlineorderpDao;
    @Resource
    protected ConfigParamHelper configParam;
    @Resource
    private OnlineuserDao onlineuserDao;
    @Resource(name = "redisCacheUtil")
    private RedisCacheUtil redisCacheUtil;
    @Autowired
    private IOnlinePrepayDao onlinePrepayDao;
    @Autowired
    private IOnlinestoreDao onlinestoreDao;
    @Autowired
    private CallJiakeApiService callJiakeApiService;
    protected Gson gson = new GsonBuilder().setDateFormat("yyyy-MM-dd HH:mm:ss").serializeNulls().create();

    public Map<String, Object> findStoreStatus(String storeCode, String token) throws Exception {
        String str = new String(Base64Util.decryBASE64(token));
        JSONObject strAsJson = JSONObject.parseObject(str);
        OnlineUserBean onlineUserBean = onlineuserDao.findEntity(OnlineUserBean.class, strAsJson.getString("openid"));
        Map<String, Object> resultMap = new HashMap<String, Object>();
        StoreBean store = onlineorderhDao.findEntity(StoreBean.class, storeCode);
        if (null == store)
            throw new ClassNotFoundException();

        OnlinestoreBean onlineStore = onlineorderhDao.findEntity(OnlinestoreBean.class, store.getStrStoreCode());
        if (null == onlineStore)
            throw new ClassNotFoundException();

        Calendar calendar = Calendar.getInstance();
        SimpleDateFormat simpleDateFormatdedate = new SimpleDateFormat("HH:mm");

        resultMap.put("storeCode", store.getStrStoreCode());
        resultMap.put("storeName", store.getStrStoreName());
        resultMap.put("status", onlineStore.getStatus());
        resultMap.put("remark1", onlineStore.getRemark1());
        if (store.getDtmTradeBegin() != null) {
            resultMap.put("beginTime", simpleDateFormatdedate.format(store.getDtmTradeBegin()));
        } else {
            resultMap.put("beginTime", "00:00");
        }
        if (store.getDtmTradeEnd() != null) {
            logger.info(store.getDtmTradeEnd());
            calendar.setTime(store.getDtmTradeEnd());
            logger.info(calendar.getTime());
            calendar.add(Calendar.MINUTE, -10);
            logger.info(calendar.getTime());
            resultMap.put("endTime", simpleDateFormatdedate.format(calendar.getTime()));
        } else {
            resultMap.put("endTime", "00:00");
        }
        if (onlineUserBean != null) {
            resultMap.put("barcard", onlineUserBean.getMemberCard());
        } else {
            resultMap.put("barcard", "");
        }
        return resultMap;
    }

    public Map<String, Object> searchByPage(Map<String, Object> queryParam) throws Exception {
        boolean totalFlag = false;
        if(ObjectUtils.isEmpty(queryParam.get("tablecode"))){
            queryParam.put("tablecode","0");
        }
        switch (Integer.parseInt(queryParam.get("tablecode").toString())) {
            case 0:
                queryParam.remove("tablecode");
                totalFlag = true;
                break;
            case 1:
                queryParam.remove("tablecode");
                queryParam.put(Constants.QUERY_NOTEQUAL + "tablecode", "qr");
                break;
            case 2:
                queryParam.put("tablecode", "qr");
                if (queryParam.get("status") != null) {
                    switch (Integer.parseInt(queryParam.get("status").toString())) {
                        case 1:
                            queryParam.put("status", 0);
                            break;
                        case 2:
                            queryParam.put("status", 3);
                            break;
                        case 3:
                            queryParam.put("status", 1);
                            break;
                    }
                }
                break;
        }
        List<OnlineorderhBean> list = new ArrayList<>();
        Number lastCount = 0;
        if (!totalFlag) {
            list = onlineorderhDao.searchList(queryParam);
            lastCount = onlineorderhDao.searchCount(queryParam);
        } else {
            if (queryParam.get("status") != null) {
//                queryParam.put(Constants.QUERY_NOTEQUAL + "tablecode", "qr");
//                list = onlineorderhDao.searchList(queryParam);
                int statusQr = 5;
                switch (Integer.parseInt(queryParam.get("status").toString())) {
                    case 1:
                        statusQr = 0;
                        break;
                    case 2:
                        statusQr = 3;
                        break;
                    case 3:
                        statusQr = 1;
                        break;
                    default:
                        statusQr = (Integer) queryParam.get("status");
                        break;
                }
//                queryParam.remove(Constants.QUERY_NOTEQUAL + "tablecode");
//                queryParam.put("tablecode","qr");
                String sql;
                String countSql;
                if (queryParam.get("spec.strstorecode") != null) {
                    if (queryParam.get("like.strstorecode") != null) {
                        sql = "select onlineorderh.* from onlineorderh where ((status = " + queryParam.get("status") + " and tablecode !='qr') or (status = " + statusQr + " and tablecode = 'qr')) and strstorecode like '%" + queryParam.get("like.strstorecode") + "%'";
                        countSql = "select count(*) from onlineorderh where ((status = " + queryParam.get("status") + " and tablecode !='qr') or (status = " + statusQr + " and tablecode = 'qr')) and strstorecode like '%" + queryParam.get("like.strstorecode") + "%'";
                    } else {
                        sql = "select onlineorderh.* from onlineorderh where ((status = " + queryParam.get("status") + " and tablecode !='qr') or (status = " + statusQr + " and tablecode = 'qr')) and " + queryParam.get("spec.strstorecode");
                        countSql = "select count(*) from onlineorderh where ((status = " + queryParam.get("status") + " and tablecode !='qr') or (status = " + statusQr + " and tablecode = 'qr')) and " + queryParam.get("spec.strstorecode");
                    }
                } else {
                    if (queryParam.get("like.strstorecode") != null) {
                        sql = "select onlineorderh.* from onlineorderh where ((status = " + queryParam.get("status") + " and tablecode !='qr') or (status = " + statusQr + " and tablecode = 'qr')) and strstorecode like '%" + queryParam.get("like.strstorecode") + "%'";
                        countSql = "select count(*) from onlineorderh where ((status = " + queryParam.get("status") + " and tablecode !='qr') or (status = " + statusQr + " and tablecode = 'qr')) and strstorecode like '%" + queryParam.get("like.strstorecode") + "%'";
                    } else {
                        sql = "select onlineorderh.* from onlineorderh where ((status = " + queryParam.get("status") + " and tablecode !='qr') or (status = " + statusQr + " and tablecode = 'qr'))";
                        countSql = "select count(*) from onlineorderh where ((status = " + queryParam.get("status") + " and tablecode !='qr') or (status = " + statusQr + " and tablecode = 'qr'))";
                    }
                }
                if (queryParam.get("like.orderno") != null) {
                    sql += " and orderno like '%" + queryParam.get("like.orderno") + "%'";
                    countSql += " and orderno like '%" + queryParam.get("like.orderno") + "%'";
                }
                if (queryParam.get("startDate.dtorderstart") != null && queryParam.get("endDate.dtorderstart") != null) {
                    sql += " and dtorderstart >= '" + queryParam.get("startDate.dtorderstart") + " 00:00:00' and dtorderstart <= '" + queryParam.get("endDate.dtorderstart") + " 23:59:59'";
                    countSql += " and dtorderstart >= '" + queryParam.get("startDate.dtorderstart") + " 00:00:00' and dtorderstart <= '" + queryParam.get("endDate.dtorderstart") + " 23:59:59'";
                }

                //追加posorderno的模糊查询 20240301 郭
                if(queryParam.get("like.posorderno") != null){
                    sql += " and posorderno like '%" + queryParam.get("like.posorderno") + "%'";
                    countSql += " and posorderno like '%" + queryParam.get("like.posorderno") + "%'";
                }
//                if(queryParam.get("orderBy")!=null){
//                    sql += " order by " + queryParam.get("orderBy");
//                }
                list = onlineorderhDao.generalSearchByFullSql(sql, null, " order by " + queryParam.get("orderBy").toString());
                list = list.subList((Integer) queryParam.get("firstResults"), Math.min((Integer.parseInt(queryParam.get("firstResults").toString()) + Integer.parseInt(queryParam.get("maxResults").toString())), list.size()));
                lastCount = onlineorderhDao.generalCountByFullSql(countSql);
                List<OnlineorderhBean> tempList = new ArrayList<>();
                for(Object temp : list){
                    JSONObject tempJs =  (JSONObject) JSON.toJSON(temp);
                    OnlineorderhBean order = JSONObject.parseObject(tempJs.toString(), OnlineorderhBean.class);
                    tempList.add(order);
                }
                list.clear();
                list.addAll(tempList);
            } else {
                list = onlineorderhDao.searchList(queryParam);
                lastCount = onlineorderhDao.searchCount(queryParam);
            }
        }

        List<OnlineorderhList> showList = new ArrayList<>();
        if(!CollectionUtils.isEmpty(list)){
            for(OnlineorderhBean order:list){
                OnlineorderhList temp = new OnlineorderhList();
                BeanUtils.copyProperties(order,temp);
                if(!ObjectUtils.isEmpty(order.getAmountsf())){
                    temp.setAmountSfShow(BigDecimal.valueOf(order.getAmountsf()).setScale(2, RoundingMode.HALF_UP).toString());
                }
                if(!ObjectUtils.isEmpty(order.getAmountyf())){
                    temp.setAmountYfShow(BigDecimal.valueOf(order.getAmountyf()).setScale(2, RoundingMode.HALF_UP).toString());
                }
                showList.add(temp);
            }
        }

        return new PageInfoUtils(queryParam, showList, lastCount).getPageInfoMap();
//        return new PageInfoUtils(queryParam, list, lastCount).getPageInfoMap();
    }

    public List<OnlineorderdBean> searchOrderDetails(String orderNo) throws Exception {
        Map<String, Object> queryParam = new HashMap<String, Object>();
        queryParam.put("orderno", orderNo);
        queryParam.put(Constants.QUERY_ORDER_BY, "order by line");
        return onlineorderhDao.searchOrderDetails(queryParam);
    }

    public List<Map<String, Object>> searchOfflineOrderDetails(String orderNo) throws Exception {
        List<Map<String, Object>> offlineItems = new ArrayList<Map<String, Object>>();
        Map<String, Object> queryParam = new HashMap<String, Object>();
        queryParam.put("orderno", orderNo);
        queryParam.put("orderfrom", 1);
        queryParam.put(Constants.QUERY_ORDER_BY, "order by line");
        List<OnlineorderdBean> offlineDetails = onlineorderhDao.searchOrderDetails(queryParam);
        if (null != offlineDetails && !offlineDetails.isEmpty()) {
            for (int i = 0; i < offlineDetails.size(); i++) {
                Map<String, Object> offlineItem = new HashMap<String, Object>();
                if (offlineDetails.get(i).getLinetype().equals("S")) {
                    offlineItem.put("packageHeader", offlineDetails.get(i));
                    List<OnlineorderdBean> childItems = new ArrayList<OnlineorderdBean>();
                    int j = i + 1;
                    for (; j < offlineDetails.size(); j++) {
                        if (offlineDetails.get(j).getLinetype().equals("SI")) {
                            childItems.add(offlineDetails.get(j));
                        } else {
                            break;
                        }
                    }
                    offlineItem.put("packageChildren", childItems);
                    offlineItems.add(offlineItem);
                    i = j;
                    continue;
                }
                offlineItem.put("packageHeader", offlineDetails.get(i));
                offlineItems.add(offlineItem);
            }
        }

        return offlineItems;
    }

    public OnlineorderhBean findOnlineorderh(String str) throws Exception {
        OnlineorderhBean onlineorderhBean = onlineorderhDao.findEntity(OnlineorderhBean.class, str);
        return onlineorderhBean;
    }

    public String findUnSettlementOrderNo(String storeCode, String tableCode) throws Exception {
        OnlineorderhBean order = onlineorderhDao.findLastOnlineOrder(storeCode, tableCode);
        if (null != order)
            return order.getOrderno();

        return StringUtils.EMPTY;
    }

    public OnlineorderhBean findOnlineorderh(Long l) throws Exception {
        OnlineorderhBean onlineorderhBean = onlineorderhDao.findEntity(OnlineorderhBean.class, l);
        return onlineorderhBean;
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public String saveOnlineOrder(ShoppingCartValidate shoppingCart, int offLineFlag, String token, String flag, Integer num) throws Exception {
        OnlineorderhBean order = null;
        String str = new String(Base64Util.decryBASE64(token));
        JSONObject strAsJson = JSONObject.parseObject(str);
        int suborderNo = 1;
        Integer daysn = onlineorderhDao.getDaysn(shoppingCart.getStoreCode());
        if (onlineorderhDao.isOrderSettle(shoppingCart.getStoreCode(), shoppingCart.getTableCode())) {
//            String orderNo = MessageFormat.format("A01{0}{1}", DateUtils.dateToString(new Date(), "yyyyMMddHHmmss"), shoppingCart.getStoreCode());
            String orderNo = MessageFormat.format("{0}{1}", DateUtils.dateToString(new Date(), "yyMMddHHmm"), shoppingCart.getStoreCode());
            order = new OnlineorderhBean();
            order.setOrderno(orderNo + String.format("%04d", daysn));
            order.setBrandcode("A01");
            order.setStrstorecode(shoppingCart.getStoreCode());
            if (flag == null) {
                order.setTablecode(shoppingCart.getTableCode());
                order.setCustomerqty(num);
                order.setStatus(1);
            } else {
                order.setTablecode("qr");
                order.setStatus(0);
            }
            order.setDaysn(daysn);
            order.setDtorderstart(new Date());
            order.setQty(shoppingCart.getTotalQuantity());
            order.setAmountyf(shoppingCart.getTotalAmount().doubleValue());
            order.setOfflineupdateflg(offLineFlag);
            order.setRemark(shoppingCart.getRemark());
//            order.setStatus(0);
//            order.setStatus(1);
            order.setUpdateuser("SYSTEM");
            order.setUpdateDate(new Date());
            order.setCreatuser("SYSTEM");
            order.setCreatDate(new Date());
            order.setOpenId(strAsJson.getString("openid"));
            order.setUnionid(strAsJson.getString("unionid"));
            order.setFoodoutflg(0);
            if (!redisCacheUtil.containsKey(shoppingCart.getStoreCode() + strAsJson.getString("openid")) || redisCacheUtil.getCache(shoppingCart.getStoreCode() + strAsJson.getString("openid")) == null) {
//                Long cache = Long.parseLong(redisCacheUtil.getCache(shoppingCart.getStoreCode()).toString());
//                redisCacheUtil.setCache(shoppingCart.getStoreCode(), cache + 1);
//                redisCacheUtil.setCache(shoppingCart.getStoreCode() + strAsJson.getString("openid"), cache.toString(), 28800);
                Long cache = getSerialNumber(shoppingCart.getStoreCode(), strAsJson.getString("openid"));
                logger.info("用户openId:" + strAsJson.getString("openid") + ",下单时首次获得序列号并放入缓存:" + cache);
//                Long temp = cache + 1;
//                logger.info("店铺号:" + order.getStrstorecode() + ",当前流水号:" + temp);
                order.setCrm_serialnumber(cache.toString());
            } else {
                logger.info("用户openId:" + strAsJson.getString("openid") + ",下单时,展示折扣获得序列号已经在缓存中:" + redisCacheUtil.getCache(shoppingCart.getStoreCode() + strAsJson.getString("openid")));
                order.setCrm_serialnumber(redisCacheUtil.getCache(shoppingCart.getStoreCode() + strAsJson.getString("openid")));
            }
        } else {
            order = onlineorderhDao.findLastOnlineOrder(shoppingCart.getStoreCode(), shoppingCart.getTableCode());
            if (null == order)
                throw new ClassNotFoundException();
            if (!redisCacheUtil.containsKey(shoppingCart.getStoreCode() + strAsJson.getString("openid")) || redisCacheUtil.getCache(shoppingCart.getStoreCode() + strAsJson.getString("openid")) == null) {
//                Long cache = Long.parseLong(redisCacheUtil.getCache(shoppingCart.getStoreCode()).toString());
//                redisCacheUtil.setCache(shoppingCart.getStoreCode(), cache + 1);
//                redisCacheUtil.setCache(shoppingCart.getStoreCode() + strAsJson.getString("openid"), cache.toString(), 28800);
                Long cache = getSerialNumber(shoppingCart.getStoreCode(), strAsJson.getString("openid"));
                logger.info("用户openId:" + strAsJson.getString("openid") + ",下单时首次获得序列号并放入缓存:" + cache);
//                Long temp = cache + 1;
//                logger.info("店铺号:" + order.getStrstorecode() + ",当前流水号:" + temp);
                order.setCrm_serialnumber(cache.toString());
            } else {
                logger.info("用户openId:" + strAsJson.getString("openid") + ",下单时,展示折扣获得序列号已经在缓存中:" + redisCacheUtil.getCache(shoppingCart.getStoreCode() + strAsJson.getString("openid")));
                order.setCrm_serialnumber(redisCacheUtil.getCache(shoppingCart.getStoreCode() + strAsJson.getString("openid")));
            }
            suborderNo = onlineorderhDao.getSubOrderNo(order.getOrderno());//子表的下单序号
            if (null == order.getDaysn())
                order.setDaysn(daysn);
            order.setStatus(1);
            order.setRemark(shoppingCart.getRemark());
            order.setQty(order.getQty() + shoppingCart.getTotalQuantity());
            order.setAmountyf(order.getAmountyf() + shoppingCart.getTotalAmount().doubleValue());
        }

        onlineorderhDao.saveOrUpdate(order);
        int maxLineNo = onlineorderhDao.getMaxLineNo(order.getOrderno());

        int lineNo = 1;
        for (OnlineItemBean bi : shoppingCart.getOnlineItems(order.getOrderno())) {
            OnlineItemBean i = onlineorderhDao.findOnlineItem(shoppingCart.getStoreCode(), bi.getIntitemno());
            String itemDesc = "";
            itemDesc = null != i.getItem() ? i.getItem().getStrItemNameShort() : StringUtils.EMPTY;
//            if (bi.getItemType().equals("A"))
//                bi.setItemType("I");
            onlineorderhDao.saveOnlineOrderDetail(i.getBrandcode(), order.getOrderno(), suborderNo, maxLineNo + lineNo, bi.getItemType(), itemDesc, bi.getPmodify(),
                    bi.getQuantity(), bi.getPrice(), offLineFlag, "SYSTEM", i.getIntitemno(), shoppingCart.getRemark());
//            for(OnlineItemPackageValidate item:shoppingCart.getRealCartItems()){
//                if(item.getLineNo()==0){
//                    item.setLineNo(maxLineNo + lineNo);
//                    break;
//                }
//            }
            lineNo++;
        }
        return order.getOrderno();
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public Map<String, Object> saveOnlineOrderScanPaymeny(ShoppingCartValidate shoppingCart, int offLineFlag) throws Exception {
        Map<String, Object> map = new HashMap<String, Object>();
        OnlineorderhBean order = null;
        int suborderNo = 1;
        Integer daysn = onlineorderhDao.getDaysn(shoppingCart.getStoreCode());

        String orderNo = MessageFormat.format("A01{0}{1}", DateUtils.dateToString(new Date(), "yyyyMMddHHmmss"), shoppingCart.getStoreCode());
        order = new OnlineorderhBean();
        order.setOrderno(orderNo + daysn);
        order.setBrandcode("A01");
        order.setStrstorecode(shoppingCart.getStoreCode());
        order.setTablecode(shoppingCart.getTableCode());
        order.setDaysn(daysn);
        order.setDtorderstart(new Date());
        order.setQty(shoppingCart.getTotalQuantity());
        order.setAmountyf(shoppingCart.getTotalAmount().doubleValue());
        order.setOfflineupdateflg(offLineFlag);
        order.setRemark(shoppingCart.getRemark());
        order.setStatus(1);
        order.setUpdateuser("SYSTEM");
        order.setUpdateDate(new Date());
        order.setCreatuser("SYSTEM");
        order.setCreatDate(new Date());

        onlineorderhDao.saveOrUpdate(order);
        int maxLineNo = onlineorderhDao.getMaxLineNo(order.getOrderno());

        int lineNo = 1;
        int itemNO = 0;
        String brandcode = "AAA";
        String itemDesc = configParam.getScanPaymeny_itemName();
        String itemNoStr = configParam.getScanPaymeny_itemNo();
        if (StringUtils.isNotEmpty(itemNoStr)) {
            itemNO = Integer.parseInt(itemNoStr);
        }
        for (OnlineItemBean bi : shoppingCart.getOnlineItems(order.getOrderno())) {
            onlineorderhDao.saveOnlineOrderDetail(brandcode, order.getOrderno(), suborderNo, maxLineNo + lineNo, bi.getItemType(), itemDesc, bi.getPmodify(),
                    bi.getQuantity(), bi.getPrice(), offLineFlag, "SYSTEM", itemNO, shoppingCart.getRemark());
            lineNo++;
        }
        map.put("orderNo", order.getOrderno());
        map.put("paymentMoney", order.getAmountyf());
        map.put("itemNo", itemNO);
        map.put("itemName", itemDesc);
        return map;
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void acceptOnlineOrder(String orderNo, LoginUserInfo loginUser) throws Exception {
        OnlineorderhBean order = onlineorderhDao.findEntity(OnlineorderhBean.class, orderNo);
        if (null == order)
            throw new ClassNotFoundException(orderNo);
        if (order.getStatus() == 1)
            throw new ValidateFailedException(orderNo);

        onlineorderhDao.updateOnlineOrderStatus(orderNo, 2);
        this.generalLogOperator(Constants.UPDATE_OPER_TYPE, loginUser, order);
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void acceptOnlineOrder(String[] orderNos, LoginUserInfo loginUser) throws Exception {
        for (String orderNo : orderNos) {
            acceptOnlineOrder(orderNo, loginUser);
        }
    }

    public boolean checkPayment(String storeCode, String tableCode) throws Exception {
        OnlineorderhBean order = onlineorderhDao.findLastOnlineOrder(storeCode, tableCode);
        if (null != order) {
            Map<String, Object> queryParam = new HashMap<String, Object>();
            queryParam.put("orderfrom", 1);
            queryParam.put("orderno", order.getOrderno());
            List<OnlineorderdBean> offlineItems = onlineorderhDao.searchOrderDetails(queryParam);

            return null == offlineItems || offlineItems.isEmpty();
        }

        return true;
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public OnlineorderhBean paymentOffOnlineOrder(String orderNo, LoginUserInfo loginUser) throws Exception {
        OnlineorderhBean order = onlineorderhDao.findEntity(OnlineorderhBean.class, orderNo);
        if (null == order)
            throw new ClassNotFoundException(orderNo);
        if (order.getStatus() == 2)
            throw new ValidateFailedException(orderNo);

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        onlineorderhDao.updateOnlineOrderStatus(orderNo, 4);
        onlineorderpDao.saveOnlineOrderPayment("A01", order.getOrderno(), 1, 3, "线下", order.getAmountyf(), "", "", "", sdf.format(new Date()), loginUser.getUserCode());
        this.generalLogOperator(Constants.UPDATE_OPER_TYPE, loginUser, order);
        return order;
    }


    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public OnlineorderhBean paymentOnlineOrder(String orderNo, int paymentCode, String if_orderNo, String openid) throws Exception {
        OnlineorderhBean order = onlineorderhDao.findEntity(OnlineorderhBean.class, orderNo);
        if (null == order)
            throw new ClassNotFoundException(orderNo);
        if (order.getStatus() == 2)
            throw new ValidateFailedException(orderNo);

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        onlineorderhDao.updateOnlineOrderStatus(orderNo, 3);
        onlineorderpDao.saveOnlineOrderPayment("A01", order.getOrderno(), 1, paymentCode, 1 == paymentCode ? "微信" : "支付宝", order.getAmountyf(), if_orderNo, openid, "", sdf.format(new Date()), "SYSTEM");
        //this.generalLogOperator(Constants.UPDATE_OPER_TYPE, "SYSTEM", order);
        return order;
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public List<Map<String, Object>> paymentOffOnlineOrder(String[] orderNos, LoginUserInfo loginUser) throws Exception {
        List<Map<String, Object>> orders = new ArrayList<Map<String, Object>>();
        for (String orderNo : orderNos) {
            OnlineorderhBean order = paymentOffOnlineOrder(orderNo, loginUser);
            Map<String, Object> orderMap = new HashMap<String, Object>();
            orderMap.put("storeCode", order.getStrstorecode());
            orderMap.put("tableCode", order.getTablecode());

            orders.add(orderMap);
        }

        return orders;
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void paymentOnlineOrder(String storeCode, String tableCode) throws Exception {
        OnlineorderhBean order = onlineorderhDao.findLastOnlineOrder(storeCode, tableCode);
        if (null == order)
            throw new ClassNotFoundException();
        if (order.getStatus() > 2)
            throw new ValidateFailedException();

        //wyj fix bug 20200308
        //onlineorderhDao.updateOnlineOrderStatus(order.getOrderno(), 3);
        onlineorderhDao.updateOnlineOrderStatus(order.getOrderno(), 3);
    }

    @Deprecated
    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void saveOnlineorderh(String strstorecode, String tablecode, int offlineupdateflg, BuyCart buyCart, LoginUserInfo loginUser) throws Exception {
        String orderno = "A01" + DateUtils.dateToString(new Date(), "yyyyMMddHHmmss") + strstorecode;
        boolean checkOrderIsOver = onlineorderhDao.isOrderSettle(strstorecode, tablecode);//判断是否结单
        OnlineorderhBean onlineorderhBean = null;
        int suborderno = 1;
        List<BuyItem> items = buyCart.getItems();
        if (checkOrderIsOver) {
            onlineorderhBean = new OnlineorderhBean();
            Integer daysn = onlineorderhDao.getDaysn(strstorecode);
            //brandcode+YYMMDDHHMMSS+strstorecode+daysn
            onlineorderhBean.setOrderno(orderno + daysn);
            onlineorderhBean.setBrandcode("A01");
            onlineorderhBean.setStrstorecode(strstorecode);
            onlineorderhBean.setTablecode(tablecode);
            onlineorderhBean.setDaysn(daysn);
            onlineorderhBean.setDtorderstart(new Date());
            //onlineorderhBean.setdtorderupdate
            onlineorderhBean.setQty(buyCart.getTotalAmount());
            onlineorderhBean.setAmountyf(buyCart.getTotalPrice());
            onlineorderhBean.setOfflineupdateflg(offlineupdateflg);
            onlineorderhBean.setStatus(1);
            onlineorderhBean.setUpdateuser(loginUser.getUserName());
            onlineorderhBean.setUpdateDate(new Date());
            onlineorderhBean.setCreatuser(loginUser.getUserName());
            onlineorderhBean.setCreatDate(new Date());
        } else {
            onlineorderhBean = onlineorderhDao.findLastOnlineOrder(strstorecode, tablecode);
            onlineorderhBean.setDtorderupdate(new Date());
            suborderno = onlineorderhDao.getSubOrderNo(onlineorderhBean.getOrderno());//子表的下单序号
            onlineorderhBean.setQty(onlineorderhBean.getQty() + buyCart.getTotalAmount());
            onlineorderhBean.setAmountyf(onlineorderhBean.getAmountyf() + buyCart.getTotalPrice());
        }
        onlineorderhDao.save(generalLogOperator(Constants.INSERT_OPER_TYPE, loginUser, onlineorderhBean));
        onlineorderhDao.saveOrUpdate(onlineorderhBean);
        //存储子表
        // int line = 1;
        for (BuyItem bi : items) {
            OnlineItemBean i = onlineorderhDao.findOnlineItem(bi.getOnlineItem().getStrstorecode(), bi.getOnlineItem().getIntitemno());
            String itemDesc = null != i.getItem() ? i.getItem().getStrItemNameShort() : StringUtils.EMPTY;
            onlineorderhDao.saveOnlineOrderDetail(i.getBrandcode(), onlineorderhBean.getOrderno(), suborderno, bi.getLineNo(), onlineorderhDao.getItemType(i.getIntitemno()), itemDesc, bi.getPmodify(),
                    bi.getQuantity(), i.getPrice(), offlineupdateflg, loginUser.getUserName(), i.getIntitemno(), StringUtils.EMPTY);
        }
    }

    public boolean checkEntityOccupied(Serializable id) throws Exception {
        OnlineorderhBean existsDept = onlineorderhDao.findEntity(OnlineorderhBean.class, id);

        return null != existsDept;
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public List<OnlineorderpList> findOnlineorderhListByOpenId(String openId) throws Exception {
        return onlineorderhDao.findOnlineorderhListByOpenId(openId);
    }

    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public Boolean findOnlineorderhOrderNoByOpenId(String openId) throws Exception {
        List<OnlinePrepayBean> res = new ArrayList<>();
        Map<String, Object> map = new HashMap<>();
        map.put("status", 0);
        List<OnlinePrepayBean> prepayBeans = onlinePrepayDao.queryListBean(map);
        for (OnlinePrepayBean prepayBean : prepayBeans) {
            Map<String, Object> tempMap = new HashMap<>();
            tempMap.put("orderno", prepayBean.getOrderno());
            tempMap.put("openid", openId);
            List<OnlineorderhBean> orders = onlineorderhDao.searchList(tempMap);
            if (orders != null && orders.size() != 0) {
                res.add(prepayBean);
            }
        }
        if (res.size() == 0) {
            return false;
        }
//        Set<String> tempMap = new HashSet<>();
        Map<String, Object> queryMap = new HashMap<String, Object>();
        OnlinePrepayBean onlinePrepayBean = null;
        for (int i = 0; i < res.size(); i++) {
            onlinePrepayBean = res.get(i);
//            if(tempMap.contains(onlinePrepayBean.getOrderno())){
//                continue;
//            }
//            tempMap.add(onlinePrepayBean.getOrderno());
            queryMap.put("out_trade_no", onlinePrepayBean.getOut_trade_no());
            queryMap.put("order_no", onlinePrepayBean.getOrderno());
            OnlinestoreBean store = onlinestoreDao.findEntity(OnlinestoreBean.class, onlinePrepayBean.getStrstorecode());
            queryMap.put("sub_mch_id", store.getRemark1());
            if (configParam.getAliPaymentCode().equals(onlinePrepayBean.getPaymentcode().toString())) {
                callJiakeApiService.callJiakeApi_aliQuery_Service(queryMap);
            } else {
                callJiakeApiService.callJiakeApi_wxQuery_Service(queryMap);
            }
        }
        return true;
    }

    @Override
    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT, readOnly = false, rollbackFor = Exception.class)
    public void removeShoppingCart(String out_trade_no) {
        OnlineorderhBean onlineorderhBean = onlineorderhDao.findEntity(OnlineorderhBean.class, out_trade_no);
        if (onlineorderhBean.getTablecode() != null) {
            if (!onlineorderhBean.getTablecode().equals("qr")) {
                String cartKey = MessageFormat.format(Constants.BUYCART_REDIS, onlineorderhBean.getStrstorecode(), onlineorderhBean.getTablecode());
                redisCacheUtil.removeCacheByKey(cartKey);
            } else {
                if (onlineorderhBean.getOpenId().isEmpty()) {
                    logger.info("该订单缺少openid!");
                    return;
                }
                String cartKey = MessageFormat.format(Constants.BUYCART_REDIS, onlineorderhBean.getStrstorecode(), onlineorderhBean.getOpenId());
                redisCacheUtil.removeCacheByKey(cartKey);
            }
        }
    }

    @Override
    public Boolean exportExcel(HttpServletResponse response, Map<String, Object> queryParam) throws Exception {
//        switch (Integer.parseInt(queryParam.get("tablecode").toString())){
//            case 0:
//                queryParam.remove("tablecode");
//                break;
//            case 1:
//                queryParam.put(Constants.QUERY_NOTEQUAL + "tablecode", "qr");
//                break;
//            case 2:
//                queryParam.put("tablecode","qr");
//                break;
//        }
//        List<OnlineorderhBean> orders = onlineorderhDao.searchList(queryParam);
//        if(orders==null||orders.size()==0){
//            return false;
//        }
        boolean totalFlag = false;
        switch (Integer.parseInt(queryParam.get("tablecode").toString())) {
            case 0:
                queryParam.remove("tablecode");
                totalFlag = true;
                break;
            case 1:
                queryParam.remove("tablecode");
                queryParam.put(Constants.QUERY_NOTEQUAL + "tablecode", "qr");
                break;
            case 2:
                queryParam.put("tablecode", "qr");
                if (queryParam.get("status") != null) {
                    switch (Integer.parseInt(queryParam.get("status").toString())) {
                        case 1:
                            queryParam.put("status", 0);
                            break;
                        case 2:
                            queryParam.put("status", 3);
                            break;
                        case 3:
                            queryParam.put("status", 1);
                            break;
                    }
                }
                break;
        }
        List<OnlineorderhBean> orders;
        if (!totalFlag) {
            orders = onlineorderhDao.searchList(queryParam);
        } else {
            if (queryParam.get("status") != null) {
                queryParam.put(Constants.QUERY_NOTEQUAL + "tablecode", "qr");
                orders = onlineorderhDao.searchList(queryParam);
                switch (Integer.parseInt(queryParam.get("status").toString())) {
                    case 1:
                        queryParam.put("status", 0);
                        break;
                    case 2:
                        queryParam.put("status", 3);
                        break;
                    case 3:
                        queryParam.put("status", 1);
                        break;
                }
                queryParam.remove(Constants.QUERY_NOTEQUAL + "tablecode");
                queryParam.put("tablecode", "qr");
                orders.addAll(onlineorderhDao.searchList(queryParam));
            } else {
                orders = onlineorderhDao.searchList(queryParam);
            }
        }
        List<OnlineOrderhExport> list = new ArrayList<>();
        if (orders != null && orders.size() != 0) {
            orders.forEach(order -> {
                OnlineOrderhExport export = new OnlineOrderhExport(order);
                export.setId(String.valueOf(orders.indexOf(order) + 1));
                list.add(export);
            });
        }
        ExcelWriter writer = null;
        OutputStream out = null;
        try {
            String fileName = "ordeList";
            response.setCharacterEncoding("UTF-8");
            response.setContentType("application/vnd.ms-excel;charset=utf-8");
            response.setHeader("Content-Disposition", "attachment;filename=" + new String(fileName.getBytes(StandardCharsets.UTF_8), StandardCharsets.ISO_8859_1) + ".xlsx");
            out = response.getOutputStream();
            writer = new ExcelWriter(out, ExcelTypeEnum.XLSX);
            Sheet sheet = new Sheet(1, 0, OnlineOrderhExport.class);
            sheet.setSheetName("茑屋订单一览");
            writer.write(list, sheet);
            out.flush();
        } finally {
            if (writer != null) {
                writer.finish();
            }
            if (out != null) {
                out.close();
            }
        }
        return true;
    }
}
