package com.bettersoft.api.service.implement;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Service;

import com.bettersoft.api.dao.interfaces.ISystemLogDao;
import com.bettersoft.api.model.MenuTreeBean;
import com.bettersoft.api.model.SystemLogOperatorBean;
import com.bettersoft.api.service.interfaces.ISystemLogService;
import com.bettersoft.api.utils.EntityUtil;
import com.bettersoft.api.utils.PageInfoUtils;
import com.bettersoft.api.validmodel.SystemLogOperatorValidate;

@Service("systemLogService")
public class SystemLogService extends BaseService implements ISystemLogService {
	@Resource(name = "systemLogDao")
	private ISystemLogDao systemLogDao;

	public SystemLogOperatorValidate findLogOperator(String logId)
			throws Exception {
		SystemLogOperatorBean syslog = systemLogDao.findEntity(
				SystemLogOperatorBean.class, logId);

		if (!StringUtils.isEmpty(syslog.getOperatorObject())) {
			MenuTreeBean menu = systemLogDao.findEntity(MenuTreeBean.class,
					syslog.getOperatorObject());
			if (null != menu)
				syslog.setMenuName(menu.getMenuName());
		}

		return (SystemLogOperatorValidate) EntityUtil.cloneToEntity(
				SystemLogOperatorValidate.class, syslog);
	}

	public Map<String, Object> searchLogs(Map<String, Object> queryParam)
			throws Exception {
		List<SystemLogOperatorBean> syslogs = systemLogDao
				.searchLogOperators(queryParam);

		if (null != syslogs && !syslogs.isEmpty()) {
			for (SystemLogOperatorBean syslog : syslogs) {
				if (!StringUtils.isEmpty(syslog.getOperatorObject())) {
					MenuTreeBean menu = systemLogDao.findEntity(
							MenuTreeBean.class, syslog.getOperatorObject());
					if (null != menu)
						syslog.setMenuName(menu.getMenuName());
				}
			}
		}
		Number count = systemLogDao.searchLogOperatorCount(queryParam);

		return new PageInfoUtils(queryParam, syslogs, count).getPageInfoMap();
	}

	public boolean checkEntityOccupied(Serializable id) throws Exception {
		// TODO Auto-generated method stub
		return false;
	}

}
