package com.bettersoft.api.service.interfaces;

import com.bettersoft.api.utils.LoginUserInfo;
import com.bettersoft.api.validmodel.LoginAccountValidate;
import io.jsonwebtoken.Claims;
import org.springframework.transaction.annotation.Transactional;

public interface IAuthorizationService extends IBaseService {
    public void loginUser(LoginUserInfo loginUser, boolean force)
            throws Exception;

    public void logoutUser(LoginUserInfo loginUser) throws Exception;

    public Claims validateLoginUser(String token) throws Exception;

    public LoginUserInfo refreshLoginUser(String refreshToken) throws Exception;

//	public void register(MembershipValidate registerValidate) throws Exception;

    public void forgetPassword(LoginAccountValidate accountValidate)
            throws Exception;

    @Transactional
    boolean checkIsLock(LoginAccountValidate loginAccount) throws Exception;

    @Transactional
    void loginError(LoginAccountValidate loginAccount) throws Exception;

    @Transactional
    void resetIsLock(LoginAccountValidate loginAccount);
}
