package com.bettersoft.api.service.interfaces;

import java.util.List;
import java.util.Map;

import com.bettersoft.api.model.OnlineItemBean;
import com.bettersoft.api.utils.JsonResult;
import com.bettersoft.api.utils.LoginUserInfo;
import com.bettersoft.api.validmodel.OnlineItemPackageValidate;
import com.bettersoft.api.validmodel.OnlineItemValidate;
import com.bettersoft.api.validmodel.ShoppingCartValidate;

public interface IOnlineItemService extends IBaseService {
    public Map<String, Object> searchItem(Map<String, Object> queryParam) throws Exception;

    public void saveOnlineItem(OnlineItemValidate onlineItemValidate, LoginUserInfo loginUser) throws Exception;

    public void updateOnlineItem(OnlineItemValidate onlineItemValidate, LoginUserInfo loginUser) throws Exception;

    public void deleteOnlineItem(String str, LoginUserInfo loginUser) throws Exception;

    public void deleteOnlineItem(Long l, LoginUserInfo loginUser) throws Exception;

    public void updateOnlineItemImage(String storeCode, int itemId, String imageUrl, LoginUserInfo loginUser) throws Exception;

    public void updateOnlineItemStatus(OnlineItemValidate onlineItemValidate, int status, LoginUserInfo loginUser) throws Exception;

    public void updateOnlineItemStatus(String storeCode, int itemId, int status, LoginUserInfo loginUser) throws Exception;

    public OnlineItemPackageValidate findOnlineItem(String storeCode, int itemId) throws Exception;

    public OnlineItemPackageValidate findOfflineItem(String storeCode, String orderNo, Map<String, Object> offlineOrder) throws Exception;

    public OnlineItemBean findOnlineItem(Long l) throws Exception;

    public OnlineItemBean getSingleOnlineItem(String storeCode, int itemId);

    public Map<String, Object> getAllStrposfastkeyname(String strstorecode) throws Exception;

    public Map<String, Object> searchItemQr(Map<String, Object> queryParam) throws Exception;

    public void checkBuyCartStatus(ShoppingCartValidate shoppingCart, JsonResult jsonResult) throws Exception;
}
