package com.bettersoft.api.service.interfaces;

import java.util.List;
import java.util.Map;

import com.bettersoft.api.model.SystemDepartmentBean;
import com.bettersoft.api.utils.LoginUserInfo;
import com.bettersoft.api.validmodel.LoginAccountValidate;
import com.bettersoft.api.validmodel.SystemUserValidate;

public interface ISystemUserService extends IBaseService {
    public SystemUserValidate findUserByCode(String userCode) throws Exception;

    public Map<String, Object> searchUsers(Map<String, Object> queryParam)
            throws Exception;

    public List<SystemDepartmentBean> searchDepartments() throws Exception;

    public Map<String, Object> initParam() throws Exception;

    public void saveUser(SystemUserValidate userModel, LoginUserInfo loginUser)
            throws Exception;

    public void updateUser(SystemUserValidate userModel, LoginUserInfo loginUser)
            throws Exception;

    public void deleteUser(String userCode) throws Exception;

    public void modifyPassword(LoginAccountValidate accountValidate,
                               LoginUserInfo loginUser) throws Exception;
}
