package com.bettersoft.api.task;

import com.alibaba.fastjson.JSONObject;
import com.bettersoft.api.config.WxConfig;
import com.bettersoft.api.model.GetAccess;
import com.bettersoft.api.model.WxSession;
import com.bettersoft.api.utils.RedisCacheUtil;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.web.client.RestTemplate;

import javax.annotation.Resource;

public class GetAccessToken {
    private static Logger logger = Logger.getLogger(GetAccessToken.class);

    @Resource(name = "redisCacheUtil")
    private RedisCacheUtil redisCacheUtil;
    @Resource
    private RestTemplate restTemplate;

    public void executeTask() {
        logger.info("===============================获取token开始============================");
        HttpHeaders headers = new HttpHeaders();
        JSONObject param = new JSONObject();
        param.put("grant_type","client_credential");
        param.put("appid",WxConfig.appId);
        param.put("secret", WxConfig.secret);
        HttpEntity<JSONObject> request = new HttpEntity<JSONObject>(param, headers);
        GetAccess getAccess = restTemplate.getForObject(WxConfig.GET_ACCESS_TOKEN_URL, GetAccess.class,param);
        redisCacheUtil.setCache("access_token",getAccess.getAccess_token());
        logger.info("========================获取token结束==================================ce");
    }
}
