package com.bettersoft.api.utils;

import java.lang.reflect.Type;
import java.math.BigDecimal;

import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonParseException;
import com.google.gson.JsonPrimitive;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;

public class BigDecimalAdapter implements JsonSerializer<BigDecimal>,
		JsonDeserializer<BigDecimal> {
	
	public BigDecimalAdapter() {
		super();
	}

	@Override
	public BigDecimal deserialize(JsonElement json, Type typeOfT,
			JsonDeserializationContext context) throws JsonParseException {
		if (json == null) {
			return null;
		} else {
			try {
				return new BigDecimal(json.getAsString());
			} catch (Exception e) {
				return null;
			}
		}
	}

	public JsonElement serialize(BigDecimal src, Type typeOfSrc,
			JsonSerializationContext context) {
		String value = "";
		if (src != null) {
			value = String.valueOf(src.floatValue());
		}
		
		return new JsonPrimitive(value);
	}
}