package com.bettersoft.api.utils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

/**
 * Created by IntelliJ IDEA. User: user Date: 2007-4-24 Time: 21:33:51 To change
 * this template use File | Settings | File Templates.
 */
public class DateUtils {
	public static final String DATE_FORMAT = "yyyy-MM-dd";

	public static final String DATETIME_FORMAT = "yyyy-MM-dd HH:mm:ss";

	public static final String DATE_FORMAT_HOUR = "yyyy-MM-dd HH:mm";

	public static String dateToString(Date dateValue) {
		return dateToString(dateValue, DATETIME_FORMAT);
	}

	public static String[] produceDaysToShow(int days_to_show) {
		String[] days_to_show_array = new String[days_to_show];
		for (int i = 0; i < days_to_show; i++) {
			days_to_show_array[i] = DateUtils.addDays(new Date(), "yyyy-MM-dd",
					i);
		}
		return days_to_show_array;
	}

	public static String[] produceDaysToShow(Date date, int days_to_show) {
		String[] days_to_show_array = new String[days_to_show];
		for (int i = 0; i < days_to_show; i++) {
			days_to_show_array[i] = DateUtils.addDays(date, "yyyy-MM-dd", i);
		}
		return days_to_show_array;
	}

	public static String getNuberDate(Date dateValue) {
		return dateToString(dateValue, "yyyyMMddHHmmss");
	}

	public static String dateToString(Date dateValue, String format) {
		if (dateValue == null || format == null) {
			return null;
		} else {
			SimpleDateFormat dateFormat = new SimpleDateFormat(format);
			return dateFormat.format(dateValue);
		}
	}

	public static Date stringToDate(String stringValue) {
		return stringToDate(stringValue, DATETIME_FORMAT);
	}

	public static Date stringToDate(String stringValue, String format) {
		Date dateValue = null;
		if (stringValue != null && format != null) {
			try {
				SimpleDateFormat dateFormat = new SimpleDateFormat(format);
				dateValue = dateFormat.parse(stringValue);

			} catch (ParseException ex) {
				dateValue = null;
			}
		}
		return dateValue;
	}

	public static String addOneDay(Date dateValue, String format) {
		if (dateValue == null || format == null) {
			return null;
		} else {
			Calendar c = Calendar.getInstance();
			c.setTime(dateValue);
			c.set(Calendar.HOUR_OF_DAY, 23);
			c.set(Calendar.MINUTE, 59);
			SimpleDateFormat sdf = new SimpleDateFormat(format);
			return sdf.format(c.getTime());
		}
	}

	public static String addSeconds(String dateStr, int seconds) {
		if (dateStr == null) {
			return null;
		} else {
			Calendar c = Calendar.getInstance();
			c.set(Calendar.HOUR_OF_DAY, Integer.valueOf(dateStr.split(":")[0]));
			c.set(Calendar.MINUTE, Integer.valueOf(dateStr.split(":")[1]));
			c.set(Calendar.SECOND, Integer.valueOf(dateStr.split(":")[2])
					+ seconds);
			SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
			return sdf.format(c.getTime());
		}
	}

	public static String addDays(Date dateValue, String format, int daysToAdd) {
		if (dateValue == null || format == null) {
			return null;
		} else {
			Calendar c = Calendar.getInstance();
			c.setTime(dateValue);
			c.set(Calendar.DAY_OF_MONTH, c.get(Calendar.DAY_OF_MONTH)
					+ daysToAdd);
			c.set(Calendar.HOUR_OF_DAY, 23);
			c.set(Calendar.MINUTE, 0);
			SimpleDateFormat sdf = new SimpleDateFormat(format);
			return sdf.format(c.getTime());
		}
	}

	public static String cuntomFormat(int startTime, int endTime) {
		if (startTime < 0 || startTime > 24 || endTime < 0 || endTime > 24) {
			return null;
		}
		Calendar c1 = Calendar.getInstance();
		Calendar c2 = Calendar.getInstance();
		c1.set(Calendar.HOUR_OF_DAY, startTime);
		c1.set(Calendar.MINUTE, 0);
		c1.set(Calendar.SECOND, 0);
		c2.set(Calendar.HOUR_OF_DAY, endTime);
		c2.set(Calendar.MINUTE, 0);
		c2.set(Calendar.SECOND, 0);
		SimpleDateFormat sdf = new SimpleDateFormat("HH:mm");
		return sdf.format(c1.getTime()) + "-" + sdf.format(c2.getTime());
	}

	public static String cuntomFormat(int startTime) {
		if (startTime < 0 || startTime > 24) {
			return null;
		}
		Calendar c1 = Calendar.getInstance();
		c1.set(Calendar.HOUR_OF_DAY, startTime);
		c1.set(Calendar.MINUTE, 0);
		c1.set(Calendar.SECOND, 0);
		SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
		return sdf.format(c1.getTime());
	}

	public static String addMinutes(String beginTime, int minutesToAdd) {
		Calendar calendar = Calendar.getInstance();
		try {
			String[] temp = beginTime.split(":");
			calendar.set(Calendar.HOUR_OF_DAY, Integer.valueOf(temp[0]));
			calendar.set(Calendar.MINUTE, Integer.valueOf(temp[1]));
			calendar.set(Calendar.SECOND, Integer.valueOf(temp[2]));
			// calendar.add(Calendar.MINUTE, minutesToAdd);
			calendar.add(Calendar.SECOND, minutesToAdd);
			SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
			return sdf.format(calendar.getTime());
		} catch (IllegalArgumentException e) {
			return null;
		}
	}

	public static String getFirstDayDate() {
		Calendar c = Calendar.getInstance();

		c.set(Calendar.DATE, 1);
		c.set(Calendar.HOUR_OF_DAY, 0);
		c.set(Calendar.MINUTE, 0);
		c.set(Calendar.SECOND, 0);

		SimpleDateFormat format = new SimpleDateFormat(DATETIME_FORMAT);

		return format.format(c.getTime());
	}

	public static String getFirstDayDate(Date sdate) {
		Calendar c = Calendar.getInstance();
		c.setTime(sdate);
		c.set(Calendar.DATE, 1);
		c.set(Calendar.HOUR_OF_DAY, 0);
		c.set(Calendar.MINUTE, 0);
		c.set(Calendar.SECOND, 0);

		SimpleDateFormat format = new SimpleDateFormat(DATETIME_FORMAT);

		return format.format(c.getTime());
	}

	public static String getLastDayDate() {
		Calendar c = Calendar.getInstance();

		c.set(Calendar.DATE, 1);
		c.roll(Calendar.DAY_OF_MONTH, -1);
		c.set(Calendar.HOUR_OF_DAY, 23);
		c.set(Calendar.MINUTE, 59);
		c.set(Calendar.SECOND, 59);

		SimpleDateFormat format = new SimpleDateFormat(DATETIME_FORMAT);

		return format.format(c.getTime());
	}

	public static String getLastDayDate(Date sdate) {
		Calendar c = Calendar.getInstance();

		c.setTime(sdate);
		c.set(Calendar.DATE, 1);
		c.roll(Calendar.DAY_OF_MONTH, -1);
		c.set(Calendar.HOUR_OF_DAY, 23);
		c.set(Calendar.MINUTE, 59);
		c.set(Calendar.SECOND, 59);

		SimpleDateFormat format = new SimpleDateFormat(DATETIME_FORMAT);

		return format.format(c.getTime());
	}

	public static String getDayFirstDate(Date date) {

		Calendar c = Calendar.getInstance();
		c.setTime(date);
		c.set(Calendar.HOUR_OF_DAY, 0);
		c.set(Calendar.MINUTE, 0);
		c.set(Calendar.SECOND, 0);

		SimpleDateFormat format = new SimpleDateFormat(DATETIME_FORMAT);
		return format.format(c.getTime());
	}

	public static String getDayLastDate(Date date) {
		Calendar c = Calendar.getInstance();
		c.setTime(date);
		c.set(Calendar.HOUR_OF_DAY, 23);
		c.set(Calendar.MINUTE, 59);
		c.set(Calendar.SECOND, 59);

		SimpleDateFormat format = new SimpleDateFormat(DATETIME_FORMAT);
		return format.format(c.getTime());
	}

	public static Date parseDateString(String dateStr) {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		try {
			return sdf.parse(dateStr);
		} catch (Exception e) {
			return null;
		}
	}

	public static Date getDateFromDate(Date date) {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		Calendar c = Calendar.getInstance();
		String tmpDate = sdf.format(date);
		c.set(Calendar.YEAR, Integer.valueOf(tmpDate.split("-")[0]));
		c.set(Calendar.MONTH, Integer.valueOf(tmpDate.split("-")[1]));
		c.set(Calendar.DAY_OF_MONTH, Integer.valueOf(tmpDate.split("-")[2]));
		c.set(Calendar.HOUR, 0);
		c.set(Calendar.MINUTE, 0);
		c.set(Calendar.SECOND, 0);
		return c.getTime();
	}

	public static Date getCurrentDate() {
		Calendar c = Calendar.getInstance();
		c.set(Calendar.HOUR, 0);
		c.set(Calendar.MINUTE, 0);
		c.set(Calendar.SECOND, 0);
		c.set(Calendar.MILLISECOND, 0);

		return c.getTime();
	}

	public static boolean isAm(Date date) {
		SimpleDateFormat sdf = new SimpleDateFormat("HH:mm");

		Date compareDate = DateUtils.stringToDate(sdf.format(date), "HH:mm");
		Date time1 = DateUtils.stringToDate("00:00", "HH:mm");
		Date time2 = DateUtils.stringToDate("11:59", "HH:mm");

		return compareDate.getTime() >= time1.getTime()
				&& compareDate.getTime() <= time2.getTime();
	}

	public static boolean isPm(Date date) {
		SimpleDateFormat sdf = new SimpleDateFormat("HH:mm");

		Date compareDate = DateUtils.stringToDate(sdf.format(date), "HH:mm");
		Date time1 = DateUtils.stringToDate("12:00", "HH:mm");
		Date time2 = DateUtils.stringToDate("23:59", "HH:mm");

		return compareDate.getTime() >= time1.getTime()
				&& compareDate.getTime() <= time2.getTime();
	}

	/**
	 * 日期与时间合并
	 * 
	 * @param offset
	 *            日期偏移量
	 * 
	 * @return 返回新的日期+时间
	 */
	public static Date combinDateTime(Date date, Date time, int offset) {
		Calendar timeCal = Calendar.getInstance();
		timeCal.setTime(time);

		Calendar cal = Calendar.getInstance();
		cal.setTime(date);
		cal.add(Calendar.DATE, offset);
		cal.set(Calendar.HOUR_OF_DAY, timeCal.get(Calendar.HOUR_OF_DAY));
		cal.set(Calendar.MINUTE, timeCal.get(Calendar.MINUTE));
		cal.set(Calendar.SECOND, timeCal.get(Calendar.SECOND));
		cal.set(Calendar.MILLISECOND, timeCal.get(Calendar.MILLISECOND));

		return cal.getTime();
	}

	/**
	 * 判断两日期是否为同一天
	 * 
	 * @param date1
	 * @param date2
	 * @return
	 */
	public static boolean isSameDate(Date date1, Date date2) {
		Calendar cal1 = Calendar.getInstance();
		Calendar cal2 = Calendar.getInstance();

		cal1.setTime(date1);
		cal2.setTime(date2);

		return cal1.get(Calendar.YEAR) == cal2.get(Calendar.YEAR)
				&& cal1.get(Calendar.MONTH) == cal2.get(Calendar.MONTH)
				&& cal1.get(Calendar.DATE) == cal2.get(Calendar.DATE);
	}
}
