package com.bettersoft.api.utils;

import java.math.BigDecimal;
import java.text.ParseException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;


public final class LangUtils {

	public static int compareTime(Date date1, Date date2) {
		if (date1.getTime() == date2.getTime())
			return 0;
		else if (date1.getTime() > date2.getTime())
			return 1;
		else
			return -1;
	}
	
	public static Boolean optBoolean(Object value) {
		if (value == null)
			return false;
		if (value instanceof Boolean)
			return (Boolean) value;
		return false;
	}

	public static Double optDouble(Object value) {
		if (value == null)
			return 0.0;
		if (value instanceof Double)
			return (Double) value;
		if (value instanceof Long)
			return ((Long) value).doubleValue();
		if (value instanceof Integer)
			return ((Integer) value).doubleValue();
		if (value instanceof String)
			return Double.valueOf((String) value);
		return 0.0;
	}

	public static Long optLong(Object value)
	{
		if (value == null)
			return 0L;
		if (value instanceof Long)
			return (Long) value;
		if (value instanceof Double)
			return ((Double) value).longValue();
		if (value instanceof BigDecimal)
			return ((BigDecimal) value).longValue();
		if (value instanceof Integer)
			return ((Integer) value).longValue();
		if (value instanceof String)
			return Long.valueOf((String) value);
		
		return 0L;
	}

	public static Integer optInteger(Object value) {
		if (value == null)
			return 0;
		if (value instanceof Integer)
			return (Integer) value;
		if (value instanceof Double)
			return ((Double) value).intValue();
		if (value instanceof Long)
			return ((Long) value).intValue();
		if (value instanceof String)
			return Integer.valueOf((String) value);
		return 0;
	}

	public static String optString(Object value) {
		if (value == null)
			return "";
		if (value instanceof String)
			return (String) value;
		if (value instanceof Double)
			return ((Double) value).toString();
		if (value instanceof Integer)
			return ((Integer) value).toString();
		if (value instanceof Long)
			return ((Long) value).toString();
		return "";
	}


	@SuppressWarnings("unchecked")
	public static Map cloneMap(Map map) {
		Map clone = new HashMap();
		clone.putAll(map);
		return clone;
	}
	
	/**
	 * 字符串表示的类 加载为对应类
	 * @param parameterType
	 * @return
	 */
	public static Class[] stringToClass(String parameterType) {
		ClassLoader classLoader = LangUtils.class.getClassLoader();
		String[] parameterTypes = parameterType.split(",");
		Class[] clazzs = new Class[parameterTypes.length];
		for(int i=0; i<parameterTypes.length; i++){
			try {
				String className = parameterTypes[i];
				Class clazz = Class.forName(className);
				clazzs[i] = clazz;
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			}
		}
		return clazzs;
	}

}
