package com.bettersoft.api.utils;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.HashSet;
import java.util.Set;

public class LoginUserInfo implements Serializable {
    private static final long serialVersionUID = 4293385620972331643L;

    // 用户账号
    private String userCode;
    // 用户名称
    private String userName;
    // 用户头像
    private String photoUrl;
    // 用户菜单授权码JSON
    private Set<String> auths = new HashSet<String>();
    // 授权菜单
    private String authMenus;
    // 用户数据权限JSON
    private String authData;
    // 用户类型
    private String userType;
    // 用户状态
    private String userStatus;
    // 操作平台
    private String platform;
    // 是否为超级管理员
    private boolean supperUser;
    // 会话SESSION ID
    private String sessionId;
    private String advLimitDate;
    private String authStores;

    private String ticket;
    private String token;
    private String refreshToken;
    private String currentMenu;
    private Timestamp expireTime;

    public LoginUserInfo() {
        super();
    }

    public LoginUserInfo(String userCode, String userName) {
        super();
        this.userCode = userCode;
        this.userName = userName;
    }

    public String getUserCode() {
        return userCode;
    }

    public void setUserCode(String userCode) {
        this.userCode = userCode;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getPhotoUrl() {
        return photoUrl;
    }

    public void setPhotoUrl(String photoUrl) {
        this.photoUrl = photoUrl;
    }

    public String getAuthMenus() {
        return authMenus;
    }

    public void setAuthMenus(String authMenus) {
        this.authMenus = authMenus;
    }

    public Set<String> getAuths() {
        return auths;
    }

    public void setAuths(Set<String> auths) {
        this.auths = auths;
    }

    public String getAuthData() {
        return authData;
    }

    public void setAuthData(String authData) {
        this.authData = authData;
    }

    public boolean isSupperUser() {
        return supperUser;
    }

    public void setSupperUser(boolean supperUser) {
        this.supperUser = supperUser;
    }

    public String getSessionId() {
        return sessionId;
    }

    public void setSessionId(String sessionId) {
        this.sessionId = sessionId;
    }

    public String getTicket() {
        return ticket;
    }

    public void setTicket(String ticket) {
        this.ticket = ticket;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public String getRefreshToken() {
        return refreshToken;
    }

    public void setRefreshToken(String refreshToken) {
        this.refreshToken = refreshToken;
    }

    public String getUserType() {
        return userType;
    }

    public void setUserType(String userType) {
        this.userType = userType;
    }

    public String getPlatform() {
        return platform;
    }

    public void setPlatform(String platform) {
        this.platform = platform;
    }

    public String getUserStatus() {
        return userStatus;
    }

    public void setUserStatus(String userStatus) {
        this.userStatus = userStatus;
    }

    public String getCurrentMenu() {
        return currentMenu;
    }

    public void setCurrentMenu(String currentMenu) {
        this.currentMenu = currentMenu;
    }

    public String getAdvLimitDate() {
        return advLimitDate;
    }

    public void setAdvLimitDate(String advLimitDate) {
        this.advLimitDate = advLimitDate;
    }

    public Timestamp getExpireTime() {
        return expireTime;
    }

    public void setExpireTime(Timestamp expireTime) {
        this.expireTime = expireTime;
    }

    public String getAuthStores() {
        return authStores;
    }

    public void setAuthStores(String authStores) {
        this.authStores = authStores;
    }
}