package com.bettersoft.api.utils;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;

@SuppressWarnings("rawtypes")
public class MapTypeAdapter implements JsonDeserializer<Map> {

	@SuppressWarnings({ "unchecked" })
	@Override
	public Map deserialize(JsonElement json, Type typeOfT,
			JsonDeserializationContext context) throws JsonParseException {
		Map resultMap = new HashMap();
		JsonObject jsonObject = json.getAsJsonObject();
		Set<Map.Entry<String, JsonElement>> entrySet = jsonObject.entrySet();
		for (Map.Entry<String, JsonElement> entry : entrySet) {
			if (entry.getValue() instanceof JsonObject) {
				resultMap.put(entry.getKey(),
						deserialize(entry.getValue(), typeOfT, context));
			} else
				resultMap.put(entry.getKey(), entry.getValue());
		}
		
		return resultMap;
	}
}
