package com.bettersoft.api.utils;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.util.DigestUtils;

import com.bettersoft.api.model.OnlineorderdBean;
import com.bettersoft.api.model.OnlineorderpBean;
import com.google.gson.Gson;

public class OutInterfaceUtil
{
	public static final String secret = "abc123";//由QR点单系统提供
	public static final String url = "https://123.com";//url请求地址
	
	public Map<String, String> getPostParam(String appid, String method, String para)
	{
		Map<String, String> map = new HashMap<String, String>();
		map.put("appid", appid);
		map.put("method", method);
		String sign = appid+secret+DateUtils.dateToString(new Date());
		sign = DigestUtils.md5DigestAsHex(sign.getBytes());//md5加密
		map.put("sign", sign);
		map.put("para", para);
		return map;
	}
	
	//3.1本接口取得未处理（门店未接单）的订单
	public String getunprocessorders(String storecode, String appid)
	{
		String rs = "";
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("storecode", storecode);
		String para = (new Gson()).toJson(map);
		Map<String, String> postParam = getPostParam(appid, "getunprocessorders", para);
		rs = HttpClientUtil.doPost(url, postParam);
		return rs;
	}
	
	//3.2取得订单详细
	public String getorderdetail(String storecode, String orderno, String appid)
	{
		String rs = "";
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("storecode", storecode);
		map.put("orderno", orderno);
		String para = (new Gson()).toJson(map);
		Map<String, String> postParam = getPostParam(appid, "getorderdetail", para);
		rs = HttpClientUtil.doPost(url, postParam);
		return rs;
	}
	
	//3.3确认订单
	public String orderdone(String storecode, String orderno, String processflg,
			List suborderno, String posorderno, String appid)
	{
		String rs = "";
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("storecode", storecode);
		map.put("orderno", orderno);
		map.put("processflg", processflg);
		map.put("suborderno", suborderno);
		map.put("posorderno", posorderno);
		String para = (new Gson()).toJson(map);
		Map<String, String> postParam = getPostParam(appid, "orderdone", para);
		rs = HttpClientUtil.doPost(url, postParam);
		return rs;
	}
	
	//4.1线下点单同步
	public String offlineorderupload(String storecode, String posorderno, String tablecode,
			String dataType, List<OnlineorderdBean> detail, List<OnlineorderpBean> payments, String appid)
	{
		String rs = "";
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("storecode", storecode);
		map.put("posorderno", posorderno);
		map.put("tablecode", tablecode);
		map.put("dataType", dataType);
		map.put("detail", detail);
		map.put("payments", payments);
		String para = (new Gson()).toJson(map);
		Map<String, String> postParam = getPostParam(appid, "offlineorderupload", para);
		rs = HttpClientUtil.doPost(url, postParam);
		return rs;
	}
}
