package com.bettersoft.api.utils;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections.MapUtils;

public class PageInfoUtils {
	private Number page;
	private Number maxResults;
	private Number resultCount;
	@SuppressWarnings("rawtypes")
	private List rows;
	private Number total;

	public PageInfoUtils() {
		super();
	}

	@SuppressWarnings("rawtypes")
	public PageInfoUtils(Map<String, Object> queryParam, List rows,
			Number resultCount) {
		this.page = MapUtils.getNumber(queryParam,
				Constants.QUERY_FIRST_RESULTS, 0);
		this.maxResults = MapUtils.getNumber(queryParam,
				Constants.QUERY_MAX_RESULTS, 1);

		this.page = new BigDecimal(
				(page.floatValue() / maxResults.floatValue()) + 1).setScale(0);
		this.rows = rows;
		this.resultCount = resultCount;
		this.total = new BigDecimal(resultCount.floatValue()
				/ maxResults.floatValue()).setScale(0, RoundingMode.UP);

		if (0 == this.total.intValue())
			this.page = 0l;

	}

	public Map<String, Object> getPageInfoMap() {
		Map<String, Object> resultMap = new HashMap<String, Object>();

		resultMap.put("page", this.page.intValue());
		resultMap.put("rows", this.rows);
		resultMap.put("total", this.total.intValue());
		resultMap.put("records", this.resultCount.intValue());

		return resultMap;
	}
}
