package com.bettersoft.api.utils;

import java.io.File;
import java.io.FileOutputStream;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.lang.StringUtils;

public class RequestMapUtils {
	public static void mapToObj(Map<String, Object> map, Object obj) {
		try {
			BeanUtils.populate(obj, map);

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * @author kane
	 * @param reqMap
	 * @return
	 */
	@SuppressWarnings({ "rawtypes" })
	public static Map RequestMapToMap(Map<String, String[]> reqMap,
			Boolean... isReplace) {
		Map<String, Object> objMap = new HashMap<String, Object>();
		String[] a;
		String sort = "";
		String order = "asc";
		try {
			for (String key : reqMap.keySet()) {
				a = (String[]) reqMap.get(key);
				if (key.startsWith("param")) {
					if (null == isReplace
							|| (0 < isReplace.length && isReplace[0]))
						key = key.substring(6).trim().replace("_", ".");
					else
						key = key.substring(6).trim();
					if (null != a && !StringUtils.isEmpty(a[0].trim())) {
						String expression = getExpressionInKey(key);
						objMap.put(
								expression + key.substring(expression.length()),
								new String(a[0].trim().getBytes(
										Constants.CHARACTERSET_CODING),
										Constants.CHARACTERSET_CODING));
					}
				}
				if (key.equalsIgnoreCase("page")) {
					objMap.put("firstResults", a[0]);
				}
				if (key.equalsIgnoreCase("rows")
						|| key.equalsIgnoreCase("limit")) {
					objMap.put("maxResults", a[0]);
				}
				if (key.equalsIgnoreCase("sidx")) {
					sort = a[0];
				}
				if (key.equalsIgnoreCase("sord")) {
					order = a[0];
				}
			}

			if (!sort.equals("")) {
				objMap.put("orderBy", sort + " " + order);

			}
			if (objMap.get("maxResults") != null
					& objMap.get("firstResults") != null) {
				objMap.put(
						"firstResults",
						new Integer(objMap.get("maxResults").toString())
								.intValue()
								* (new Integer(objMap.get("firstResults")
										.toString()).intValue() - 1));
				objMap.put("maxResults", new Integer(objMap.get("maxResults")
						.toString()));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return objMap;

	}

	/**
	 * @author lgcheng
	 * @param reqMap
	 * @return
	 */
	@SuppressWarnings("rawtypes")
	public static Map RequestMapArrayToMap(Map<String, Object> reqMap) {
		Map<String, Object> objMap = new HashMap<String, Object>();
		String[] a;

		try {
			for (String key : reqMap.keySet()) {
				a = (String[]) reqMap.get(key);
				objMap.put(key, a[0]);

			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		return objMap;

	}

	/**
	 * @author kane
	 * @param list
	 * @param parentClass
	 * @param subClass
	 * @param o
	 * @return
	 * @throws Exception
	 */

	@SuppressWarnings({ "unchecked", "rawtypes" })
	public static List oneToManyObjectReadyBeforeSave(List list,
			String parentClass, String subClass, Object o) throws Exception {
		Class parent = Class.forName(parentClass);
		Class cls = Class.forName(subClass);
		List result = new ArrayList();
		@SuppressWarnings("unused")
		Object obj = Class.forName(subClass).newInstance();

		for (Iterator iterator = list.iterator(); iterator.hasNext();) {
			Object object = (Object) iterator.next();
			Method meth = cls.getMethod(
					"set"
							+ parentClass.substring(parentClass
									.lastIndexOf(".") + 1), parent);
			@SuppressWarnings("unused")
			Object retobj = meth.invoke(object, o);
			result.add(object);

		}
		return result;

	}

	/**
	 * @author kane
	 * @param list
	 * @param parentClass
	 * @param subClass
	 * @param o
	 * @return
	 * @throws Exception
	 */
	@SuppressWarnings({ "unchecked", "rawtypes" })
	public static List oneToManyObjectReadyBeforeSave1(List list,
			String parentClass, String subClass, Object o) throws Exception {
		Class parent = Class.forName(parentClass);
		Class cls = Class.forName(subClass);
		List result = new ArrayList();
		@SuppressWarnings("unused")
		Object obj = Class.forName(subClass).newInstance();

		for (Iterator iterator = list.iterator(); iterator.hasNext();) {
			Object object = (Object) iterator.next();
			Method meth = cls.getMethod(
					"set"
							+ parentClass.substring(parentClass
									.lastIndexOf(".") + 1), parent);
			@SuppressWarnings("unused")
			Object retobj = meth.invoke(object, o);
			result.add(object);
		}
		return result;

	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	public static Map<String, Object> beanToMap(Object bean, String className)
			throws Exception {
		Class cls = Class.forName(className);
		Map<String, Object> valueMap = new HashMap<String, Object>();

		Field[] fields = cls.getDeclaredFields();
		String temp = "";
		for (Field field : fields) {
			try {
				String fieldType = field.getType().getSimpleName();
				String fieldGetName = parGetName(field.getName());
				if ("Set".equals(fieldType)
						|| cls.getSimpleName().equals(fieldType)) {
					continue;
				}
				temp = fieldGetName + ":" + className;
				Method fieldGetMet = cls
						.getMethod(fieldGetName, new Class[] {});
				Object fieldVal = fieldGetMet.invoke(bean, new Object[] {});

				valueMap.put(field.getName(), fieldVal);
			} catch (Exception e) {
				System.out.println(temp);
				e.printStackTrace();
				continue;
			}
		}
		return valueMap;

	}

	/**
	 * ƴ��ĳ���Ե� get����s
	 * 
	 * @param fieldName
	 * @return String
	 */
	public static String parGetName(String fieldName) {
		if (null == fieldName || "".equals(fieldName)) {
			return null;
		}
		return "get" + fieldName.substring(0, 1).toUpperCase()
				+ fieldName.substring(1);
	}

	/**
	 * 
	 * @param fieldName
	 * @return String
	 */
	public static String parSetName(String fieldName) {
		if (null == fieldName || "".equals(fieldName)) {
			return null;
		}
		return "set" + fieldName.substring(0, 1).toUpperCase()
				+ fieldName.substring(1);
	}

	public static void backup(byte[] b, String fileName) throws Exception {
		FileOutputStream fos = null;
		String backupPath = "/users";
		try {
			File path = new File(backupPath);
			if (!path.exists()) {
				path.mkdirs();
			}
			File file = new File(backupPath, fileName);
			fos = new FileOutputStream(file);
			fos.write(b);
			fos.flush();
		} finally {
			if (fos != null) {
				fos.close();
				fos = null;
			}
		}
	}

	private static String getExpressionInKey(String key) {
		String cloneKey = key.replace("_", ".");
		if (0 <= cloneKey.indexOf(Constants.QUERY_BEGIN_WITH))
			return Constants.QUERY_BEGIN_WITH;
		if (0 <= cloneKey.indexOf(Constants.QUERY_END_DATE))
			return Constants.QUERY_END_DATE;
		if (0 <= cloneKey.indexOf(Constants.QUERY_END_WITH))
			return Constants.QUERY_END_WITH;
		if (0 <= cloneKey.indexOf(Constants.EQUAL_DATE))
			return Constants.EQUAL_DATE;
		if (0 <= cloneKey.indexOf(Constants.QUERY_GREATE_EQUAL_DATE))
			return Constants.QUERY_GREATE_EQUAL_DATE;
		if (0 <= cloneKey.indexOf(Constants.QUERY_GREATE_DATE))
			return Constants.QUERY_GREATE_DATE;
		if (0 <= cloneKey.indexOf(Constants.QUERY_GREATE_EQUAL))
			return Constants.QUERY_GREATE_EQUAL;
		if (0 <= cloneKey.indexOf(Constants.QUERY_GREATE))
			return Constants.QUERY_GREATE;
		if (0 <= cloneKey.indexOf(Constants.QUERY_LESS))
			return Constants.QUERY_LESS;
		if (0 <= cloneKey.indexOf(Constants.QUERY_LESS_DATE))
			return Constants.QUERY_LESS_DATE;
		if (0 <= cloneKey.indexOf(Constants.QUERY_LESS_EQUAL))
			return Constants.QUERY_LESS_EQUAL;
		if (0 <= cloneKey.indexOf(Constants.QUERY_LESS_EQUAL_DATE))
			return Constants.QUERY_LESS_EQUAL_DATE;
		if (0 <= cloneKey.indexOf(Constants.QUERY_LIKE))
			return Constants.QUERY_LIKE;
		if (0 <= cloneKey.indexOf(Constants.QUERY_NOTEQUAL))
			return Constants.QUERY_NOTEQUAL;
		if (0 <= cloneKey.indexOf(Constants.QUERY_NOTEQUAL_DATE))
			return Constants.QUERY_NOTEQUAL_DATE;
		if (0 <= cloneKey.indexOf(Constants.QUERY_SPEC_CONDITION))
			return Constants.QUERY_SPEC_CONDITION;

		return StringUtils.EMPTY;
	}
}
