package com.bettersoft.api.utils;

import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.ConfigurableListableBeanFactory;
import org.springframework.beans.factory.config.PropertyPlaceholderConfigurer;

public class ValidateMessagerPropertyConfig extends
		PropertyPlaceholderConfigurer {
	private Map<String, String> validateMsgMap = new HashMap<String, String>();

	@Override
	protected void processProperties(
			ConfigurableListableBeanFactory beanFactoryToProcess,
			Properties props) throws BeansException {
		super.processProperties(beanFactoryToProcess, props);
		for (Object key : props.keySet()) {
			String value = props.getProperty(key.toString());

			validateMsgMap.put(key.toString(), value);
		}
	}

	public String getValidateMsgValue(String key) {
		key = key.replace("{", "").replace("}", "");
		return MapUtils.getString(validateMsgMap, key, StringUtils.EMPTY);
	}
}
