package com.bettersoft.api.validmodel;

import org.hibernate.validator.constraints.NotBlank;

import com.bettersoft.api.annotation.FieldCommon;
import com.bettersoft.api.validategroup.AppLoginForgetPasswordValidate;
import com.bettersoft.api.validategroup.AppLgoinSmsValidate;
import com.bettersoft.api.validategroup.AppLoginPwdValidate;
import com.bettersoft.api.validategroup.CommonLoginValidate;

public class LoginAccountValidate extends BaseValidate {
	private static final long serialVersionUID = 5078866897098531446L;

	@NotBlank(message = "{field.notempty}")
	@FieldCommon(common = "登录账号")
	private String account;
	@NotBlank(message = "{field.notempty}", groups = {
			AppLoginPwdValidate.class, CommonLoginValidate.class })
	@FieldCommon(common = "登录密码")
	private String password;
	@FieldCommon(common = "新密码")
	@NotBlank(message = "{field.notempty}", groups = { AppLoginForgetPasswordValidate.class })
	private String modifyPassword;
	@FieldCommon(common = "登录类型")
	private String loginType;
	@FieldCommon(common = "会话SESSION ID")
	private String sessionId;
	@FieldCommon(common = "登录平台")
	private String platform;
	@FieldCommon(common = "短信验证码")
	@NotBlank(message = "{field.notempty}", groups = {
			AppLgoinSmsValidate.class, AppLoginForgetPasswordValidate.class })
	private String smsCode;

	public LoginAccountValidate() {
		super();
	}

	public LoginAccountValidate(String account, String password) {
		super();
		this.account = account;
		this.password = password;
	}

	public LoginAccountValidate(String account, String password,
			String loginType) {
		super();
		this.account = account;
		this.password = password;
		this.loginType = loginType;
	}

	public String getAccount() {
		return account;
	}

	public void setAccount(String account) {
		this.account = account;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String getModifyPassword() {
		return modifyPassword;
	}

	public void setModifyPassword(String modifyPassword) {
		this.modifyPassword = modifyPassword;
	}

	public String getLoginType() {
		return loginType;
	}

	public void setLoginType(String loginType) {
		this.loginType = loginType;
	}

	public String getSessionId() {
		return sessionId;
	}

	public void setSessionId(String sessionId) {
		this.sessionId = sessionId;
	}

	public String getPlatform() {
		return platform;
	}

	public void setPlatform(String platform) {
		this.platform = platform;
	}

	public String getSmsCode() {
		return smsCode;
	}

	public void setSmsCode(String smsCode) {
		this.smsCode = smsCode;
	}
}
