package com.bettersoft.api.validmodel;

import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

import org.hibernate.validator.constraints.NotBlank;

import com.bettersoft.api.annotation.FieldCommon;

public class ProvincialAreaValidate extends BaseValidate {
	private static final long serialVersionUID = -8497153970224243151L;

	@NotBlank(message = "{field.notempty}")
	@Size(max = 50, message = "{field.length}")
	@Pattern(regexp = "^[a-zA-Z0-9]+$", message = "{field.codformat}")
	@FieldCommon(common = "地区编号")
	private String areaCode;
	@NotBlank(message = "{field.notempty}")
	@FieldCommon(common = "地区描述")
	private String areaName;
	@FieldCommon(common = "行政级别")
	private int provincialLevel;

	@FieldCommon(common = "上级行政区")
	private String parentAreaCode;
	private String parentAreaName;

	public String getAreaCode() {
		return areaCode;
	}

	public void setAreaCode(String areaCode) {
		this.areaCode = areaCode;
	}

	public String getAreaName() {
		return areaName;
	}

	public void setAreaName(String areaName) {
		this.areaName = areaName;
	}

	public int getProvincialLevel() {
		return provincialLevel;
	}

	public void setProvincialLevel(int provincialLevel) {
		this.provincialLevel = provincialLevel;
	}

	public String getParentAreaCode() {
		return parentAreaCode;
	}

	public void setParentAreaCode(String parentAreaCode) {
		this.parentAreaCode = parentAreaCode;
	}

	public String getParentAreaName() {
		return parentAreaName;
	}

	public void setParentAreaName(String parentAreaName) {
		this.parentAreaName = parentAreaName;
	}
}
