package com.bettersoft.api.validmodel;

import javax.validation.constraints.Size;

import org.hibernate.validator.constraints.NotBlank;

import com.bettersoft.api.annotation.FieldCommon;
import com.bettersoft.api.annotation.NotCopy;

public class SystemConfigurationValidate extends BaseValidate {
	private static final long serialVersionUID = -6209452932966097238L;

	@NotBlank(message = "{field.notempty}")
	@Size(max = 50, message = "{field.length}")
	@FieldCommon(common = "系统配置编号")
	@NotCopy
	private String configCode;
	@NotBlank(message = "{field.notempty}")
	@FieldCommon(common = "系统配置描述")
	private String configDesc;
	@NotBlank(message = "{field.notempty}")
	@FieldCommon(common = "系统配置值")
	private String configValue;
	private boolean enable;
	private String remark;

	public String getConfigCode() {
		return configCode;
	}

	public void setConfigCode(String configCode) {
		this.configCode = configCode;
	}

	public String getConfigDesc() {
		return configDesc;
	}

	public void setConfigDesc(String configDesc) {
		this.configDesc = configDesc;
	}

	public String getConfigValue() {
		return configValue;
	}

	public void setConfigValue(String configValue) {
		this.configValue = configValue;
	}

	public boolean isEnable() {
		return enable;
	}

	public void setEnable(boolean enable) {
		this.enable = enable;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}
}
