package com.bettersoft.api.validmodel;

import java.io.Serializable;

import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

import org.hibernate.validator.constraints.NotBlank;

import com.bettersoft.api.annotation.FieldCommon;
import com.bettersoft.api.annotation.NotCopy;

public class SystemDepartmentValidate extends BaseValidate implements
		Serializable {
	private static final long serialVersionUID = 2267732204281486704L;

	@NotBlank(message = "{field.notempty}")
	@Size(max = 10, message = "{field.length}")
	@Pattern(regexp = "^[a-zA-Z0-9]+$", message = "{field.codformat}")
	@FieldCommon(common = "组织编号")
	@NotCopy
	private String departmentCode;
	@Size(min = 1, max = 100, message = "{filed.length}")
	@FieldCommon(common = "组织名称")
	private String departmentDesc;
	private boolean enable;
	private String remark;

	private String parentCode;
	private String parentDesc;

	public String getDepartmentCode() {
		return departmentCode;
	}

	public void setDepartmentCode(String departmentCode) {
		this.departmentCode = departmentCode;
	}

	public String getDepartmentDesc() {
		return departmentDesc;
	}

	public void setDepartmentDesc(String departmentDesc) {
		this.departmentDesc = departmentDesc;
	}

	public boolean isEnable() {
		return enable;
	}

	public void setEnable(boolean enable) {
		this.enable = enable;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public String getParentCode() {
		return parentCode;
	}

	public void setParentCode(String parentCode) {
		this.parentCode = parentCode;
	}

	public String getParentDesc() {
		return parentDesc;
	}

	public void setParentDesc(String parentDesc) {
		this.parentDesc = parentDesc;
	}
}