package com.bettersoft.api.validmodel;

import java.io.Serializable;

import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

import org.hibernate.validator.constraints.NotBlank;

import com.bettersoft.api.annotation.FieldCommon;

public class SystemMenuTreeValidate extends BaseValidate implements
		Serializable {
	private static final long serialVersionUID = -8495268952104657014L;

	@NotBlank(message = "{field.notempty}")
	@Size(max = 10, message = "{field.length}")
	@Pattern(regexp = "^[a-zA-Z0-9]+$", message = "{field.codformat}")
	@FieldCommon(common = "菜单编号")
	private String menuCode;
	@NotBlank(message = "{field.notempty}")
	@FieldCommon(common = "菜单名称")
	private String menuName;
	@FieldCommon(common = "菜单排序")
	private int priority;
	@FieldCommon(common = "是否有效")
	private boolean enable;
	@FieldCommon(common = "菜单URL")
	private String menuUrl;
	@FieldCommon(common = "菜单路由")
	private String menuRoute;
	@FieldCommon(common = "菜单图标")
	private String menuIcon;
	@FieldCommon(common = "菜单类型")
	private String menuType;
	@FieldCommon(common = "父级菜单")
	private String parentCode;
	private String parentName;

	private String perms;

	public String getMenuCode() {
		return menuCode;
	}

	public void setMenuCode(String menuCode) {
		this.menuCode = menuCode;
	}

	public String getMenuName() {
		return menuName;
	}

	public void setMenuName(String menuName) {
		this.menuName = menuName;
	}

	public int getPriority() {
		return priority;
	}

	public void setPriority(int priority) {
		this.priority = priority;
	}

	public boolean isEnable() {
		return enable;
	}

	public void setEnable(boolean enable) {
		this.enable = enable;
	}

	public String getMenuUrl() {
		return menuUrl;
	}

	public void setMenuUrl(String menuUrl) {
		this.menuUrl = menuUrl;
	}

	public String getMenuRoute() {
		return menuRoute;
	}

	public void setMenuRoute(String menuRoute) {
		this.menuRoute = menuRoute;
	}

	public String getMenuIcon() {
		return menuIcon;
	}

	public void setMenuIcon(String menuIcon) {
		this.menuIcon = menuIcon;
	}

	public String getMenuType() {
		return menuType;
	}

	public void setMenuType(String menuType) {
		this.menuType = menuType;
	}

	public String getParentCode() {
		return parentCode;
	}

	public void setParentCode(String parentCode) {
		this.parentCode = parentCode;
	}

	public String getParentName() {
		return parentName;
	}

	public void setParentName(String parentName) {
		this.parentName = parentName;
	}

	public String getPerms() {
		return perms;
	}

	public void setPerms(String perms) {
		this.perms = perms;
	}
}
