package com.bettersoft.api.validmodel;

import java.io.Serializable;

import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

import org.hibernate.validator.constraints.NotBlank;

import com.bettersoft.api.annotation.FieldCommon;
import com.bettersoft.api.annotation.NotCopy;

public class SystemPermissionValidate extends BaseValidate implements
		Serializable {
	private static final long serialVersionUID = -4740412848727504375L;

	@NotBlank(message = "{field.notempty}")
	@Size(max = 10, message = "{field.length}")
	@Pattern(regexp = "^[a-zA-Z0-9]+$", message = "{field.codformat}")
	@FieldCommon(common = "权限编号")
	@NotCopy
	private String permissionCode;
	@NotBlank(message = "{field.notempty}")
	@FieldCommon(common = "权限描述")
	private String permissionDesc;
	@FieldCommon(common = "权限类型")
	private String permissionType;

	public String getPermissionCode() {
		return permissionCode;
	}

	public void setPermissionCode(String permissionCode) {
		this.permissionCode = permissionCode;
	}

	public String getPermissionDesc() {
		return permissionDesc;
	}

	public void setPermissionDesc(String permissionDesc) {
		this.permissionDesc = permissionDesc;
	}

	public String getPermissionType() {
		return permissionType;
	}

	public void setPermissionType(String permissionType) {
		this.permissionType = permissionType;
	}
}
