package com.bettersoft.api.validmodel;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

import org.hibernate.validator.constraints.NotBlank;

import com.bettersoft.api.annotation.FieldCommon;
import com.bettersoft.api.annotation.NotCopy;

public class SystemRoleValidate extends BaseValidate implements Serializable {
	private static final long serialVersionUID = -8939362554774902218L;

	@NotBlank(message = "{field.notempty}")
	@Size(max = 10, message = "{field.length}")
	@Pattern(regexp = "^[a-zA-Z0-9]+$", message = "{field.codformat}")
	@FieldCommon(common = "角色编号")
	@NotCopy
	private String roleCode;
	@NotBlank(message = "{field.notempty}")
	@FieldCommon(common = "角色名称")
	private String roleName;
	@FieldCommon(common = "角色备注")
	private String remark;
	@NotBlank(message = "{field.notempty}")
	@FieldCommon(common = "所属部门")
	private String departmentCode;

	private String departmentName;

	@NotCopy
	private List<Map<String, Object>> menuPerms = new ArrayList<Map<String, Object>>();
	@NotCopy
	private String deptDatas;

	public String getRoleCode() {
		return roleCode;
	}

	public void setRoleCode(String roleCode) {
		this.roleCode = roleCode;
	}

	public String getRoleName() {
		return roleName;
	}

	public void setRoleName(String roleName) {
		this.roleName = roleName;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public String getDepartmentCode() {
		return departmentCode;
	}

	public void setDepartmentCode(String departmentCode) {
		this.departmentCode = departmentCode;
	}

	public String getDepartmentName() {
		return departmentName;
	}

	public void setDepartmentName(String departmentName) {
		this.departmentName = departmentName;
	}

	public List<Map<String, Object>> getMenuPerms() {
		return menuPerms;
	}

	public void setMenuPerms(List<Map<String, Object>> menuPerms) {
		this.menuPerms = menuPerms;
	}

	public String getDeptDatas() {
		return deptDatas;
	}

	public void setDeptDatas(String deptDatas) {
		this.deptDatas = deptDatas;
	}
}
