package com.bettersoft.api.validmodel;

import java.io.Serializable;

import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

import org.hibernate.validator.constraints.NotBlank;

import com.bettersoft.api.annotation.FieldCommon;
import com.bettersoft.api.annotation.NotCopy;

public class SystemUserValidate extends BaseValidate implements Serializable {
    private static final long serialVersionUID = -1754106979663298223L;

    @NotBlank(message = "{field.notempty}")
    @Size(max = 10, message = "{field.length}")
    @Pattern(regexp = "^[a-zA-Z0-9]+$", message = "{field.codformat}")
    @FieldCommon(common = "用户编号")
    private String userCode;
    @NotBlank(message = "{field.notempty}")
    @FieldCommon(common = "用户名")
    private String userName;
    @FieldCommon(common = "用户密码")
    private String password;
    @FieldCommon(common = "手机号")
    private String mobile;
    @FieldCommon(common = "邮箱")
    private String email;
    private boolean enable;
    private String departmentCode;
    private String departmentName;
    @NotCopy
    private String roles;
    @NotCopy
    private String stores;

    public String getUserCode() {
        return userCode;
    }

    public void setUserCode(String userCode) {
        this.userCode = userCode;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public boolean isEnable() {
        return enable;
    }

    public void setEnable(boolean enable) {
        this.enable = enable;
    }

    public String getDepartmentCode() {
        return departmentCode;
    }

    public void setDepartmentCode(String departmentCode) {
        this.departmentCode = departmentCode;
    }

    public String getDepartmentName() {
        return departmentName;
    }

    public void setDepartmentName(String departmentName) {
        this.departmentName = departmentName;
    }

    public String getRoles() {
        return roles;
    }

    public void setRoles(String roles) {
        this.roles = roles;
    }

    public String getStores() { return stores; }

    public void setStores(String stores) { this.stores = stores; }
}
