package com.bettersoft.api.websocket;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter;
import org.springframework.web.socket.config.annotation.EnableWebSocket;
import org.springframework.web.socket.config.annotation.WebSocketConfigurer;
import org.springframework.web.socket.config.annotation.WebSocketHandlerRegistry;

@Component
@EnableWebSocket
public class WebSocketConfig extends WebMvcConfigurerAdapter implements
		WebSocketConfigurer {

	@Autowired
	private BettersoftHandShakeInterceptor bettersoftHandShakeInterceptor;
	@Autowired
	private BettersoftWebSocketHandler bettersoftHandler;

	@Override
	public void registerWebSocketHandlers(WebSocketHandlerRegistry registry) {
		registry.addHandler(bettersoftHandler, "/ws")
				.addInterceptors(bettersoftHandShakeInterceptor)
				.setAllowedOrigins("*");

		registry.addHandler(bettersoftHandler, "/ws/sockjs")
				.addInterceptors(bettersoftHandShakeInterceptor)
				.setAllowedOrigins("*").withSockJS();
	}
}
