package comm.hibernate;

import com.bettersoft.api.model.OnlineorderhBean;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;
import java.util.Map;

public interface IBaseHibernateDao {
	public <T> List<T> generalSearch(String fromHql,
			Map<String, Object> queryParam, String orderByHql);

	public <T> List<T> generalSearch(String fromHql,
			Map<String, Object> queryParam, String orderByHql, boolean lockFlag);

	public Number generalCount(String fromHql, Map<String, Object> queryParam,
			boolean... holdOn);

	public <T> List<T> generalSearchBySql(String fromSql,
			Map<String, Object> queryParam, String orderBySql);

	public Number generalCountBySql(String fromSql,
			Map<String, Object> queryParam, boolean... holdOn);

	@SuppressWarnings("unchecked")
	public Number executeByHql(final String fromHql,
			final Map<String, Object> queryParam,
			final Map<String, Object>... valueParams) throws Exception;

	public <T> Serializable save(T entity);

	public <T> T findEntity(Class<T> entity, Serializable id);

	public <T> T findEntity(Class<T> entity);

	public <T> T loadEntity(Class<T> entity, Serializable id);

	public <T> void update(Object entity);
	
	public int updataByOriginSql(final String updateOriginSql);

	public <T> void saveOrUpdate(Object entity);

	public <T> void saveOrUpdateAll(Collection<T> collection);

	public <T> void delete(Class<T> entity, Serializable id);

	public void delete(Object object);

	public <T> void deleteAll(Collection<T> collection);

	public <T> List<OnlineorderhBean> generalSearchByFullSql(String fromSql,
															 Map<String, Object> queryParam, String orderBySql);

	public Number generalCountByFullSql(String fromSql);

}
