package com.bettersoft.api.unittest.dao.implement;

import java.util.Properties;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.jdbc.core.JdbcTemplate;

import com.bettersoft.api.unittest.dao.interfaces.IBettersoftApiTestNGDao;
import com.bettersoft.api.unittest.utils.ResourceUtils;
import com.mchange.v2.c3p0.ComboPooledDataSource;

public class BettersoftApiTestNGDao implements IBettersoftApiTestNGDao {
	private JdbcTemplate jdbcTemplate;
	private Log logger = LogFactory.getLog(getClass());

	public BettersoftApiTestNGDao() throws Exception {
		if (jdbcTemplate == null) {
			Properties properties = new Properties();
			properties.load(ResourceUtils
					.getResourceAsStream("/jdbc.properties"));

			ComboPooledDataSource dataSource = new ComboPooledDataSource();
			dataSource.setDriverClass(properties
					.getProperty("jdbc.driverClassName"));
			dataSource.setJdbcUrl(properties.getProperty("jdbc.url"));
			dataSource.setUser(properties.getProperty("jdbc.username"));
			dataSource.setPassword(properties.getProperty("jdbc.password"));
			jdbcTemplate = new JdbcTemplate(dataSource);
		}
	}

	public void executeSqlCommand(String fromSql) {
		if (StringUtils.isEmpty(fromSql))
			return;
		try {
			if (null != jdbcTemplate)
				jdbcTemplate.execute(fromSql);
			logger.info("executeSqlCommand success:" + fromSql);
		} catch (Exception ex) {
			logger.error("executeSqlCommand success:" + fromSql, ex);
		}
	}

}
