package com.bettersoft.api.unittest.utils;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

import javax.transaction.Transactional;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.junit.runner.RunWith;
import org.springframework.test.annotation.Rollback;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.testng.AbstractTransactionalTestNGSpringContextTests;

import com.bettersoft.api.unittest.dao.implement.BettersoftApiTestNGDao;
import com.bettersoft.api.unittest.dao.interfaces.IBettersoftApiTestNGDao;
import com.bettersoft.api.utils.BigDecimalAdapter;
import com.bettersoft.api.utils.HibernateProxyTypeAdapter;
import com.bettersoft.api.utils.MapTypeAdapter;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = { "/spring4testng.xml" })
@Rollback
@Transactional
public class Bettersoft4TestNG extends
		AbstractTransactionalTestNGSpringContextTests {
	protected final Log logger = LogFactory.getLog(getClass());
	protected IBettersoftApiTestNGDao bettersoftTestDao;
	protected Gson gson = new GsonBuilder().serializeNulls()
			.registerTypeAdapterFactory(HibernateProxyTypeAdapter.FACTORY)
			.registerTypeAdapter(Map.class, new MapTypeAdapter())
			.registerTypeAdapter(BigDecimal.class, new BigDecimalAdapter())
			.setDateFormat("yyyy-MM-dd HH:mm:ss").create();

	public Bettersoft4TestNG() {
		try {
			bettersoftTestDao = new BettersoftApiTestNGDao();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	@SuppressWarnings("rawtypes")
	protected Map json2Map(String json) {
		return gson.fromJson(json, HashMap.class);
	}
}
