package com.bettersoft.api.unittest.utils;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import org.apache.commons.io.FileUtils;

public final class ResourceUtils {

	public static InputStream getResourceAsStream(String file) {
		file = file.trim();
		boolean isStratWithClassPath = file.startsWith("classpath:");
		boolean isStartWithSlash = file.startsWith("/");

		if (isStratWithClassPath) {
			file = file.substring(10);
			return ResourceUtils.class.getClassLoader().getResourceAsStream(
					file);
		} else if (isStartWithSlash) {
			file = file.substring(1);
			return ResourceUtils.class.getClassLoader().getResourceAsStream(
					file);
		} else {
			try {
				return FileUtils.openInputStream(new File(file));
			} catch (IOException e) {
				throw new ResourceException(e);
			}
		}
	}

	public static URL getResource(String file) {
		file = file.trim();
		boolean isStratWithClassPath = file.startsWith("classpath:");
		boolean isStartWithSlash = file.startsWith("/");

		if (isStratWithClassPath) {
			file = file.substring(10);
			return ResourceUtils.class.getClassLoader().getResource(file);
		} else if (isStartWithSlash) {
			file = file.substring(1);
			return ResourceUtils.class.getClassLoader().getResource(file);
		} else {
			return ResourceUtils.class.getResource(file);
		}
	}
}
